# Commodore 64 Programming on Windows
TL;TR

This repo contains the source from my Commodore 64 assembly programming tutorial for Windows.

![alt text][logo]
### Introduction
Welcome to the Commodore 64 Programming on Windows tutorial! This tutorial will get you up and running with the tools needed to build C64 programs on windows, and teach you(tm) the basics of 6502 microprocessor programming using assembly. I will show you how to create graphics and how to render them on the screen, how to play music, and the many limitations and considerations needed to develop a proper C64 program. Remember, this is an old machine so you might have to think about things you normally didn't - if you are a graphics developer (DirectX, OpenGL, Unity, Unreal, ...), you might be able to learn why some things are they way they are.

Disclaimer: I'm no expert, use the informations here as you like.

Language: Assembly

Compiler: DASM

OS: Windows (I have tried all this on Windows 10 and Windows. Also Mac OSX users can follow the material as well by downloading DASM via [homebrew](https://brew.sh) and running `brew install dasm`

[1 - Setup and your first program!][1]

[2 - 6502 Microprocessor Programming Basics][2]

[3 - Arithmetic's on the C64][3]

[4 - Creating and Rendering Sprites][4]

[5 - Clearing the screen][5]

[6 - Raster Lines][6]

[7 - Creating and Rendering Bitmaps][7]

[8 - Text and Custom Charsets][8]

[9 - Interrupts and Music][9]

[10 - Multiple Interrupts][10]

[logo]: https://raw.githubusercontent.com/petriw/Commodore64Programming/master/image_thumb.png "Logo Tutorial Series"
[1]: https://digitalerr0r.wordpress.com/2011/03/19/commodore-64-programming-a-quick-start-guide-to-c-64-assembly-programming-on-windows/
[2]: https://digitalerr0r.wordpress.com/2011/03/21/commodore-64-programming-intro-to-6502-microprocessor-programming/
[3]: https://digitalerr0r.wordpress.com/2011/03/21/commodore-64-programming-3-6502-arithmetics/
[4]: https://digitalerr0r.wordpress.com/2011/03/31/commodore-64-programming-4-rendering-sprites/
[5]: https://digitalerr0r.wordpress.com/2011/04/28/commodore-64-programming-5-clearing-the-screen/
[6]: https://digitalerr0r.wordpress.com/2011/04/30/commodore-64-programming-6-raster-interrupts/
[7]: https://digitalerr0r.wordpress.com/2011/04/30/commodore-64-programming-7-creating-and-rendering-bitmaps/
[8]: https://digitalerr0r.wordpress.com/2011/05/01/commodore-64-programming-8-text-and-custom-charsets/
[9]: https://digitalerr0r.wordpress.com/2011/05/01/commodore-64-programming-9-interrupts-and-music/
[10]: https://digitalerr0r.wordpress.com/2011/05/02/commodore-64-programming-10-multiple-interrupts/
