//*** Variablen
.var SCREENRAM       = $0400         //Start des Bildschirmspeichers
.var CHAR            = $45          //Pik-Zeichen für die Ausgabe
.var COLORRAM        = $d800         //Start des Farb-RAMs
.var COLORNO         = $00           //Schwarz ($00) als Zeichenfarbe
.var SCREENZEROADR   = $fb           //Zero-Page Adr. für BS-Speicher Adr.
.var COLORZEROADR    = $fd           //Zero-Page Adr. für Farb-RAM Adresse
 
//*** Startadresse BASIC-Zeile
*=$0801
 .byte $0c,$08,$e2,$07,$9e,$20,$32,$30,$36,$32,$00,$00,$00
 
//*** Start des Assemblerprogrammes
startadr:
//*** Bildschirmspeicher in die Zero-Page
 lda #<SCREENRAM
 sta SCREENZEROADR
 lda #>(SCREENRAM+$0300)        //auf der letzten Seite beginnen 
 sta SCREENZEROADR+1
//*** Farb-RAM in die Zero-Page
 lda #<COLORRAM 
 sta COLORZEROADR    
 lda #>(COLORRAM+$0300)
 sta COLORZEROADR+1
 ldx #$02                      //Page-Anzahl
 
pageloop:
 ldy #$ff                       //Schleifenanzahl
loop:
 lda #CHAR                      //Zeichen in den Akku laden
 sta (SCREENZEROADR),y          //Akku auf dem BS ausgeben 
 lda #COLORNO                   //Farbe in den Akku laden
 sta (COLORZEROADR),y           //Akku ins Farb-RAM schreiben
 dey
 bne loop
//*** MSB für SCREENRAM & COLORRAM um 1 verringern
 dec SCREENZEROADR+1
 dec COLORZEROADR+1
 
//*** wenn es noch eine gibt, dann die nächste Page abarbeiten
 dex
 bne pageloop      
 
 rts