// ****************************************
// GAME TEMPLATE
// IN KICK ASSEMBLER
// EXPERIMENTAL ARCHEOLOGY
// CONFOEDERATIO LUDENS
// 
// ****************************************
// GAMEDESIGN NEEEDS
// SIMPLE FUNCTIONS:
// - IF THEN, LOOP, INC, DEC
// - INPUT
// - OUTPUT
// (- SPRITES/SCROLLING/COLLISION) OR DO IT YOURSELF

/*
    TOO BIG CONSOLE WITH A TOO SMALL HEART    
    DATAMANAGEMENT HORROR!
*/


// TODO: DRAW BITMAP
// https://www.youtube.com/watch?v=AGR2-tAYXFw


// COMPILING (FOR FASTER DEV)
.var loadPicture = true // > by hand ! search for loadPicture
.var loadMusic = true

// CONTROL 1-10 as joystick input1Ω

// PROCESSOR: 6502 :-( (Why not the original 680x? yes to expensive!)
// VIC-II: Graphic chip
// SID: Programmable sound chip

// EMULATION: VICE-USAGE
// - drag&drop
// - F10
// - cursors (0-10)

// KICK ASSEMLBER
// ASSEMBLER WITH SCRIPTING FUNCTIONS
// http://www.theweb.dk/KickAssembler/webhelp/content/ch12s03.html

// EXAMPLES
// https://codebase64.org/doku.php?do=search&id=base%3Areading_the_keyboard&q=print


/*

    # ASSEMBLER-HINTS

    160x200 in multicolor 

    only 8bit ... > problems with sprite x etc .-(

    command             : local
    command xyz         : command memory
    command xyz,index   : command memory+index

    inc
    dec 


    txa - transfer x to a
    tya - transfer a to x

    clc - clear add on state bits ! (for ror,rol,etc)

    clc
    adc #$13 - add (reset flag before)
    
    // value ohne # !!!!
    // > %10001
    // > 10
    // > 00

    // sub 10
    sec 
    sbc #10


    // stack
    pha (PusH Accumulator)        
    // do something 
    pla (PuLl Accumulator)          

    / indexing
    sta xyz,4 // store in acummlator-adresse xyz[4]
    lda xyz,5 // load into accumulator xyz[4]

    clc
    cmp #20,x
    bne bxt // not ...

    bne : not equal
    beq : equal
    blt : lower than (flags!)
    bcc : less
    bcs : higher or same

    bit (compare)

    
bxt:

    ror - '*2'
    rol - '/2'

    http://www.6502.org/tutorials/6502opcodes.html#ROR

*/

/*

    THE ARCHITECTURE OF C64

    VIDEORAM:

        vicbank(%00000011)  defines where the VIDEORAM IS!
        [VIDEORAM (IS SOMEHOW ORGANISED IN 8x8 BLOCKS .-( ))]
        [VIDEORAM]+1016 > POINTERS TO ! THE SPRITES! [SPRITE0][SPRITE1]...

        [POSITIONS ABSOLUTE!]

    // DESIGNDECISIONS?

*/

//VIDEO RAMS ADDRESSES
// POSSIBLE: $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff
// https://www.c64-wiki.com/wiki/Screen_RAM
// $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff etc
// ... 
// vicbank(%00000011);
// vicbank(%00000010); // bank1
/*
    lda $dd00
    and #%11111100
    ora #pattern
    sta $dd00 // store there

 */ 

// MODES:
// - CURSOR MODE - ASCII 
//   - start AT $4000 (SCREENRAM)

// - GRAPHIC MODE - ALSO BLOCKS (COLORRAM)
//   - STARTS AT $D800

/*
    8x4 > next 8x4 > next 8x4
    [ ] > [ ] > [ ]


*/

// - HIGHRES: 320x200 
// - LOWRES: 160x200 - MULTICOLOR 

// GRAPHICS PAINT
// https://mcdraw.xyz

// CONVERT PICS TO C64 COLOR PALETTE
// https://www.micheldebree.nl/retropixels/

// SPRITE PAINT (Multicolor)
// multicolor: https://beta.spritemate.com
// you can use http://spritemate.com/ to edit these
// just press file->save file->kick ass(hex) once you designed your sprite


// HELPERS
// DEC TO HEX
// https://www.rapidtables.com/convert/number/decimal-to-hex.html?x=214


// DEMO EXAMPLE
// https://github.com/celso/c64/blob/master/card.asm (including sprite management etc)
// GOOD FOR STARTING (this is a mix from this and other tutorials)

// RANDOM
// rndGen(%1111);
// sta $d027,x  // into x 



// MUSIC

// playing SID music has 3 parts:
// 0. load music
// 1. you use use Kick Assembler's LoadSid to import the .sid file
// 2. you call music.init
// 3. you call music.play in every raster interrupt
// see http://www.theweb.dk/KickAssembler/webhelp/content/ch12s03.html and the README.md

// ----------------------
// MINIMAL VARS/CONST
// ----------------------

.var  BORDER_COLOR   = $D020
.var  BACKGROUND_COLOR    = $D021
.var  FOREGROUND_COLOR = $E536

.var  SPRITE_0_X_POSITION = $D000 // only for ascii screen !!!! 
.var  SPRITE_0_Y_POSITION = $D001
.var  SPRITE_0_POINTER    = $0400 + $03F8 // Last 8 Bytes of Screen RAM
.var  SPRITE_0_DATA       = $0340         // Block 13, 13*64=>832 => $0340
.var SPRITE_UPPER_X      = $D010
.var  SPRITE_0_COLOR      = $D027 

// VRAM (different places - definable)
// SPRITES: VRAM START AND $3F8

 .var SCNKEY     = $ff9f   // scan keyboard - kernal routine
 .var GETIN      = $ffe4   // read keyboard buffer - kernal routine

            // ----------------------
            // MAX VARIABLES
            // ----------------------


            // *******************************************************************************
            // *** Farben                                                                  ***
            // *******************************************************************************
            .var COLOR_BLACK         = $00           // schwarz
            .var COLOR_WHITE         = $01           // weiß
            .var COLOR_RED           = $02           // rot
            .var COLOR_CYAN          = $03           // türkis
            .var COLOR_PURPLE        = $04           // lila
            .var COLOR_GREEN         = $05           // grün
            .var COLOR_BLUE          = $06           // blau
            .var COLOR_YELLOW        = $07           // gelb
            .var COLOR_ORANGE        = $08           // orange
            .var COLOR_BROWN         = $09            // braun
            .var COLOR_PINK          = $0a           // rosa
            .var COLOR_DARKGREY      = $0b           // dunkelgrau
            .var COLOR_GREY          = $0c           // grau
            .var COLOR_LIGHTGREEN    = $0d           // hellgrün
            .var COLOR_LIGHTBLUE     = $0e           // hellblau
            .var COLOR_LIGHTGREY     = $0f           // hellgrau

            // zone Sprites
            // *******************************************************************************
            // *** Die VIC II Sprite Register  -  ANFANG                                   ***
            // *******************************************************************************
            // THESE ARE ABSOLUT REGISTERS > NOT THE DATA! 
            .var SPRITE_BASE         = $d000
            .var SPRITE0X            = $d000         // (00) X-Position von Sprite 0
            .var SPRITE0Y            = $d001         // (01) Y-Position von Sprite 0
            .var SPRITE1X            = $d002         // (02) X-Position von Sprite 1
            .var SPRITE1Y            = $d003         // (03) Y-Position von Sprite 1
            .var SPRITE2X            = $d004         // (04) X-Position von Sprite 2
            .var SPRITE2Y            = $d005         // (05) Y-Position von Sprite 2
            .var SPRITE3X            = $d006         // (06) X-Position von Sprite 3
            .var SPRITE3Y            = $d007         // (07) Y-Position von Sprite 3
            .var SPRITE4X            = $d008         // (08) X-Position von Sprite 4
            .var SPRITE4Y            = $d009         // (09) Y-Position von Sprite 4
            .var SPRITE5X            = $d00a         // (10) X-Position von Sprite 5
            .var SPRITE5Y            = $d00b         // (11) Y-Position von Sprite 5
            .var SPRITE6X            = $d00c         // (12) X-Position von Sprite 6
            .var SPRITE6Y            = $d00d         // (13) Y-Position von Sprite 6
            .var SPRITE7X            = $d00e         // (14) X-Position von Sprite 7
            .var SPRITE7Y            = $d00f         // (15) Y-Position von Sprite 7
            .var SPRITESMAXX         = $d010         // (16) Höhstes BIT der jeweiligen X-Position
                                                //         da der BS 320 Punkte breit ist reicht
                                                //         ein BYTE für die X-Position nicht aus// 
                                                //         Daher wird hier das 9. Bit der X-Pos
                                                //         gespeichert. BIT-Nr. (0-7) = Sprite-Nr.
            .var SPRITEACTIVE        = $d015         // (21) Bestimmt welche Sprites sichtbar sind
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDOUBLEHEIGHT  = $d017         // (23) Doppelte Höhe der Sprites
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDEEP          = $d01B         // (27) Legt fest ob ein Sprite vor oder hinter
                                                //         dem Hintergrund erscheinen soll.
                                                //         Bit = 1: Hintergrund vor dem Sprite
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEMULTICOLOR    = $d01c         // (28) Bit = 1: MultiColor Sprite 
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDOUBLEWIDTH   = $d01d         // (29) Bit = 1: Doppelte Breite des Sprites
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEMULTICOLOR0   = $d025         // (37) Spritefarbe 0 im Multicolormodus
            .var SPRITEMULTICOLOR1   = $d026         // (38) Spritefarbe 1 im Multicolormodus
            .var SPRITE0COLOR        = $d027         // (39) Farbe von Sprite 0
            .var SPRITE1COLOR        = $d028         // (40) Farbe von Sprite 1
            .var SPRITE2COLOR        = $d029         // (41) Farbe von Sprite 2
            .var SPRITE3COLOR        = $d02a         // (42) Farbe von Sprite 3
            .var SPRITE4COLOR        = $d02b         // (43) Farbe von Sprite 4
            .var SPRITE5COLOR        = $d02c         // (44) Farbe von Sprite 5
            .var SPRITE6COLOR        = $d02d         // (45) Farbe von Sprite 6
            .var SPRITE7COLOR        = $d02e         // (46) Farbe von Sprite 7

            .var SPRITE0DATA         = $07f8         // Sprite-Pointer für die Sprite-0-Daten
            // *******************************************************************************
            // *** Die VIC II Sprite Register  -  ENDE                                     ***
            // *******************************************************************************

            // zone VIC
            .var VICBASE             = $d000         // (RG) = Register-Nr. dezimal
            .var VICRASTERROWPOS     = $d012         // (18) Aktuelle Rasterzeile lesen oder setzen
            .var VICBORDERCOLOR      = $d020         // (32) Bildschirmrandfarbe
            .var VICBACKGROUNDCOLOR  = $d021         // (33) Hintergrundfarbe

            // zone CIA
            .var CIA1_A              = $dc00         // Adresse des CIA1-A
            .var CIA1_B              = $dc01         // Adresse des CIA1-B
            .var CIA1_CLOCK_TENTH    = $dc08         // Adresse zehntel Sekunden (Uhrzeit) im CIA1
            .var CIA1_CLOCK_SECONDS  = $dc09         // Adresse Sekunden (Uhrzeit) im CIA1

            // zone SID
            // *******************************************************************************
            // *** Die SID Register  -  ANFANG                                             ***
            // *******************************************************************************
            .var SID_BASE            = $d400         // (Nr) Basisadresse des SID_BASE
            .var SID_VOICE1_FREQ_MSB = $d401         // (01) 1. Stimme: High-Byte der Frequenz
            .var SID_VOICE1_WAVEFORM = $d404         // (04) 1. Stimme: Wellenform
            .var SID_SUSTAIN_RELEASE = $d406         // (06) BIT 7-4: Anschlag (sustain)
                                                //          3-0: Abschwellen (release)
            .var SID_VOLUME          = $d418         // (24) BIT   7: 3. Stimme Filtermodus AUS
                                                //            6:   -''-    Hochpass
                                                //            5:   -''-    Bandpass
                                                //            4:   -''-    Tiefpass
                                                //          3-0: Lautstärke

            .var SID_WAVE_TRIANGLE   = $11           // Wellenform: Dreieck
            .var SID_WAVE_SAWTOOTH   = $21           // Wellenform: Sägezahn
            .var SID_WAVE_PULSE      = $41           // Wellenform: Rechteck
            .var SID_WAVE_WHITENOISE = $81           // Wellenform: Rauschen
            // *******************************************************************************
            // *** Die SID Register  -  ENDE                                               ***
            // *******************************************************************************

            // zone Zeropage
            .var ZP_SCREENRAMADR     = $02           // Zeichen-Quelle fürs BS-Kopieren (drawscreen:)
            .var ZP_COLORRAMADR      = $04           // Farb-Quelle fürs BS-Kopieren    (drawscreen:)
            .var ZP_SCREENTODRAW     = $06           // Zeichen-Ziel fürs BS-Kopieren   (drawscreen:)
            .var ZP_COLORTODRAW      = $08           // Farb-Ziel fürs BS-Kopieren      (drawscreen:)
            .var ZP_LOOPHELPER       = $f8           // Die letzten 8 BYTES für Schleifen reservieren

            // zone Kernal
            .var JT_GETIN            = $ffe4         // Kernalfunktion: Zeichen lesen

            // zone Generic
            .var SCREENRAMADR        = $0400         // Beginn des Bildschirmspeichers
            .var COLORRAMADR         = $d800         // Beginn des Farbspeichers
            .var INPUT_NONE          = $00           // Es wurde noch kein Port gewählt
            .var INPUT_JOY1          = $01           // Joystick in Port-1
            .var INPUT_JOY2          = $02           // oder 2
            .var JOY_UP              = %00000001     // Joystick rauf
            .var JOY_DOWN            = %00000010     // Joystick runter
            .var JOY_LEFT            = %00000100     // Joystick links
            .var JOY_RIGHT           = %00001000     // Joystick rechts
            .var JOY_FIRE            = %00010000     // Joystick FEUER// 



// --------------------------------------------
// LOAD DATA
// --------------------------------------------

// Music (<3k!)
// Attention: Reload Emulators to test other music!!

.var music = LoadSid("music7.sid") 

// Graphics
// https://mcdraw.xyz
//.if (loadPicture) {
  
  
    // .var picture = LoadBinary("image.koa", BF_KOALA)
    // .var picture = LoadBinary("minimalpicture.kla", BF_KOALA) // less loading
    .var picture = LoadBinary("image.kla", BF_KOALA)
    .var picturemen = LoadBinary("squarez_menu.kla", BF_KOALA)
//}

// --------------------------------------------------
// INIT
// --------------------------------------------------

// *=$0801 "Basic Program"
BasicUpstart2(start)


 // the address $0001 holds and sets the 6510 CPU's on-chip port register
    // %x10: RAM visible at $A000-$BFFF; KERNAL ROM visible at $E000-$FFFF
    // what we're saying here is we don't need the BASIC ROM after we start
    // see https://www.c64-wiki.com/wiki/Zeropage
    lda #%00110110
    sta $0001

// --------------------------------------------------
// INIT 
// --------------------------------------------------

start:

    // MULTIMEDIA

    // music: init 1
    .if (loadMusic) { 
        lda #music.startSong-1 // set up the music
        jsr music.init
    }

    // setup: raster music
    sei

        .if (loadMusic) { 
          lda #<irq1
          sta $0314
          lda #>irq1
          sta $0315
          lda #$1b
          sta $d011
          lda #$80
          sta $d012
          lda #$7f
          sta $dc0d
          sta $dd0d
          lda #$81
          sta $d01a
          lda $dc0d
          lda $dd0d
          asl $d019
        }

      cli


    // CLEAR SCREEN
    jsr clear_screen

     // disable input buffers     
     jsr disable_inputbuffers



// ------------------------------------
// asciiloop (SHOWS 'ASCII' MODE)
// ------------------------------------
// of course: it is no ascii!!!!
// different format like zx81 etc
 
jmp noascii // disable 'ASCII'    

    // background, frame color
      lda #$04     
      sta BORDER_COLOR      
      lda #$07
      sta BACKGROUND_COLOR  
      // set FOREGROUND_COLOR (COLOR CAN BE DIFFERENT IN EACH LINE!)
      lda #$09
      sta FOREGROUND_COLOR


      // ----------------
      // ASCII / PRINT
      // ----------------
/*      
      // charset: https://www.c64-wiki.de/wiki/Zeichen

      // print - show a character
      lda #$d6                //  load character '_' into register A
      jsr $ffd2               //  print character to screen
      // print at // ... 
      // https://medium.com/@RetroAsmDev/c-64-part-4-ascii-art-a4319784d26
      
  

        
        // WRITE INTO SCREEN MEMORY

        // ASCII: 40x25 > 1000bytes > $0400-$07F7
        // - example: https://dustlayer.com/c64-coding-tutorials/2013/4/8/episode-2-2-writing-to-the-c64-screen
        
        // FILL ALL WITH CHARS

        // all the same
        ldx #$00
        ldy #$00
clear:    
         lda #$40    // #$20 is the spacebar Screen Code
         sta $0400,x  // fill four areas with 256 spacebar characters
         sta $0500,x 
         sta $0600,x 
         sta $06e8,x 
         lda #$04     // set foreground to black in Color Ram 
         sta $d800,x  
         sta $d900,x
         sta $da00,x
         sta $dae8,x
         inx           // increment X
         bne clear    


        // write direct in the screen
        ldx #$ff
    directscreen:  
        lda #$04 
        sta $0400,x
        dex
        bne directscreen
        
        // just print one char somewhere
        lda #$d8
        ldx #$20
        sta $0400,x


asciiloop: 
        jsr vsync // wait for 'vsync'

        jsr SCNKEY
        jsr GETIN

        // SPACE TO FINISH
        cmp #$20
        bne noinfokey
            // lda #05     
            // sta BORDER_COLOR      
            // sta BACKGROUND_COLOR  
            
            lda #$d6                //  load character '_' into register A
            jsr $ffd2               //  print character to screen
              
            jmp noascii
noinfokey:

        // PRINTING 
        // https://dustlayer.com/c64-coding-tutorials/2013/4/8/episode-2-4-reading-from-a-data-table

        ldx #$00
        ldy #$00

        ldy counter
        inc counter

        lda #$00        
clearcolhere:    
         lda #$42     // #$20 is the spacebar Screen Code
         sta $0400,x  // fill four areas with 256 spacebar characters
         sta $0500,x 
         sta $0600,x 
         sta $06e8,x 
         // lda #$08     // set foreground to black in Color Ram 
         iny
         tya
         sta $d800,x  
         iny
         tya
         sta $d900,x
         iny
         tya
         sta $da00,x
         // iny
         // tya
         sta $dae8,x
         inx           // increment X
         bne clearcolhere   

        // ------------------
        // blink  
        // ------------------
    
        inc BACKGROUND_COLOR
        inc BORDER_COLOR
        inc FOREGROUND_COLOR
        
        jmp asciiloop

*/

noascii:
        

        jsr blink


      // ----------------
      // GRAPHIC MODE
      // ----------------

        jsr blink

// vicbank(%00000011);
        vicbank(%00000010); // bank1



        // -----------------------------
          // IMAGE COPY
          // -----------------------------

             // copy picture 
                lda #$38
                sta $d018
                lda #$d8
                sta $d016
                lda #$3b
                sta $d011
                lda #0
                sta $d020
                lda #picture.getBackgroundColor()
                sta $d021
                ldx #0
        copycat:
                .for (var i=0; i<4; i++) {
                   lda colorRam+i*$100,x
                   sta $d800+i*$100,x
                }
                inx
                bne copycat
 

 // -----------------------------
  // OBJECTS
  // -----------------------------

    .const objects_count = 14

    .const objects_sprite = 8 // 0-x are sprites rest something else triggers

    // object struct 

    .const object_length = $0b // length 

    .const object_x = 0
    .const object_y = 2
    .const object_w = 4
    .const object_h = 5

    .const object_type = 6  // 0 nothing 1 sprite 2 block 3 trigger

        .const ot_nothing = 0
        .const ot_sprite = 1
        .const ot_block = 2
        .const ot_trigger = 3

        // ot_enemy
        // ot_friend
        // ot_???

    .const object_state = 7

        .const os_active = 0 // active
        .const os_dead = 5 // inactive

    .const object_statesub = 8
    .const object_arg = 9
    .const object_behavior = 10
    .const object_spr = 11
    .const object_anim = 12

 // -----------------------------
  // SPRITE SETUP
  // -----------------------------
 
    // ALL SINGLE COLOR
    lda #%00000000
    // lda #%11111111
    sta $d01c // all sprites are of type 'single color'
    // card: $D015/53269  acts like a "switch" that turns one of the eight sprites "on" or "off"
    // swith all on 
    lda #%11111111
    sta $d015 // all eight sprites on (all bits set)

    // cards: the location of the sprite pointers (see sprites.asm) follows that of the text screen plus 1016/$3F8
     // this will iterate the 8 sprite pointers, load their values (see sprites.asm) and set screen addresses with them
    // see https://www.c64-wiki.com/wiki/Sprite#Sprite_pointers


      jsr blink




// --------------------------------------------------
// MENU-LOOP
// --------------------------------------------------

jmp nomenu

    // vicbank(%00000011); // bank0
    vicbank(%00000010); // bank1 - MENU

    lda #00   
    sta BORDER_COLOR      
    sta BACKGROUND_COLOR  

    lda 0
    sta mcounter

menu_loop:

    jsr vsync   

    // mcounter
    inc mcounter
    lda mcounter
    clc
    cmp #50
    bne mnext
    lda #0
    sta mcounter
    inc BACKGROUND_COLOR
    inc BORDER_COLOR
mnext:

    // space
    jsr SCNKEY
    jsr GETIN
          
    // SPACE TO FINISH
    cmp #$20
    bne menu_nokey
    jmp nomenu
menu_nokey:     


    jmp menu_loop

nomenu:


// --------------------------------------------------
// GAME-LOOP 
// --------------------------------------------------


    // set background
    lda #00   
    sta BORDER_COLOR      
    sta BACKGROUND_COLOR  


// ---------------------------
// GAMELOOP: SPRITE RESET 
// ---------------------------
// spritespixel def: pointer VRAM+1016!
// reset all/them all 



    // $D01C/53276 sprites can be high resolution or multicolor mode - bits at 0 sets them to high res
    // see https://www.c64-wiki.com/wiki/Sprite
    lda #%00000000 // single color
    lda #%11111111 // multi color
     sta $d01c // all sprites are of type 'single color'

    // $D015/53269  acts like a "switch" that turns one of the eight sprites "on" or "off"
    // see https://www.c64-wiki.com/wiki/Sprite
    lda #%11111111
    sta $d015 // all eight sprites on (all bits set)

    // FIND WHERE THEY POINT
        ldx #$8
    !loop:
        lda spritePtrs,x
        sta $0c00 + 1016,x
        dex
        bpl !loop-

    // --------------------------
    // STRANGE COLOR SYSTEM
    // --------------------------
    // sprite colors ...

    lda #$0a // sprite multicolor 1
    sta $D025
    lda #$08 // sprite multicolor 2
    sta $D026


    lda #$01 // sprite multicolor 2
    sta SPRITE0COLOR

    lda #$07 // sprite multicolor 2
    sta SPRITE1COLOR
    sta SPRITE2COLOR
    sta SPRITE3COLOR
 
    lda #$02 // sprite multicolor 2
    sta SPRITE4COLOR
    sta SPRITE5COLOR
    sta SPRITE6COLOR
    sta SPRITE7COLOR


   // --------------------------
    // SPRITES
    // --------------------------
 
    // --------------------
    // setup
    // --------------------

setup_menu:
 
       ldy #$0 // sprite nr ... 
       ldx #$0 // sprite counter 0,11,22,33,44 etc ...   
       lda 0  
       sta temp // x pos ... 
ssetting:

        // positions
        lda temp
        // rndGen(%1111111)
        sta objects+object_x,x
        lda #$80
        // rndGen(%1111111)
        sta objects+object_y,x

        // line
        lda temp
        clc
        adc #$18
        sta temp
        
        // object_behavior


        // 1+
        cpy #$01
        bcc biggerthan1
            rndGen(%111)
            sta objects+object_behavior,x
            ora 1
biggerthan1:


        // add indices 
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
        iny
        cpy #objects_count
        bne ssetting

        // --------------------
        // direct settings
        // --------------------
        // avatar
        .var sprnr=0
        lda #$a0
        sta objects+(sprnr*object_length)+object_x
        sta objects+(sprnr*object_length)+object_y

/*        
        .eval sprnr=1
        lda #$01
        sta objects+(sprnr*object_length)+object_behavior
        
        .eval sprnr=2
        lda #$02
        sta objects+(sprnr*object_length)+object_behavior
        
        .eval sprnr=3
        lda #$03
        sta objects+(sprnr*object_length)+object_behavior

        .eval sprnr=4
        lda #$04
        sta objects+(sprnr*object_length)+object_behavior

        .eval sprnr=5
        rndGen(%11)
        sta objects+(sprnr*object_length)+object_behavior
        ora 1
    
*/

// MAIN_LOOP ------------------------

main_loop:
  

 

    // SET 
    vicbank(%00000011); // bank0
    // vicbank(%00000010); // bank1 - MENU

    // inc BORDER_COLOR

  // -----------------------------
  // SPRITE HANDLES
  // -----------------------------

  // --------------------
  // handle sprite
  // --------------------

       ldy #0 // sprite counter 012345
       ldx #$0 // object in memory 0,11,22,33...  
       lda 0  
       sta temp
supdate:
        // inc objects+object_x,x

        lda objects+object_behavior,x
        clc
        cmp #$01
        bne up_right
        inc objects+object_x,x
up_right:        

        cmp #$02
        bne up_left
        dec objects+object_x,x
up_left:        

        cmp #$03
        bne up_up
        inc objects+object_y,x
up_up:        

        cmp #$04
        bne up_down
        dec objects+object_y,x
up_down:        

       
        // + 11
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
 
        iny
        clc
        cpy #objects_count
        bne supdate

   // --------------------
   // collision
   // --------------------
   //  box collision
   //  collision 0-15
   //   |_ collisionwidth 0-15 !!!
   // 

       ldx #$0 // objectx : object in memory 0,11,22,33...  
 
       lda #0
       sta counterx
collision: 
        // inc objects+object_x,x


        // collide with ---------------

            // collide with
            // collisiony
            ldy #$0
            lda #0 
            sta countery

collision_width: 

            // identical? 
            clc
            lda counterx
            cmp countery
            bne nocollision_width
            
            // check now x left
            clc
            lda objects+object_x,x
            cmp objects+object_x,y
            bcc around


            // check now x right
            clc
            lda objects+object_x,x
            adc #40
            cmp objects+object_x,y
            bcs around

            // check now y up
            clc
            lda objects+object_y,x
            cmp objects+object_y,y
            bcc around

            // check now y down
            clc
            lda objects+object_y,x
            adc #40
            cmp objects+object_y,y
            bcs around

            // collision detected 
            dec  objects+object_x,x
            dec  objects+object_y,x


            inc BORDER_COLOR                    

around:

            // + 11
            pha 
                tya 
                clc
                adc #object_length // #$0b 
                tay
            pla
     
            inc countery
            lda countery
            clc
            cmp #objects_count
            bne collision_width

nocollision_width:

         // /collide with ---------------

       
        // + 11
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
 
        inc counterx
        lda counterx
        clc
        cmp #objects_count
        bne collision
     

   // --------------------
   // render sprites 
   // --------------------
       ldx #$0 // object counter 0,11,22    
       ldy #$0 // sprite counter 0 - 16       
srender:

        // positions
        lda objects+object_x,x
        sta SPRITE_BASE,y
        
        lda objects+object_y,x
        sta SPRITE_BASE+1,y 

       // add 10
       pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
        // iny ... +2 
        iny
        iny

        cpy #(objects_sprite*2)
        bne srender



/*
   // move ... 
   ldx #$0 // sprite counter in 
   lda rcounter
   lda #$40
spritehandle:
    // X ----------------   
    lda SPRITE_BASE,x
        clc
        adc #$01
        sta rcounter
    sta SPRITE_BASE,x // X ----------
    
    // Y --------------   
    lda SPRITE_BASE,x
        inx // index + 1
        lda #$C0
    // sta SPRITE_BASE,x // Y ------------
    
    // NEXT --------------
    inx 
    cpx #16
    bne spritehandle
*/


  // -----------------------------
  // KEYS INPUT
  // -----------------------------
  // https://codebase64.org/doku.php?id=base:scanning_the_keyboard_the_correct_and_non_kernal_way
  // only 2 keys at once .-( 

           // get keys
           jsr SCNKEY
           jsr GETIN

           // check matrix !2
              
            // A
            clc
            cmp #65
            bne no_a
            dec objects+object_x
no_a:  
            // D
            clc
            cmp #68
            bne no_d
            inc objects+object_x
no_d:  




            // SPACE TO FINISH
            clc
            cmp #$20
            bne nokey

            // jmp exit
            lda #05     
            sta BORDER_COLOR      
            sta BACKGROUND_COLOR  

            rts  // exit ... 
nokey:  




            // ------------------
            // joystick  
            // ------------------
            // joystick : https://retro-programming.com/how-to-program-joystick-input-handling-on-a-c64/

            clc
            lda #JOY_RIGHT                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notright   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                inc objects+object_x
                inc objects+object_x
joystick_notright:

            clc
            lda #JOY_LEFT             // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notleft   // if not active (==1), go to .input_up_check
                lda #$33
                // jsr $ffd2   // print screen ... 
                dec objects+object_x
                dec objects+object_x
           
joystick_notleft:

            clc
            lda #JOY_UP                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notup   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                dec objects+object_y
                dec objects+object_y
joystick_notup:

            clc
            lda #JOY_DOWN                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notdown   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                inc objects+object_y
                inc objects+object_y
joystick_notdown:



            // wait for vsync
            jsr vsync // wait for 'vsync'

            // restart
            jmp main_loop      // loopy loop
exit: 
            jsr clear_screen
            rts

            // back to BASIC


// --------------------------------------------------
// SUBROUTINES 
// --------------------------------------------------
clear_screen:
    jsr $E544       
    rts

disable_inputbuffers:
    lda #1
    sta $0289  //  disable keyboard buffer
    lda #127
    sta $028a  // disable key repeat
    rts

vsync:
      lda #$FF    // load 255 into A
      cmp $D012    //look if current rasterline equals 255
      bne vsync     // if no, goto wait
      rts  

blink:
    inc BACKGROUND_COLOR
    inc BORDER_COLOR
    inc FOREGROUND_COLOR
    rts

.macro vicbank(pattern) {
    lda $dd00
    and #%11111100
    ora #pattern
    sta $dd00
}



// --------------------------------------------------
// INTERRUPTS 
// --------------------------------------------------
irq1:
    asl $d019
    

    // inc $d020 - act. volume 
    jsr music.play 
    // dec $d020
    pla
    tay
    pla
    tax
    pla
    rti

// --------------------------------------------------
// DATA LOADING 
// --------------------------------------------------

//.if (loadPicture) {

    // vicbank(%00000011); // bank0

    *=$0c00 "ScreenRam_1"; ;            .fill picture.getScreenRamSize(), picture.getScreenRam(i)
    *=$1c00; colorRam:  .fill picture.getColorRamSize(), picture.getColorRam(i)
    *=$2000;            .fill picture.getBitmapSize(), picture.getBitmap(i)

    // vicbank(%00000010); // bank1

    * = $4c00 "ScreenRam_2"; screenRam_2: .fill picturemen.getScreenRamSize(), picturemen.getScreenRam(i)
    * = $6000 "Bitmap_2"; bitMap_2: .fill picturemen.getBitmapSize(), picturemen.getBitmap(i)
    * = $7f40 "ColorRam_2:"; colorRam_2: .fill picturemen.getColorRamSize(), picturemen.getColorRam(i)


// }

.if (loadMusic) { 
    * = music.location "Music"
    .fill music.size, music.getData(i)
}


// VARIABLES
// counter
counter:
  .byte $00

    // --------------------------------------------------
    // VARS ... 
    // --------------------------------------------------

mcounter: .byte $00

rcounter: .byte $00

spritenr: .byte $00

temp: .byte $00

counterx: .byte $00
countery: .byte $00

    // --------------------------------------------------
    // OBJECTS ... 
    // --------------------------------------------------

/*

    // look for constants
    object_x
    object_y

    
*/

    objects: 
  
      // object 0-7
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 0
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 1
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 2
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 3
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 4
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 5
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 6
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 7

      // 8+
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 



// --------------------------------------------------
// MACROS 
// --------------------------------------------------
.macro rndGen(mask) {
    // see http://sta.c64.org/cbm64mem.html
    // first we read the current raster line (0-255)
    lda $d012
    // then we xor it with timer A (low byte)
    // see https://www.c64-wiki.com/wiki/CIA
    eor $dc04
    // then we subtract it with timer A (high byte)
    sbc $dc05
    // finally we mask it so we can have a number between 0 and bits^2
    and #mask
}

.function toSpritePtr(addr) {
   .return (addr&$3FFF)/64
}

// single color
spritePtrs:
.byte toSpritePtr(sprite_avatar), toSpritePtr(sprite_eat)
.byte toSpritePtr(sprite_eat), toSpritePtr(sprite_eat)
.byte toSpritePtr(sprite_enemy), toSpritePtr(sprite_enemy)
.byte toSpritePtr(sprite_enemy), toSpritePtr(sprite_enemy)

// you can use http://spritemate.com/ to edit these
// just press file->save file->kick ass(hex) once you designed your sprite


// be carefull with the address you chose for your sprites. two notes:
// 1. it needs to be divisible by 64 - see above - you can use the .align 64 if it helps
// 2. it needs to be in the same video block where you want to display them
//    the c64 has four video blocks $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff

// ! SINGLE COLORS SPRITES
// $b60
* = $b60-32 "Sprites"; // address $b60 means that this sprites can only be used with the screen on block $0000-$3fff

all_sprites:

.align 64
// memory for sprite patterns needs to be divisible by 64 - see above why


// sprite 0 / singlecolor / color: $01

sprite_avatar:
/*
.byte $00,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$7f,$0f,$fc,$7f,$0f,$fc,$7f
.byte $0f,$fc,$7f,$0f,$04,$7f,$ff,$04
.byte $7f,$ff,$04,$7f,$ff,$04,$47,$ff
.byte $04,$47,$ff,$04,$47,$ff,$fc,$47
.byte $07,$fc,$47,$07,$fc,$7f,$07,$fc
.byte $7f,$07,$fc,$7f,$07,$fc,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01
*/

.byte $00,$00,$00,$2a,$aa,$a8,$3f,$ff
.byte $f8,$3a,$aa,$b8,$ba,$aa,$b8,$ba
.byte $aa,$b8,$ba,$aa,$b8,$ba,$aa,$b8
.byte $ba,$aa,$b8,$ba,$aa,$b8,$ba,$aa
.byte $b8,$ba,$aa,$b8,$ba,$aa,$b8,$ba
.byte $aa,$b8,$ba,$aa,$b8,$ba,$aa,$b8
.byte $ba,$aa,$b8,$ba,$aa,$b8,$ba,$aa
.byte $b8,$bf,$ff,$e8,$aa,$aa,$a0,$81

sprite_eat:

/*
.byte $00,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01
*/

.byte $00,$00,$00,$00,$00,$00,$00,$00
.byte $00,$01,$6a,$80,$03,$ea,$80,$03
.byte $ea,$80,$01,$7e,$c0,$03,$ea,$80
.byte $01,$7e,$c0,$03,$ea,$80,$01,$7e
.byte $c0,$03,$ea,$80,$01,$7e,$c0,$03
.byte $ea,$80,$01,$7e,$c0,$03,$ea,$80
.byte $03,$ea,$80,$01,$69,$40,$00,$00
.byte $00,$00,$00,$00,$00,$00,$00,$81


sprite_enemy:

/*
.byte $00,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01
*/


.byte $09,$24,$24,$a9,$96,$94,$a9,$96
.byte $94,$2b,$be,$bd,$2b,$be,$be,$2b
.byte $be,$bc,$2b,$be,$bc,$2b,$be,$bc
.byte $ab,$be,$bd,$2b,$be,$be,$2b,$be
.byte $bc,$2b,$be,$bc,$ab,$be,$bd,$ab
.byte $be,$be,$2b,$be,$bc,$2b,$be,$bc
.byte $2b,$be,$bd,$ab,$be,$be,$aa,$aa
.byte $a8,$2a,$aa,$a8,$0a,$02,$08,$81

