
// ****************************************
// GAME
// ****************************************


// VICE-USAGE
// - drag&drop
// - F10
// - cursors (0-10)


// zone Farben
// *******************************************************************************
// *** Farben                                                                  ***
// *******************************************************************************
.var COLOR_BLACK         = $00           // schwarz
.var COLOR_WHITE         = $01           // weiß
.var COLOR_RED           = $02           // rot
.var COLOR_CYAN          = $03           // türkis
.var COLOR_PURPLE        = $04           // lila
.var COLOR_GREEN         = $05           // grün
.var COLOR_BLUE          = $06           // blau
.var COLOR_YELLOW        = $07           // gelb
.var COLOR_ORANGE        = $08           // orange
.var COLOR_BROWN         = $09            // braun
.var COLOR_PINK          = $0a           // rosa
.var COLOR_DARKGREY      = $0b           // dunkelgrau
.var COLOR_GREY          = $0c           // grau
.var COLOR_LIGHTGREEN    = $0d           // hellgrün
.var COLOR_LIGHTBLUE     = $0e           // hellblau
.var COLOR_LIGHTGREY     = $0f           // hellgrau

// zone Sprites
// *******************************************************************************
// *** Die VIC II Sprite Register  -  ANFANG                                   ***
// *******************************************************************************
.var SPRITE0X            = $d000         // (00) X-Position von Sprite 0
.var SPRITE0Y            = $d001         // (01) Y-Position von Sprite 0
.var SPRITE1X            = $d002         // (02) X-Position von Sprite 1
.var SPRITE1Y            = $d003         // (03) Y-Position von Sprite 1
.var SPRITE2X            = $d004         // (04) X-Position von Sprite 2
.var SPRITE2Y            = $d005         // (05) Y-Position von Sprite 2
.var SPRITE3X            = $d006         // (06) X-Position von Sprite 3
.var SPRITE3Y            = $d007         // (07) Y-Position von Sprite 3
.var SPRITE4X            = $d008         // (08) X-Position von Sprite 4
.var SPRITE4Y            = $d009         // (09) Y-Position von Sprite 4
.var SPRITE5X            = $d00a         // (10) X-Position von Sprite 5
.var SPRITE5Y            = $d00b         // (11) Y-Position von Sprite 5
.var SPRITE6X            = $d00c         // (12) X-Position von Sprite 6
.var SPRITE6Y            = $d00d         // (13) Y-Position von Sprite 6
.var SPRITE7X            = $d00e         // (14) X-Position von Sprite 7
.var SPRITE7Y            = $d00f         // (15) Y-Position von Sprite 7
.var SPRITESMAXX         = $d010         // (16) Höhstes BIT der jeweiligen X-Position
                                    //         da der BS 320 Punkte breit ist reicht
                                    //         ein BYTE für die X-Position nicht aus// 
                                    //         Daher wird hier das 9. Bit der X-Pos
                                    //         gespeichert. BIT-Nr. (0-7) = Sprite-Nr.
.var SPRITEACTIVE        = $d015         // (21) Bestimmt welche Sprites sichtbar sind
                                    //         Bit-Nr. = Sprite-Nr.
.var SPRITEDOUBLEHEIGHT  = $d017         // (23) Doppelte Höhe der Sprites
                                    //         Bit-Nr. = Sprite-Nr.
.var SPRITEDEEP          = $d01B         // (27) Legt fest ob ein Sprite vor oder hinter
                                    //         dem Hintergrund erscheinen soll.
                                    //         Bit = 1: Hintergrund vor dem Sprite
                                    //         Bit-Nr. = Sprite-Nr.
.var SPRITEMULTICOLOR    = $d01c         // (28) Bit = 1: MultiColor Sprite 
                                    //         Bit-Nr. = Sprite-Nr.
.var SPRITEDOUBLEWIDTH   = $d01d         // (29) Bit = 1: Doppelte Breite des Sprites
                                    //         Bit-Nr. = Sprite-Nr.
.var SPRITEMULTICOLOR0   = $d025         // (37) Spritefarbe 0 im Multicolormodus
.var SPRITEMULTICOLOR1   = $d026         // (38) Spritefarbe 1 im Multicolormodus
.var SPRITE0COLOR        = $d027         // (39) Farbe von Sprite 0
.var SPRITE1COLOR        = $d028         // (40) Farbe von Sprite 1
.var SPRITE2COLOR        = $d029         // (41) Farbe von Sprite 2
.var SPRITE3COLOR        = $d02a         // (42) Farbe von Sprite 3
.var SPRITE4COLOR        = $d02b         // (43) Farbe von Sprite 4
.var SPRITE5COLOR        = $d02c         // (44) Farbe von Sprite 5
.var SPRITE6COLOR        = $d02d         // (45) Farbe von Sprite 6
.var SPRITE7COLOR        = $d02e         // (46) Farbe von Sprite 7

.var SPRITE0DATA         = $07f8         // Sprite-Pointer für die Sprite-0-Daten
// *******************************************************************************
// *** Die VIC II Sprite Register  -  ENDE                                     ***
// *******************************************************************************

// zone VIC
.var VICBASE             = $d000         // (RG) = Register-Nr. dezimal
.var VICRASTERROWPOS     = $d012         // (18) Aktuelle Rasterzeile lesen oder setzen
.var VICBORDERCOLOR      = $d020         // (32) Bildschirmrandfarbe
.var VICBACKGROUNDCOLOR  = $d021         // (33) Hintergrundfarbe

// zone CIA
.var CIA1_A              = $dc00         // Adresse des CIA1-A
.var CIA1_B              = $dc01         // Adresse des CIA1-B
.var CIA1_CLOCK_TENTH    = $dc08         // Adresse zehntel Sekunden (Uhrzeit) im CIA1
.var CIA1_CLOCK_SECONDS  = $dc09         // Adresse Sekunden (Uhrzeit) im CIA1

// zone SID
// *******************************************************************************
// *** Die SID Register  -  ANFANG                                             ***
// *******************************************************************************
.var SID_BASE            = $d400         // (Nr) Basisadresse des SID_BASE
.var SID_VOICE1_FREQ_MSB = $d401         // (01) 1. Stimme: High-Byte der Frequenz
.var SID_VOICE1_WAVEFORM = $d404         // (04) 1. Stimme: Wellenform
.var SID_SUSTAIN_RELEASE = $d406         // (06) BIT 7-4: Anschlag (sustain)
                                    //          3-0: Abschwellen (release)
.var SID_VOLUME          = $d418         // (24) BIT   7: 3. Stimme Filtermodus AUS
                                    //            6:   -''-    Hochpass
                                    //            5:   -''-    Bandpass
                                    //            4:   -''-    Tiefpass
                                    //          3-0: Lautstärke

.var SID_WAVE_TRIANGLE   = $11           // Wellenform: Dreieck
.var SID_WAVE_SAWTOOTH   = $21           // Wellenform: Sägezahn
.var SID_WAVE_PULSE      = $41           // Wellenform: Rechteck
.var SID_WAVE_WHITENOISE = $81           // Wellenform: Rauschen
// *******************************************************************************
// *** Die SID Register  -  ENDE                                               ***
// *******************************************************************************

// zone Zeropage
.var ZP_SCREENRAMADR     = $02           // Zeichen-Quelle fürs BS-Kopieren (drawscreen:)
.var ZP_COLORRAMADR      = $04           // Farb-Quelle fürs BS-Kopieren    (drawscreen:)
.var ZP_SCREENTODRAW     = $06           // Zeichen-Ziel fürs BS-Kopieren   (drawscreen:)
.var ZP_COLORTODRAW      = $08           // Farb-Ziel fürs BS-Kopieren      (drawscreen:)
.var ZP_LOOPHELPER       = $f8           // Die letzten 8 BYTES für Schleifen reservieren

// zone Kernal
.var JT_GETIN            = $ffe4         // Kernalfunktion: Zeichen lesen

// zone Generic
.var SCREENRAMADR        = $0400         // Beginn des Bildschirmspeichers
.var COLORRAMADR         = $d800         // Beginn des Farbspeichers
.var INPUT_NONE          = $00           // Es wurde noch kein Port gewählt
.var INPUT_JOY1          = $01           // Joystick in Port-1
.var INPUT_JOY2          = $02           // oder 2
.var JOY_UP              = %00000001     // Joystick rauf
.var JOY_DOWN            = %00000010     // Joystick runter
.var JOY_LEFT            = %00000100     // Joystick links
.var JOY_RIGHT           = %00001000     // Joystick rechts
.var JOY_FIRE            = %00010000     // Joystick FEUER// 


// ---------------
// MINIMAL
// ---------------
.var  BORDER_COLOR   = $D020
.var  BACKGROUND_COLOR    = $D021
.var  FOREGROUND_COLOR = $E536

.var  SPRITE_0_X_POSITION = $D000
.var  SPRITE_0_Y_POSITION = $D001
.var  SPRITE_0_POINTER    = $0400 + $03F8 // Last 8 Bytes of Screen RAM
.var  SPRITE_0_DATA       = $0340         // Block 13, 13*64=>832 => $0340
.var SPRITE_UPPER_X      = $D010
  

// COLORS
// https://www.c64-wiki.com/wiki/Color

// IDEAS: 
// Strategy: Strategy game with frame. defend frame coming into the frame and destroying it ... > change color > change strategy
//           not all colors are good. 

// Demo: Use loading input on screen ... (someone did this of course before, i am sure) title could be content

*=$0801   //  Starting Address BASIC + 1 =&gt//  SYS 2049
 
  .byte $0C,$08,$40,$00,$9E,$20,$32,$30,$36,$32,$00,$00,$00 //  BASIC CODE: 1024 SYS 2062


// --------------------------------------------------
// INIT 
// --------------------------------------------------

init:

  jsr clear_screen

  // DEC TO HEX
  // https://www.rapidtables.com/convert/number/decimal-to-hex.html?x=214
 
  jsr disable_inputbuffers

  // ----------------
  // BACK & FOREGROUND COLORS
  // ----------------
  // background, frame color
  lda #0      
  sta BORDER_COLOR      
  sta BACKGROUND_COLOR  
  // set FOREGROUND_COLOR (COLOR CAN BE DIFFERENT IN EACH LINE!)
  lda #$01 
  jsr FOREGROUND_COLOR


  // ----------------
  // PRINT
  // ----------------
  // zeichensatz: https://www.c64-wiki.de/wiki/Zeichen

  // print - show a character
  lda #$d6                //  load character '_' into register A
  jsr $ffd2               //  print character to screen

  // print at // ... 
  // https://medium.com/@RetroAsmDev/c-64-part-4-ascii-art-a4319784d26


  // KEY
  .var SCNKEY     = $ff9f   // scan keyboard - kernal routine
  .var GETIN      = $ffe4   // read keyboard buffer - kernal routine



// --------------------------------------------------
// LOOP 
// --------------------------------------------------

loop:
  
  
  jsr vsync       // vsync



            // ---------
            // keys     ascii? > other in charset! 
            // ---------
            // input keys: https://codebase64.org/doku.php?id=base:scanning_the_keyboard_the_correct_and_non_kernal_way
            // get all keys https://codebase64.org/doku.php?id=base:scanning_the_keyboard_the_correct_and_non_kernal_way 

            jsr SCNKEY
            jsr GETIN

            // check keys

            // A                 
            cmp $1f
            bne notkey_a

            lda $d6               
            jsr $ffd2              
notkey_a:        

            cmp #13             // return
            bne notkey_return
            lda $03                
            jsr $ffd2 
notkey_return:                 

            // SPACE
            cmp #$20
            bne nokey
            // jmp exit

            lda #05     
            sta BORDER_COLOR      
            sta BACKGROUND_COLOR  

            rts  // exit ... 
nokey:  

            // ------------------
            // joystick  
            // ------------------
            // joystick : https://retro-programming.com/how-to-program-joystick-input-handling-on-a-c64/

            lda #$08                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notright   // if not active (==1), go to .input_up_check
            lda #$32
            jsr $ffd2   // print screen ... 
joystick_notright:
            
            lda #$01              // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notleft   // if not active (==1), go to .input_up_check
            lda #$33
            jsr $ffd2   // print screen ... 
joystick_notleft:

            
            // ------------------
            // sprite ...  
            // ------------------
            // https://retro-programming.com/how-to-move-sprites-in-c64-assembly/


    
            // ------------------
            // blinken ...  
            // ------------------
            /*
            inc BACKGROUND_COLOR
            inc BORDER_COLOR
            inc FOREGROUND_COLOR
            */

            
            // restart
            jmp loop      // loopy loop

exit: 

  // back to BASIC

// --------------------------------------------------
// SUBROUTINES 
// --------------------------------------------------
clear_screen:
    jsr $E544       
    rts

disable_inputbuffers:
    lda #1
    sta $0289  //  disable keyboard buffer
    lda #127
    sta $028a  // disable key repeat
    rts

vsync:
      lda #$FF    // load 255 into A
      cmp $D012    //look if current rasterline equals 255
      bne vsync     // if no, goto wait
      rts  

// --------------------------------------------------
// DATA 
// --------------------------------------------------

