
// ****************************************
// GAME TEMPLATE
// ****************************************
// 
// 
// IN KICK ASSEMBLER
// EXPERIMENTAL ARCHEOLOGY
// CONFOEDERATIO LUDENS
// 
// rene.bauer@zhdk.ch
// 
// setting: workaholic
// 
// ****************************************
// Fullfeatured 2 loaded screen > look at ... _featured!
// ****************************************

// 
// 20230727 fixed the collect mechanic (problem cmp > branch)
// 20230708 remove ingame-background-picture

// GAMEDESIGN NEEEDS
// SIMPLE FUNCTIONS:
// - IF THEN, LOOP, INC, DEC
// - INPUT
// - OUTPUT
// (- SPRITES/SCROLLING/COLLISION) OR DO IT YOURSELF


/*

    GAME IDEA: HOLY CUBE

    A META DEMO WITH A GAME

    NEXT LEVEL:
    I AM FROM ANOTHER WORLD
    I AM THE FUTURE
    I AM ENDLESS
    I WILL BE IN ENDLESS DEMOS
    I WILL BE THE DEMOSCENE
    I AM A VECTOR
    I ROTATE ENDLESS
    I TURN AROUND MYSELF
    I AM AN AI 
    I WILL BE DOOM
    I WILL KILL ALL PIXELS
    I AM ONLY ONE
    THERE WILL COME MORES
    WE ARE VECTORS
    WE ARE GODS
    WE ARE VIRTUAL REALITY
    WE CONTROL YOU
    WE KILLED 3D CONSTRUTION
    ALL WILL BE VECTORS
    VECTREX MUST LIVE

    DIED:
    YOU FUCKED UP 2008
    YOU VOTED FOR TRUMP
    YOU ARE AGAINST DEMOCRACY
    YOU JUST WANNA MAKE MONEY
    YOU WILL NEVER WIN, WE ARE PIXELS
    WE ARE THE PIXELS
    YOU RENDER ALWAYS TO PIXELS
    DIE VECTREX
    DIE SHADERS
    DIE SCALABLE
    DIE TEXTURES
    DIE UNITY
    DIE UNREAL
    LONG LIVE SHOOTEMUP-CONSTRUCTIONKIT
    DIE ALL ABSTRACTS


*/


/*

    // gameengine:

    mainloop:

        gameobjects (incl. sprites)
        gameobject-gameobject-collisions
        gameobject-backround-collisions

        tile animations

    functions:

        load_level
        render_playfield
        render_block
        
        set_sprite

        render_tile

        show_dialog
        render_string
        render_tile_number09

    
*/



// CODE SNIPETS
// https://codebase64.org/doku.php?id=start


/*
    TOO BIG CONSOLE ((24+320) x (200+50)pixel) WITH A TOO SMALL HEART  (8bit 6502)  
    DATAMANAGEMENT HORROR!
*/

/*

    ENGINE MODE 

    engine_mode:           // 0 normal mode: spritex only 0-256
                            // 1 extended mode: spritex 0-320: 
                            //
                            //   spritex: 100 + 1 >> 200 + 1 = 201
                            //            byte 1 (0-160): x (*2)  > 129*2
                            //            byte 2 (0/1): + 0/1   > +1    >> 258+1 > 259
                            //            spritecollision: /2 
                            //

    SPRITES:
    x = 24   [24-320+24]
    y = 50   [50-50+200]

    SPRITE-SIZE:
    width: 24
    height: 21

*/

.var  engine_mode   = 1; // 0 or 1 
.var  playfield_starts_at8px = 0; // 0 or 1

// bug in 1 with a mixed up lines in 

// boundaries for avatar
.var engine_boundary_y_min = 10

// animation speed
.var animation_speed = 3

/*
    INGAME SCREEN MODE

    engine_ingamescreen         // 0: char-mode *
                                // 1: chars - Extended Colour Mode / ECM / Extended color mode * - not many tiles!
                                // 2: color bitmap 
                                // * not yet working with ingame menu screen switch etc



*/


.var engine_ingamescreen = 2 // only 2 available .. 

// TODO: DRAW BITMAP
// https://www.youtube.com/watch?v=AGR2-tAYXFw

// COMPILING (FOR FASTER DEV)
.var loadPicture = true // > by hand ! search for loadPicture
.var loadMusic = true

// CONTROL 1-10 as joystick input1Ω

// PROCESSOR: 6502 :-( (Why not the original 680x? yes to expensive!)
// VIC-II: Graphic chip
// SID: Programmable sound chip

// EMULATION: VICE-USAGE
// - drag&drop
// - F10
// - cursors (0-10)

// KICK ASSEMLBER
// ASSEMBLER WITH SCRIPTING FUNCTIONS
// http://www.theweb.dk/KickAssembler/webhelp/content/ch12s03.html

// java -jar KickAss.jar game_template.asm

// EXAMPLES
// https://codebase64.org/doku.php?do=search&id=base%3Areading_the_keyboard&q=print


// INSPIRATIONS:
// - https://www.youtube.com/watch?v=4F1F8O6TkMo (fantastic endless runner, analog and digital)


// IDEAS
// 2 sprites 1 px changed or even highsolution

/*

    # ASSEMBLER-HINTS

    160x200 in multicolor 

    only 8bit ... > problems with sprite x etc .-(

    page: 256bytes 

    command             : local
    command xyz         : command memory
    command xyz,index   : command memory+index

    inc
    dec 

    clc - clear add on state bits ! (for ror,rol,etc)

    clc
    lda #100
    adc #200 - add (reset flag before)
    bcs morethan256 
    // do the staff 
    // add 1 to possible 8-16bit byte
    // use a for the rest .. 
    // BCC
    morethan256:  

        // example 
            lda #100
            lda #10
            clc
            adc #200
            // depends on carryflag

            bcs morethan256 
            inc BACKGROUND_COLOR
        morethan256:

            bcc lessthan256 
            // is more - more is in a
            inc BORDER_COLOR
        lessthan256:

        example 2:
        clc 
            lda zp_bmp_lower
            adc #11*22
            sta zp_bmp_lower
            bcc morethan256 
            inc zp_bmp_higher
        levelhigher_than256:


    // adding over 256
    // use carry flag
    //  
    // a: 200+60 > a: 4 and carryflag = true 
    // 
    clc 
    lda #100
    adc #200
    // result 44 or 45 + carry flag !!!
    // check carry flag !

    // add > 255
    // add 1 directly and than the rest!



    // calculating with pointers (no other way!)

        // zero page - calculating with pointers (only possibility!)
        // fe - 00
        // ff - 04
        // (fe) access ($0400)

        // Most programmers use $02 to $06 and/or $FB to $FE.

        // lowbyte  lda #<$0400
        //          sta $fe
        // highbyte sta #>$0400
        // etc.

        // https://technology-blog.net/c64-assembler-programmierung-zeropage-und-addressing-modes/

        indirect registers .-(


--- LOADING FROM ZEROPAGE WITH THE SAME x is not possible(abc),x and save to non zero page ist not working
--- BUT: x to load and y to save works
            // copy now
            ldy #0
            ldx #0
cp_level:
            
            lda (zp_draw_lower),y

            sta act_level,x
            // sta (zp_bmp_lower),y




        a lot of defined things https://www.c64-wiki.de/wiki/Zeropage
        $fb+ 
        indirect adressing mit zero page

        LDA ($FE),Y // load fe und ff > absolute adress ... 
        STA ($fe),Y
        // indirect adressing with y!
        vs LDA($FE,Y) - (FE+Y)

        // 00 + 04 > 0400
          lda #$00
          sta $fe
          lda #$04
          sta $ff
          // c
          lda #3
          sta ($fe),y

        // clean the screen (not splitted)
            lda #$00
            sta $10
            lda #$02
            sta $11
        fill:
            ldy #0
            lda #$ff
        loop:
            sta ($10), y
            iny
            bne loop
            lda $11
            clc
            adc #$01
            cmp #$06
            beq done
            sta $11
            bne fill
        done:   


    txa - transfer x to a
    tya - transfer a to x

    
    // value ohne # !!!!
    // > %10001
    // > 10
    // > 00

    // sub 10
    clc
    sbc #10


    // stack
    pha (PusH Accumulator)        
    // do something 
    pla (PuLl Accumulator)          

    // indexing
    sta xyz,4 // store in acummlator-adresse xyz[4]
    lda xyz,5 // load into accumulator xyz[4]

    // compare direct
    clc
    cmp #20,x // direct
    bne bxt // not ...


    // compare to var 
    abc: .byte 20
    cmp abc


    think invers:

    == bne
    != beq


    bne : not equal
    beq : equal
    blt : lower than (flags!)
    bcc : less
    bcs : higher or same

    bit (compare)

    
bxt:

    0101010

    ror -  < / 2 // '*2' <
    rol -  > *2 // '/2' >

    http://www.6502.org/tutorials/6502opcodes.html#ROR

*/

/*

    THE ARCHITECTURE OF C64

    VIDEORAM:

        vicbank(%00000011)  defines where the VIDEORAM IS!
        [VIDEORAM (IS SOMEHOW ORGANISED IN 8x8 BLOCKS .-( ))]
        [VIDEORAM]+1016 > POINTERS TO ! THE SPRITES! [SPRITE0][SPRITE1]...

        [POSITIONS ABSOLUTE!]

    // DESIGNDECISIONS?

*/

//VIDEO RAMS ADDRESSES
// POSSIBLE: $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff
// https://www.c64-wiki.com/wiki/Screen_RAM
// $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff etc
// ... 
// vicbank(%00000011);
// vicbank(%00000010); // bank1
/*
    lda $dd00
    and #%11111100
    ora #pattern
    sta $dd00 // store there

 */ 

// MODES:
// - CURSOR MODE - ASCII 
//   - start AT $4000 (SCREENRAM)

// - GRAPHIC MODE - ALSO BLOCKS (COLORRAM)
//   - STARTS AT $D800

/*
    8x4 > next 8x4 > next 8x4
    [ ] > [ ] > [ ]


*/

// - HIGHRES: 320x200 
// - LOWRES: 160x200 - MULTICOLOR 

// GRAPHICS PAINT
// https://mcdraw.xyz

// CONVERT PICS TO C64 COLOR PALETTE
// https://www.micheldebree.nl/retropixels/

// SPRITE PAINT (Multicolor)
// multicolor: https://beta.spritemate.com
// you can use http://spritemate.com/ to edit these
// just press file->save file->kick ass(hex) once you designed your sprite


// HELPERS
// DEC TO HEX
// https://www.rapidtables.com/convert/number/decimal-to-hex.html?x=214


// DEMO EXAMPLE
// https://github.com/celso/c64/blob/master/card.asm (including sprite management etc)
// GOOD FOR STARTING (this is a mix from this and other tutorials)

// RANDOM
// rndGen(%1111);
// sta $d027,x  // into x 



// MUSIC

// playing SID music has 3 parts:
// 0. load music
// 1. you use use Kick Assembler's LoadSid to import the .sid file
// 2. you call music.init
// 3. you call music.play in every raster interrupt
// see http://www.theweb.dk/KickAssembler/webhelp/content/ch12s03.html and the README.md


// ----------------------
// POINTERS
// ----------------------


        // bitmap & block
        .var zp_block_lower   = $02 // zeropage
        .var zp_block_higher  = $03 


        .var zp_bmp_lower   = $04 // zeropage
        .var zp_bmp_higher  = $05 

        // color ram .. copy to 1+2
        .var zp_colorram_lower   = $08 // zeropage
        .var zp_colorram_higher  = $09  

        // draw
        .var zp_draw_lower   = $06 // zeropage
        .var zp_draw_higher  = $07 

        // lowbyte   #<  $1020 >  $20
        // highbyte  #> $1020 > $10

// ----------------------
// MINIMAL VARS/CONST
// ----------------------

.var  BORDER_COLOR   = $D020
.var  BACKGROUND_COLOR    = $D021
.var  FOREGROUND_COLOR = $E536

.var  SPRITE_0_X_POSITION = $D000 // only for ascii screen !!!! 
.var  SPRITE_0_Y_POSITION = $D001
.var  SPRITE_0_POINTER    = $0400 + $03F8 // Last 8 Bytes of Screen RAM
.var  SPRITE_0_DATA       = $0340         // Block 13, 13*64=>832 => $0340
.var  SPRITE_UPPER_X      = $D010   // X-MSB
.var  SPRITE_0_COLOR      = $D027 

// VRAM (different places - definable)
// SPRITES: VRAM START AND $3F8

 .var SCNKEY     = $ff9f   // scan keyboard - kernal routine
 .var GETIN      = $ffe4   // read keyboard buffer - kernal routine

            // ----------------------
            // MAX VARIABLES
            // ----------------------


            // *******************************************************************************
            // *** Farben                                                                  ***
            // *******************************************************************************
            .var COLOR_BLACK         = $00           // schwarz
            .var COLOR_WHITE         = $01           // weiß
            .var COLOR_RED           = $02           // rot
            .var COLOR_CYAN          = $03           // türkis
            .var COLOR_PURPLE        = $04           // lila
            .var COLOR_GREEN         = $05           // grün
            .var COLOR_BLUE          = $06           // blau
            .var COLOR_YELLOW        = $07           // gelb
            .var COLOR_ORANGE        = $08           // orange
            .var COLOR_BROWN         = $09            // braun
            .var COLOR_PINK          = $0a           // rosa
            .var COLOR_DARKGREY      = $0b           // dunkelgrau
            .var COLOR_GREY          = $0c           // grau
            .var COLOR_LIGHTGREEN    = $0d           // hellgrün
            .var COLOR_LIGHTBLUE     = $0e           // hellblau
            .var COLOR_LIGHTGREY     = $0f           // hellgrau

            // zone Sprites
            // *******************************************************************************
            // *** Die VIC II Sprite Register  -  ANFANG                                   ***
            // *******************************************************************************
            // THESE ARE ABSOLUT REGISTERS > NOT THE DATA! 
            .var SPRITE_BASE         = $d000
            .var SPRITE0X            = $d000         // (00) X-Position von Sprite 0
            .var SPRITE0Y            = $d001         // (01) Y-Position von Sprite 0
            .var SPRITE1X            = $d002         // (02) X-Position von Sprite 1
            .var SPRITE1Y            = $d003         // (03) Y-Position von Sprite 1
            .var SPRITE2X            = $d004         // (04) X-Position von Sprite 2
            .var SPRITE2Y            = $d005         // (05) Y-Position von Sprite 2
            .var SPRITE3X            = $d006         // (06) X-Position von Sprite 3
            .var SPRITE3Y            = $d007         // (07) Y-Position von Sprite 3
            .var SPRITE4X            = $d008         // (08) X-Position von Sprite 4
            .var SPRITE4Y            = $d009         // (09) Y-Position von Sprite 4
            .var SPRITE5X            = $d00a         // (10) X-Position von Sprite 5
            .var SPRITE5Y            = $d00b         // (11) Y-Position von Sprite 5
            .var SPRITE6X            = $d00c         // (12) X-Position von Sprite 6
            .var SPRITE6Y            = $d00d         // (13) Y-Position von Sprite 6
            .var SPRITE7X            = $d00e         // (14) X-Position von Sprite 7
            .var SPRITE7Y            = $d00f         // (15) Y-Position von Sprite 7
            .var SPRITESMAXX         = $d010         // (16) Höhstes BIT der jeweiligen X-Position
                                                //         da der BS 320 Punkte breit ist reicht
                                                //         ein BYTE für die X-Position nicht aus// 
                                                //         Daher wird hier das 9. Bit der X-Pos
                                                //         gespeichert. BIT-Nr. (0-7) = Sprite-Nr.
            .var SPRITEACTIVE        = $d015         // (21) Bestimmt welche Sprites sichtbar sind
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDOUBLEHEIGHT  = $d017         // (23) Doppelte Höhe der Sprites
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDEEP          = $d01B         // (27) Legt fest ob ein Sprite vor oder hinter
                                                //         dem Hintergrund erscheinen soll.
                                                //         Bit = 1: Hintergrund vor dem Sprite
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEMULTICOLOR    = $d01c         // (28) Bit = 1: MultiColor Sprite 
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDOUBLEWIDTH   = $d01d         // (29) Bit = 1: Doppelte Breite des Sprites
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEMULTICOLOR0   = $d025         // (37) Spritefarbe 0 im Multicolormodus
            .var SPRITEMULTICOLOR1   = $d026         // (38) Spritefarbe 1 im Multicolormodus
            .var SPRITE0COLOR        = $d027         // (39) Farbe von Sprite 0
            .var SPRITE1COLOR        = $d028         // (40) Farbe von Sprite 1
            .var SPRITE2COLOR        = $d029         // (41) Farbe von Sprite 2
            .var SPRITE3COLOR        = $d02a         // (42) Farbe von Sprite 3
            .var SPRITE4COLOR        = $d02b         // (43) Farbe von Sprite 4
            .var SPRITE5COLOR        = $d02c         // (44) Farbe von Sprite 5
            .var SPRITE6COLOR        = $d02d         // (45) Farbe von Sprite 6
            .var SPRITE7COLOR        = $d02e         // (46) Farbe von Sprite 7

            .var SPRITE0DATA         = $07f8         // Sprite-Pointer für die Sprite-0-Daten
            // *******************************************************************************
            // *** Die VIC II Sprite Register  -  ENDE                                     ***
            // *******************************************************************************

            // zone VIC
            .var VICBASE             = $d000         // (RG) = Register-Nr. dezimal
            .var VICRASTERROWPOS     = $d012         // (18) Aktuelle Rasterzeile lesen oder setzen
            .var VICBORDERCOLOR      = $d020         // (32) Bildschirmrandfarbe
            .var VICBACKGROUNDCOLOR  = $d021         // (33) Hintergrundfarbe

            // zone CIA
            .var CIA1_A              = $dc00         // Adresse des CIA1-A
            .var CIA1_B              = $dc01         // Adresse des CIA1-B
            .var CIA1_CLOCK_TENTH    = $dc08         // Adresse zehntel Sekunden (Uhrzeit) im CIA1
            .var CIA1_CLOCK_SECONDS  = $dc09         // Adresse Sekunden (Uhrzeit) im CIA1

            // zone SID
            // *******************************************************************************
            // *** Die SID Register  -  ANFANG                                             ***
            // *******************************************************************************
            .var SID_BASE            = $d400         // (Nr) Basisadresse des SID_BASE
            .var SID_VOICE1_FREQ_MSB = $d401         // (01) 1. Stimme: High-Byte der Frequenz
            .var SID_VOICE1_WAVEFORM = $d404         // (04) 1. Stimme: Wellenform
            .var SID_SUSTAIN_RELEASE = $d406         // (06) BIT 7-4: Anschlag (sustain)
                                                //          3-0: Abschwellen (release)
            .var SID_VOLUME          = $d418         // (24) BIT   7: 3. Stimme Filtermodus AUS
                                                //            6:   -''-    Hochpass
                                                //            5:   -''-    Bandpass
                                                //            4:   -''-    Tiefpass
                                                //          3-0: Lautstärke

            .var SID_WAVE_TRIANGLE   = $11           // Wellenform: Dreieck
            .var SID_WAVE_SAWTOOTH   = $21           // Wellenform: Sägezahn
            .var SID_WAVE_PULSE      = $41           // Wellenform: Rechteck
            .var SID_WAVE_WHITENOISE = $81           // Wellenform: Rauschen
            // *******************************************************************************
            // *** Die SID Register  -  ENDE                                               ***
            // *******************************************************************************

            // zone Zeropage
            .var ZP_SCREENRAMADR     = $02           // Zeichen-Quelle fürs BS-Kopieren (drawscreen:)
            .var ZP_COLORRAMADR      = $04           // Farb-Quelle fürs BS-Kopieren    (drawscreen:)
            .var ZP_SCREENTODRAW     = $06           // Zeichen-Ziel fürs BS-Kopieren   (drawscreen:)
            .var ZP_COLORTODRAW      = $08           // Farb-Ziel fürs BS-Kopieren      (drawscreen:)
            .var ZP_LOOPHELPER       = $f8           // Die letzten 8 BYTES für Schleifen reservieren

            // zone Kernal
            .var JT_GETIN            = $ffe4         // Kernalfunktion: Zeichen lesen

            // zone Generic
            .var SCREENRAMADR        = $0400         // Beginn des Bildschirmspeichers
            .var COLORRAMADR         = $d800         // Beginn des Farbspeichers
            .var INPUT_NONE          = $00           // Es wurde noch kein Port gewählt
            .var INPUT_JOY1          = $01           // Joystick in Port-1
            .var INPUT_JOY2          = $02           // oder 2
            .var JOY_UP              = %00000001     // Joystick rauf
            .var JOY_DOWN            = %00000010     // Joystick runter
            .var JOY_LEFT            = %00000100     // Joystick links
            .var JOY_RIGHT           = %00001000     // Joystick rechts
            .var JOY_FIRE            = %00010000     // Joystick FEUER// 



// --------------------------------------------
// LOAD DATA
// --------------------------------------------

// Music (<3k!)
// Attention: Reload Emulators to test other music!!

.var music = LoadSid("music7.sid") 

// Graphics
// https://mcdraw.xyz
//.if (loadPicture) {
  

    // .var picture = LoadBinary("image.koa", BF_KOALA)
    // .var picture = LoadBinary("minimalpicture.kla", BF_KOALA) // less loading

  // .var picture = LoadBinary("image.kla", BF_KOALA)
  .var picture = LoadBinary("title.kla", BF_KOALA)

  //  .var picturemen = LoadBinary("squarez_menu.kla", BF_KOALA)
//}

// --------------------------------------------------
// INIT BASIC
// --------------------------------------------------

// *=$0801 "Basic Program"
BasicUpstart2(start)


 // the address $0001 holds and sets the 6510 CPU's on-chip port register
    // %x10: RAM visible at $A000-$BFFF; KERNAL ROM visible at $E000-$FFFF
    // what we're saying here is we don't need the BASIC ROM after we start
    // see https://www.c64-wiki.com/wiki/Zeropage
    lda #%00110110
    sta $0001

// --------------------------------------------------
// SCENE SYSTEM 
// --------------------------------------------------
.const scene_menu = 0
.const scene_info = 1
.const scene_setup = 2
.const scene_score = 3
.const scene_load = 4
.const scene_story = 5
.const scene_gameover = 6
.const scene_level = 7 // +

// .const scene_won = 19



// --------------------------------------------------
// INIT 
// --------------------------------------------------
*= $c000 "Program" // no idea why ..

start:

    // MULTIMEDIA

    // music: init 1
    .if (loadMusic) { 
        lda #music.startSong-1 // set up the music
        jsr music.init
    }

    // setup: raster music
    sei

        .if (loadMusic) { 
          lda #<irq1
          sta $0314
          lda #>irq1
          sta $0315
          lda #$1b
          sta $d011
          lda #$80
          sta $d012
          lda #$7f
          sta $dc0d
          sta $dd0d
          lda #$81
          sta $d01a
          lda $dc0d
          lda $dd0d
          asl $d019
        }

      cli


    // CLEAR SCREEN
    // jsr clear_screen

     // disable input buffers     
     jsr disable_inputbuffers


// ------------------------------------
// Testsuite for codes
// ------------------------------------

// comment: code (concept, idea) and working code (tested)
// bne etc are like i++ 

jmp  nottestsuite

testsuite:
    
    lda #100
    lda #10
    clc
    adc #200
    // depends on carryflag

    bcs morethan256 
    inc BACKGROUND_COLOR
morethan256:

    bcc lessthan256 
    // is more - more is in a
    inc BORDER_COLOR
lessthan256:

    jmp testsuite

nottestsuite:


      // ----------------
      // GRAPHIC MODE
      // ----------------

        jsr blink

// vicbank(%00000011);


        vicbank(%00000010); // bank1

        // $8000 < means the worldwide knowhow called chatgpt


        // -----------------------------
          // IMAGE COPY
          // -----------------------------

    //   .if (engine_ingamescreen==0) {
             // copy picture 
                
                lda #$38
                sta $d018
                
                lda #$d8
                sta $d016
                
                lda #$3b
                sta $d011
                
                lda #0
                sta $d020
                
                lda #picture.getBackgroundColor()
                sta $d021
                
                ldx #0
        copycat:
                .for (var i=0; i<4; i++) {
                   lda colorRam+i*$100,x
                   sta $d800+i*$100,x // colorram 
                }
                inx
                bne copycat
 
  //  }


 // -----------------------------
  // OBJECTS
  // -----------------------------

    .const objects_count = 14 // 14 all objects

    .const objects_sprite = 8 // 0-x are sprites rest something else triggers

    // object struct 

    .const object_length = $12 //  17 // $0c // length 

    .const object_x = 0 // + 1 byte!
    .const object_x_higher = 1 // + 1 byte!

    /* 

        X-MSB

        sprite: 256+x

        256 + 40 

        LDA $D010       ; load X-MSB
        ORA #%00100000  ; set extra bit for sprite #5
        STA $D010       ; write X-MSB register
    */

    .const object_y = 2
    .const object_w = 4
    .const object_h = 5

    .const object_type = 6  // 0 nothing 1 sprite 2 block 3 trigger

        .const ot_nothing = 0
        .const ot_sprite = 1
        .const ot_block = 2
        .const ot_trigger = 3


    .const object_state = 7

        .const os_inactive = 0 // active
        .const os_active = 1 // inactive

    .const object_statesub = 8 // 0 neutral - 1 friend - 2 enemy 

        .const os_sub_neutral = 0
        .const os_sub_friend = 1
        .const os_sub_enemy = 2


    .const object_arg = 9
    .const object_behavior = 10 // 0 - no behaviour 1: player1 2: player 2 3: reset 4+: up left etc .. 
   
    .const object_spr = 11 // sprite type 

    .const object_animtodo = 12 // actual sprite next
    .const object_animindex = 13 // actual sprite
    .const object_minanim = 14
    .const object_maxanim = 15
    .const object_animtype = 16 // 0 no anim 1 once 2 endless 3+
        .const oa_noanim = 0
        .const oa_once = 1
        .const oa_endless = 2

    .const object_animdone = 17 // done ?


    // ingamestate
      .const igm_normal = 0
        .const igm_normal_nocomment = 1
        .const igm_auto = 2

 // -----------------------------
  // SPRITE SETUP TECH
  // -----------------------------
 
    // ALL SINGLE COLOR
    lda #%00000000
    // lda #%11111111
    sta $d01c // all sprites are of type 'single color'
    // card: $D015/53269  acts like a "switch" that turns one of the eight sprites "on" or "off"
    // swith all on 
    lda #%11111111
    sta $d015 // all eight sprites on (all bits set)

    // cards: the location of the sprite pointers (see sprites.asm) follows that of the text screen plus 1016/$3F8
     // this will iterate the 8 sprite pointers, load their values (see sprites.asm) and set screen addresses with them
    // see https://www.c64-wiki.com/wiki/Sprite#Sprite_pointers


      jsr blink


// ---------------------------- ------------
// SETUP: COMMENT SYSTEM STEPBYSTEP
// ---------------------------- ------------
lda #<comment_strings
sta comment_char_pointer_lower
lda #>comment_strings
sta comment_char_pointer_higher


// --------------------------------------------------
// TITLE SCREEN / SPLASH SCREEN
// --------------------------------------------------

// jmp notitle

    vicbank(%00000011); // bank0

    lda #00   
    sta BORDER_COLOR      
    sta BACKGROUND_COLOR  

    lda #0
    sta title_counter

    lda #0
    sta mcounter

    lda #0
    sta title_comment_counter

title_loop:

    // do the demo comment stuff/staff .-)
    lda #12
    sta comment_step_color
    lda #0
    sta comment_step_y
    jsr comment_stepper
    jsr comment_stepper_reset
    
    jsr vsync  

    // mcounter
    inc mcounter
    lda mcounter
    clc
    cmp #50
    bne mnext
    lda #0
    sta mcounter
 

    // print text
    inc title_comment_counter
    clc
    lda title_comment_counter
    cmp #1
    bne remove_comment
    
        // set up
        lda #5
        sta string_x
       lda #22
       sta string_y
       // render ... 4 
       lda #<title_text_clear
       sta string_adress_lower
       lda #>title_text_clear
       sta string_adress_higher
       jsr render_string

remove_comment:
 
    clc
    lda title_comment_counter
    cmp #5
    bne show_title_comment

       // set up
       lda #5
       sta string_x
       lda #22
       sta string_y
       // render ... 4 
       lda #<title_text
       sta string_adress_lower
       lda #>title_text
       sta string_adress_higher
       jsr render_string

show_title_comment:

    clc
    lda title_comment_counter
    cmp #8
    bne show_title_comment_loop

    lda #0
    sta title_comment_counter


show_title_comment_loop:


    jsr vsync       
    clc
    inc title_counter
    lda title_counter
    clc
    lda title_counter
    tay
    lda title_colors,y
    cmp #17
    bne next_col
    lda #0
    sta title_counter
next_col:
    clc
    lda title_counter
    tax
    lda title_colors,x
    // lda #1
    // lda title_counter
    sta BACKGROUND_COLOR
    sta BORDER_COLOR
mnext:


    

    // space
    jsr SCNKEY
    jsr GETIN
          
    // SPACE TO FINISH
    cmp #$20
    bne title_nokey
    jmp notitle
title_nokey:     


    jmp title_loop

notitle:


// --------------------------------------------------
// MENU-LOOP
// --------------------------------------------------

// jmp nomenu

    // vicbank(%00000011); // bank0
//    vicbank(%00000010); // bank1 - MENU


// picture loaded to vicbank
// vicbank(%00000011); // bank0

//    vicbank(%00000011); // bank0
    
menu_awake:

    lda #00   
    sta BORDER_COLOR      
    sta BACKGROUND_COLOR  

        /*
       lda #1
       sta block_no
       lda #1
       sta block_px
       lda #0
       sta block_py
       jsr render_block
       */

    // reset stepper
    jsr comment_stepper_reset
    // load level0 as menuscreen
    lda #scene_menu
    sta level_to_load
    jsr load_level
    jsr render_playfield

    // texts
        // set up
       lda #8
       sta string_x
       lda #10
       sta string_y
       // render ... 4 
       lda #<menu_text
       sta string_adress_lower
       lda #>menu_text
       sta string_adress_higher
       jsr render_string    

       // set up
       lda #8
       sta string_x
       lda #20
       sta string_y
       // render ... 4 
       lda #<menu_text_start
       sta string_adress_lower
       lda #>menu_text_start
       sta string_adress_higher
       jsr render_string    




    lda 0
    sta mcounter

menu_loop:

    jsr vsync   

    // anim menu
    jsr playfield_animate

    // comment here ...


    // ----------------------------
    // comment stepper in action
    // ----------------------------

    // reset stepper
    jsr comment_stepper_reset
    // set stepper color etc ---------
    lda #12
    sta comment_step_color
    // load stepper
    lda #0
    sta comment_step_y
    jsr comment_stepper
    // reset stepper again
    jsr comment_stepper_reset

    // space
    jsr SCNKEY
    jsr GETIN
          
    // SPACE TO FINISH
    cmp #$20
    bne menu_nokey
    jmp nomenu
menu_nokey:     


    jmp menu_loop

nomenu:


// --------------------------------------------------
// GAME-LOOP 
// --------------------------------------------------


    // set background
    lda #00   
    sta BORDER_COLOR      
    sta BACKGROUND_COLOR  


// ---------------------------
// GAMELOOP: SPRITE RESET 
// ---------------------------
// spritespixel def: pointer VRAM+1016!
// reset all/them all 



    // $D01C/53276 sprites can be high resolution or multicolor mode - bits at 0 sets them to high res
    // see https://www.c64-wiki.com/wiki/Sprite
    lda #%00000000 // single color
    lda #%11111111 // multi color
     sta $d01c // all sprites are of type 'single color'

    // $D015/53269  acts like a "switch" that turns one of the eight sprites "on" or "off"
    // see https://www.c64-wiki.com/wiki/Sprite
    lda #%11111111
    sta $d015 // all eight sprites on (all bits set)

    // FIND WHERE THEY POINT
        ldx #$8
    !loop:
        lda spritePtrs,x
        sta $0c00 + 1016,x
        dex
        bpl !loop-

    // --------------------------
    // STRANGE COLOR SYSTEM
    // --------------------------
    // sprite colors ...

    lda #$0a // sprite multicolor 1
    sta $D025
    lda #$08 // sprite multicolor 2
    sta $D026


    lda #$01 // sprite multicolor 2
    sta SPRITE0COLOR

    lda #$07 // sprite multicolor 2
    sta SPRITE1COLOR
    sta SPRITE2COLOR
    sta SPRITE3COLOR
 
    lda #$02 // sprite multicolor 2
    sta SPRITE4COLOR
    sta SPRITE5COLOR
    sta SPRITE6COLOR
    sta SPRITE7COLOR




   // --------------------------
    // SPRITES
    // --------------------------
 
    // --------------------
    // setup
    // --------------------

setup_menu:
 
       ldy #$0 // sprite nr ... 
       ldx #$0 // sprite counter 0,11,22,33,44 etc ...   
       lda 0  
       sta temp // x pos ... 
ssetting:
        
    
        // positions
        // char position
        
        lda temp
        // rndGen(%1111111)
        sta objects+object_x,x
        // lda #$80
        // rndGen(%1111111)
        sta objects+object_y,x
        
    

        // line
        lda temp
        clc
        adc #$18
        sta temp
        
        // object_behavior

        // all inactive
        lda #os_inactive
        // sta objects+object_state,x

        // active all hardwaresprites
        cpy #$08
        bcs notanymoreactive
        lda #os_inactive
        // sta objects+object_state,x  

notanymoreactive:

        // >0
        cpy #$01
        bcc end_check

        /*
        // random behavior
        rndGen(%111)
        sta objects+object_behavior,x
        ora 1
        */
        lda #3 // reset everything here ... 
        sta objects+object_behavior,x
        

        // default enemies
        lda os_sub_enemy
        sta objects+object_statesub,x    

 
        // <3
        cpy #$04
        bcs enemies
        // eatable
        lda os_sub_friend
        sta objects+object_statesub,x
enemies:       
        

        


end_check:
    



        // add indices 
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
        iny
        cpy #objects_count
        bne ssetting

        // --------------------
        // direct settings
        // --------------------
        // avatar
        .var sprnr=0
        lda #$a0
        sta objects+(sprnr*object_length)+object_x
        sta objects+(sprnr*object_length)+object_y

/*        
        .eval sprnr=1
        lda #$01
        sta objects+(sprnr*object_length)+object_behavior
        
        .eval sprnr=2
        lda #$02
        sta objects+(sprnr*object_length)+object_behavior
        
        .eval sprnr=3
        lda #$03
        sta objects+(sprnr*object_length)+object_behavior

        .eval sprnr=4
        lda #$04
        sta objects+(sprnr*object_length)+object_behavior

        .eval sprnr=5
        rndGen(%11)
        sta objects+(sprnr*object_length)+object_behavior
        ora 1
    
*/



  

// ---------------------------
// LOAD_LEVEL
// ---------------------------
        lda #scene_level
        clc
        adc level
        sta level_to_load
        jsr load_level

awake_level:

// ---------------------------
// PLAYFIELD TO SPRITES ETC
// ---------------------------
// instantiate
// read level blocks
// > command block > create sprites

// disable all sprites 
       ldy #$0 // sprite nr ... 
       ldx #$0 // sprite counter 0,object_length,object_length*2 
       lda #0  
       sta temp // x pos ... 
sssetting:
        

        lda #os_inactive
//        sta objects+object_state,x  

        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
        iny
        cpy #objects_count
        bne sssetting

// -------------------------------------
// check now playfields for commands
// -------------------------------------

        ldx #0
        
        lda #object_length
        tay // pointer to objects,object_length*2,object_length*3


        lda #0    
        sta block_index_x
        lda #0
        sta block_index_y

playfield_n:

        lda act_level,x

        // check levels
        
        // AVATAR LEFT................
        clc
        cmp #56 // avatar start
        bne n_stava
        lda #65
        sta act_level,x
        .if (engine_mode==0) {
          adc #10  
        }
        lda block_index_x
        adc #10

        sta objects+object_x

        lda block_index_y
        adc #50
        sbc #15
        sta objects+object_y

        lda #os_active
        sta objects+object_state

        lda #0
        sta objects+object_arg

        lda #0
        sta objects+object_behavior

        jmp o_done
n_stava:

        // AVATAR RIGHT................
        clc
        cmp #57 // avatar start
        bne n_staval
        lda #65
        sta act_level,x
        .if (engine_mode==0) {
          adc #10  
        }
        lda block_index_x
        adc #10

        sta objects+object_x

        lda block_index_y
        adc #50
        sbc #15
        sta objects+object_y

        lda #os_active
        sta objects+object_state

        lda #0
        sta objects+object_arg

        lda #1
        sta objects+object_behavior

        jmp o_done
n_staval:


// AVATAR LAST DIRECTION ...............
        clc
        cmp #58 // avatar start
        bne n_stavald
        lda #65
        sta act_level,x
        .if (engine_mode==0) {
          adc #10  
        }
        lda block_index_x
        adc #10

        sta objects+object_x

        lda block_index_y
        adc #50
        sbc #15
        sta objects+object_y

        lda #os_active
        sta objects+object_state

        lda #0
        sta objects+object_arg

        
        jmp o_done
n_stavald:



        // ENEMY  ................
        clc
        cmp #59 // enemy
        bne n_enemy
        lda #65
        sta act_level,x

        lda #os_active
        sta objects+object_state,y

        lda #2
        sta objects+object_behavior,y

        lda block_index_x
        adc #10
        sta objects+object_x,y
        lda block_index_y
        adc #50
        sbc #1
        sta objects+object_y,y
        // next object
        tya
        clc
        adc #object_length
        tay
        jmp o_done
n_enemy:

o_done:

        // calculate fornext ................

        lda block_index_x
        clc
        adc #8
        .if (engine_mode==0) {
            adc #8
        }
        sta block_index_x
        
        inc block_index_ct
        lda block_index_ct
        clc
        cmp #20
        bne n_xyt
        lda #0
        sta block_index_ct
        lda #0
        sta block_index_x  
        lda block_index_y
        adc #16
        sta block_index_y
        
        jmp starkiller  
n_xyt:
        

starkiller:

        // ...
        inx 
        cpx #240
        beq playfield_perfect
        jmp playfield_n
 playfield_perfect:       

   // --------------------------
   // PLAYFIELD ALIAS LEVELS
   // 8x16
   // --------------------------
   // vs render_tile

   // render_playfield
   jsr render_playfield 

   // not playfield_testings
jmp playfield_testings

   // testing
   lda #1
   sta playfield_val
   
   lda #5
   sta playfield_px  

   lda #5
   sta playfield_py 

   jsr set_playfield


   jsr render_playfield 

   // test now x > playfield_x

   lda #20
   sta playfield_x
   jsr get_px

   lda #18
   sta playfield_y
   jsr get_py

   // store now ...
   lda #1
   sta playfield_val
   // take the result in _px
   jsr set_playfield

   jsr render_playfield 


   // render block
  
   lda #3
   sta block_no
   lda #1
   sta block_px
   lda #0
   sta block_py
   jsr render_block

   // ----------------------
   // tiles
   // ----------------------

playfield_testings:

    // tile testings
jmp notile_testings
    
   lda #7
   sta tile_no_lower // under 256 
   lda #7
   sta tile_px
   lda #0
   sta tile_py
   jsr render_tile    

   // render no
   inc tile_py
   lda #8
   sta tile_number
   jsr render_tile_number09

   // render string!
   inc tile_py
   // set up
   lda tile_px
   sta string_x
   lda tile_py
   sta string_y
   // render ... 4 


   lda #<string0x
   sta string_adress_lower
   lda #>string0x
   sta string_adress_higher
   // jsr render_string
   

   // render it 
   lda #0
   sta string_x
   lda #24
   sta string_y
   lda #<comment_strings
   sta string_adress_lower
   lda #>comment_strings
   sta string_adress_higher
   // jsr render_string




notile_testings:

    // sprite testing

    // -----------------------------
    // SETUP SPRITES
    // -----------------------------
    
     /*
        defaults
    */
    // SRRITE ANIM SETUP
    // set up defaults
    ldy #0 // 0-8
    ldx #0 // indexer
default_anim:
    // default no animation 
    // just direct index 
  
    // static sprite
    lda #oa_noanim // oder #
    sta objects+object_animtype,x     

    // objects[].animindex = indexer
    // lda #7
    tya
    sta objects+object_animtodo,x  
    lda #42
    sta objects+object_animindex,x     

    // one object forward
    txa 
    clc
    adc #object_length
    tax
    // y++
    clc
    iny
    clc
    cpy #8
    bne default_anim    


    /*
        overwrites
    */

    // set_up avatar
    ldx #0
    lda #oa_endless
    sta objects+object_animtype,x
    lda #7
    sta objects+object_minanim,x
    lda #11
    sta objects+object_maxanim,x
    lda #7
    sta objects+object_animtodo,x
    
    /*
    lda #0
    sta sprite_no
    lda #1
    sta sprite_index
    jsr set_sprite
    */

    // set_up enemy 1
    lda #0
    clc
    adc #object_length
    tax
    lda #oa_endless
    sta objects+object_animtype,x
    lda #20
    sta objects+object_minanim,x
    lda #22
    sta objects+object_maxanim,x
    lda #20
    sta objects+object_animtodo,x


    // set_up enemy 2
    lda #0
    clc
    adc #object_length
    adc #object_length
    tax
    lda #oa_endless
    sta objects+object_animtype,x
    lda #16
    sta objects+object_minanim,x
    lda #18
    sta objects+object_maxanim,x
    lda #1
    sta objects+object_animtodo,x

/*
    // set_up enemy 3
    lda #0
    clc
    adc #object_length
    adc #object_length
    adc #object_length
    tax
    lda #oa_endless
    sta objects+object_animtype,x
    lda #20
    sta objects+object_minanim,x
    lda #23
    sta objects+object_maxanim,x
    lda #20
    sta objects+object_animtodo,x
*/


// ------------------------
// MAIN_LOOP
// ------------------------

// SET 
vicbank(%00000011); // bank0
// vicbank(%00000010); // bank1 - MENU

    // ascii mode ...
    .if (engine_ingamescreen==0) {

        lda #7
        sta BORDER_COLOR
        lda #1
        sta BACKGROUND_COLOR
        lda #4
        sta FOREGROUND_COLOR

        // disable .. graphic mode
        // disable bitmap mode
        lda #$1b
        lda #%00011011
        // lda #%00011111
        // lda #%11111111
        sta $D011

       lda #$D8
        sta $D016

        //  set multicolor 1
        lda #$0C
        sta $D022

        //  set multicolor 2
        lda #$0B
        sta $D023



        // The pointers to the character set and the screen character memory both reside in address 53272/$D018

//  set screen memory ($0400) and charset bitmap offset ($2000)
       // lda #$18
       // sta $D018
  
    *=$0c00 "ScreenRam_1"; .fill picture.getScreenRamSize(), picture.getScreenRam(i)
    // color
    *=$1c00; colorRam:  .fill picture.getColorRamSize(), picture.getColorRam(i)
    // bitmap
    *=$2000;            .fill picture.getBitmapSize(), picture.getBitmap(i)



        //   
        //   ldy #$18     // screen at $0400, bitmap at $2000
        //   sta $d011
      
          // set VIC to bank 3
          lda $DD00
          and #$fc
          // sta $dd00
  
          ldx #0
again:
          lda #244
          txa
          sta $2000,x

         lda #127

         sta $2000+300,x
    
         txa
         // lda #%00111011 
         sta $0400,x // screen ram
         
          inx
          clc
          cpx #160 // 2 lines ... 
          bne again

         


    }


        // Extended Color Mode 
    .if (engine_ingamescreen==1) {



    }


// --------------------
main_loop:
// --------------------
  

   // --------------------
   // animation-system
   // anim system  
   // --------------------
   // todo: each frame 
   // another sprite
   // 0-8

   // ---------------------
   // anim speed
   // ---------------------
   inc anim_counter
   lda anim_counter
   clc 
   cmp #animation_speed
   bne notanim_speed
   lda #0
   sta anim_counter

   // ----------------
   // anim types ...
   // ---------------------
   ldy #0 // 0-9
   ldx #0 // indexer
as_loop_doit:
    lda objects+object_animtype,x
    clc
    cmp #oa_noanim
    beq no_animatall
    // anim here ... 
    clc
    lda objects+object_animtodo,x
    cmp objects+object_maxanim,x
    bcc no_animatall_j
    clc
    cmp #oa_once
    bne no_animatall_j_not
    // set done ...
    lda #1
    lda objects+object_animdone,x
    jmp no_animatall
no_animatall_j_not:
    clc
    lda objects+object_minanim,x
    sta objects+object_animtodo,x
    jmp no_animatall
no_animatall_j:
    inc objects+object_animtodo,x
no_animatall:

    // pointer
    txa
    clc
    adc #object_length
    clc
    tax

    // for next
    iny
    cpy #8
    bne as_loop_doit

notanim_speed:

   // animation tasks
   // animation done ... 

   // ---------------------
   // show all 
   // ---------------------
   ldy #0 // 0-9
   ldx #0 // indexer
as_loop:

    // is the index other than todo 
    // > copy new animation
    lda objects+object_animindex,x
    clc
    cmp objects+object_animtodo,x
    beq noanim_now 
    lda objects+object_animtodo,x
    sta objects+object_animindex,x

    // sprite_no
    tya
    sta sprite_no
    lda #3
    // sprite to show
    tya 
    lda objects+object_animindex,x
    sta sprite_index
    jsr set_sprite
noanim_now:    
    // pointer
    txa
    clc
    adc #object_length
    clc
    tax

    // for next
    iny
    cpy #8
    bne as_loop
    // ------------------


    // comments
    lda #24
    sta comment_step_y
    jsr comment_stepper
   



// lda #os_active
// sta objects+object_state

    // realtime playfield in 0.25/sec
    // jsr render_playfield
   
    // inc BORDER_COLOR
    // inc BACKGROUND_COLOR

   // --------------------
   // gui
   // --------------------



        // flicker
     jmp noflackerforex

 inc FOREGROUND_COLOR
inc BACKGROUND_COLOR
inc BORDER_COLOR

noflackerforex:

  // ----------------------------
  // COMMENT SYSTEM ONE LINE
  // ----------------------------

jmp no_comment

  inc comment_counter
  lda comment_counter
  clc
  cmp #30
  bne no_comment
  lda #0
  sta comment_counter
  
  inc comment_accum
  lda comment_accum
  clc
  cmp #2
  bne no_comment
  lda #0
  sta comment_accum

      
       // render it 
       lda #0
       // lda comment_index
       sta string_x
       lda #24
       sta string_y
       lda #<comment_strings
       sta string_adress_lower
       lda #>comment_strings
       sta string_adress_higher

       // todo: use a pointer for all this +40

       // loop it
       inc comment_index
       lda comment_index
       clc 
       cmp #6   // comment_max
       bne comment_restart
       lda #0
       sta comment_index
comment_restart:


       lda comment_index
       clc
       cmp #0
       beq notfirst_line

       /*
        lda #<comment_strings_on
        sta string_adress_lower
        lda #>comment_strings_on
        sta string_adress_higher

        */


        ldx comment_index
google_shit:
        lda string_adress_lower
        clc
        adc #41 // 40 + zero
        sta string_adress_lower
        bcc next_line
        inc string_adress_higher
next_line:        
        dex
        clc
        cpx #0
        bne google_shit


notfirst_line:



       jsr render_string



no_comment:



  // -----------------------------
  // PLAYFIELD MANAGEMENT
  // -----------------------------

  // -----------------------
  // PLAYFIELD ANIMATIONS
  // -----------------------
  // background animation
  jsr playfield_animate

  // -----------------------------
  // SPRITE HANDLES
  // -----------------------------

  // --------------------
  // handle sprite
  // --------------------

// jmp nobehaviour

       ldy #0 // sprite counter 012345
       ldx #$0 // object in memory 0,11,22,33...  
       lda 0  
       sta temp
supdate:
        
        // inc objects+object_x,x

        // ------------------
        // active
        // ------------------
        // active? 


        // ------------------
        // behaviors
        // ------------------
        lda objects+object_state,x
        clc
        cmp #os_active
        beq notactive_yes
        jmp nextobject
notactive_yes:     

        // BEHAVIOR: ENEMY

        lda objects+object_behavior,x


        // ENEMY - 2/3 falling! ...........
        clc
        cmp #2
        beq goon_h
        cmp #3
        beq goon_h
        jmp no_enemy_leftright
goon_h:

        // test falling
        clc
        lda objects+object_x,x
        // - offset
        sbc #10
        adc #5
        sta playfield_x
        jsr get_px

        lda objects+object_y,x
        // - offset
        clc
        sbc #50
        adc #22
        sta playfield_y
        jsr get_py

        // get playfield
        jsr get_playfield
    
        clc
        lda playfield_val
        /*
        cmp #80
        beq dontf
        */
        clc
        cmp #80
        bcc fallout
        clc
        cmp #88
        bcs fallout2
        jmp dontf
fallout2:
fallout:        


        // check for it ...

        inc objects+object_y,x
        inc objects+object_y,x
dontf:

n_e_falling:

        // inc objects+object_x,x

        // falling end 

        // enemy: right .............
        lda objects+object_behavior,x
        clc
        cmp #2
        bne enemy_right
        clc
        lda objects+object_x,x
        // - offset
        sbc #10
        adc #5
        adc #10
        sta playfield_x
        jsr get_px

        lda objects+object_y,x
        // - offset
        clc
        sbc #50
        adc #25
        sta playfield_y
        jsr get_py


        // get playfield
        jsr get_playfield
    
        clc
        lda playfield_val
        /*
        cmp #80
        bne enemy_right_no
        */
        clc
        cmp #80
        bcc fallout_x
        clc
        cmp #88
        bcs fallout2_x
        jmp farcry
fallout2_x:
fallout_x:  
        jmp enemy_right_no
farcry:              


        // check for it ...

        inc objects+object_x,x
        jmp enemy_done
enemy_right_no: 
         lda #3
        sta objects+object_behavior,x
        jmp enemy_done
enemy_right:


        // enemy: left .............
        lda objects+object_behavior,x
        clc
        cmp #3
        bne enemy_left
        clc
        lda objects+object_x,x
        // - offset
        sbc #10
        adc #5
        sbc #10
        sta playfield_x
        jsr get_px

        lda objects+object_y,x
        // - offset
        clc
        sbc #50
        adc #25
        sta playfield_y
        jsr get_py


        // get playfield
        jsr get_playfield
    
        clc
        lda playfield_val
        // left right
        /*
        cmp #80
        bne enemy_left_no
        */
        clc
        cmp #80
        bcc fallout_xx
        clc
        cmp #88
        bcs fallout2_xx
        jmp farcry_x
fallout2_xx:
fallout_xx:  
        jmp enemy_left_no
farcry_x:     

        // check for it ...

        lda objects+object_x_higher,x
        clc
        cmp #0
        bne oxt
        inc objects+object_x_higher,x
        dec objects+object_x,x
        jmp eoxt
oxt:
        lda #0
        sta objects+object_x_higher,x
eoxt:       

        jmp enemy_done
enemy_left_no: 
         lda #2
        sta objects+object_behavior,x
        jmp enemy_done
enemy_left:






enemy_done:
        jmp nextobject


no_enemy_leftright:        




            

nextobject:

       
        // + 11
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
 
        iny
        clc
        cpy #objects_count
        beq nosupdate
        jmp supdate
nosupdate:

nobehaviour: 


    // -----------------------------
    // avatar collides playfield
    // -----------------------------
    // die

    clc
    lda objects+object_x
    // - offset
    sbc #10
    adc #6
    sta playfield_x
    jsr get_px

    lda objects+object_y
    // - offset
    clc
    sbc #50
    adc #18
    sta playfield_y
    jsr get_py

    // get now the val
    jsr get_playfield


    lda playfield_val
    clc
    cmp #96
    bcc notdieing
    clc 
    cmp #104
    bcs notdieing
    
    // inc BORDER_COLOR
    jmp avatar_died

notdieing:


    // -----------------------------
    // avatar collides playfield
    // -----------------------------
    // remove things

jmp not_onafield

    clc
    lda objects+object_x
    // - offset
    sbc #10
    sta playfield_x
    jsr get_px

    lda objects+object_y
    // - offset
    clc
    sbc #50
    sta playfield_y
    jsr get_py

    // get now the val
    jsr get_playfield


        lda playfield_val
        clc
        cmp #96
        beq notonafield
        
        inc BORDER_COLOR
        clc
        lda objects+object_x
        // - offset
        sbc #10 // * 2
        cmp #0
        bcs lowerxyzt
        lda #0
    lowerxyztc:
        sta playfield_x
        jsr get_px

        lda objects+object_y
        // - offset
        clc
        sbc #50
        cmp #0
        bcs lowerxyzc
        lda #0
    lowerxyzc:
        sta playfield_y
        jsr get_py

        // render block
        lda playfield_px
        sta block_px
        lda playfield_py
        sta block_py
        lda #27

        sta block_no
        jsr render_block       


notonafield:

not_onafield:


    // avatar falling down
jmp falling_downx

    lda objects+object_x
    // adc #10
    sta playfield_x
    jsr get_px

    lda objects+object_y
    // - offset
    clc
    sbc #50
    adc #22
    sta playfield_y
    jsr get_py
    // get now the val
    jsr get_playfield
    
    clc
    lda playfield_val
    cmp #25
    beq pfxx
    inc objects+object_y
    inc objects+object_y
    inc objects+object_y
pfxx:



falling_downx:




    // --------------------
    // change playfield
    // --------------------

jmp no_changeplayfield

    clc
    lda objects+object_x
    // - offset
    sbc #10 // * 2
    cmp #0
    bcs lowerxyzt
    lda #0
lowerxyzt:
    sta playfield_x
    jsr get_px

    lda objects+object_y
    // - offset
    clc
    sbc #50
    cmp #0
    bcs lowerxyz
    lda #0
lowerxyz:
    sta playfield_y
    jsr get_py

    // render block
    lda playfield_px
    sta block_px
    lda playfield_py
    sta block_py
    lda #7
    sta block_no
    jsr render_block

no_changeplayfield:

    // ----------------------
    // avatar enters
    // a field 
    // ----------------------
    // playfield_index
    lda objects+object_x
    clc
    sbc 10
    clc
    adc #5
    sta playfield_x
    lda objects+object_y
    clc
    sbc 50
    clc
    adc #10
    sta playfield_y
    jsr get_playfield

    // avatar_playfieldindex
    lda playfield_index
    clc
    cmp avatar_playfieldindex
    bne hex
    // check entering playfield 
    
    lda playfield_val
    clc
    cmp #22
    bne not_field22
        // lda
        lda #27
        sta playfield_val
        jsr set_playfield
        lda playfield_px
        sta block_px    
        lda playfield_py
        sta block_py
        lda #24
        sta block_no
        jsr render_block
not_field22:

    // dialog
    // show_dialog
    lda playfield_val
    clc
    cmp #37
    bne not_37
    
    lda #<string0x
   sta string_adress_lower
   lda #>string0x
   sta string_adress_higher

    jsr show_dialog
not_37:

hex:
    lda playfield_index
    sta avatar_playfieldindex


    // ----------------------
    // collect objects
    // ----------------------
    // remove them afterwards

// jmp no_collect

    lda #0
    sta counter_tmp

    /*
      
        x (default)
        x (1)

        // works: problem was a wrong condition & jmp to end ..


    */

collect_3pts:

    // reset
    // lda #0
    // sta offset_neg
    lda #5 // 0
    sta offset_arg_x
    lda #0 // 10
    sta offset_arg

    lda counter_tmp
    
    clc
    cmp #1
    bne not_00
    lda #5
    sta offset_arg_x
    lda #10
    sta offset_arg
    jmp switch_done
not_00:



switch_done:

    // check now 

    clc
    lda objects+object_x
    // - offset
    clc
    sbc #10
    // x-off
    // sbc #2
    clc
    adc offset_arg_x 
    sta playfield_x
    jsr get_px
    lda objects+object_y
    // - offset
    clc
    sbc #50
    // y-off
    // sbc #2
    clc
    adc offset_arg  
    sta playfield_y
    jsr get_py

    // debug render
    /*
    lda playfield_px
    sta block_px
    lda playfield_py
    sta block_py
    // lda #7
    jsr get_playfield
    lda playfield_val
    sta block_no
    jsr render_block
    */

    // load content
    jsr get_playfield

    // exit || EXIT
    clc
    lda playfield_val
    cmp #63
    bne next_level
    
    // make an own jump area for this 
    // action_next_level
    // action_lost 
    // action_last_level
    inc level
    // lda #1
    // sta level
    // jump again (no .-) c, c++ etc
    // load it 
    jsr load_level
    jmp awake_level

next_level:    

    // rings / collect / extras
    // 104-111
    clc
    lda playfield_val
    cmp #104
    bcc no_collect_here
    clc
    lda playfield_val
    cmp #112
    bcs no_collect_here


    // border color
    // inc BORDER_COLOR

    // render block
    lda playfield_px
    sta block_px
    lda playfield_py
    sta block_py
    lda #66
    sta block_no
    jsr render_block
    
    lda #66
    sta playfield_val
    jsr set_playfield

no_collect_here:

    // counter ... 
    inc counter_tmp
    clc
    lda counter_tmp
    clc
    cmp #3
    beq no_collect
    jmp collect_3pts
no_collect:

        // -----------------------
        // avatar boundaries
        // -----------------------

jmp no_avatarboundaries

        // x: *2
        clc
        lda objects+object_x
        cmp #12
        bcs avat_lower
        lda #12
        sta objects+object_x
        jmp avat_end
avat_lower:
        cmp #159
        bcc avat_higher
        lda #159
        sta objects+object_x
        jmp avat_end
avat_higher:

avat_end:

        // y: *1
        clc
        lda objects+object_y
        cmp #engine_boundary_y_min
        bcs avat_lowery
        lda #engine_boundary_y_min
        sta objects+object_y
        jmp avat_endy
avat_lowery:
        cmp #228
        bcc avat_highery
        lda #228
        sta objects+object_y
        jmp avat_endy
avat_highery:

avat_endy:


no_avatarboundaries:

   // --------------------
   // frame
   // --------------------

   // check frame
   lda objects+object_x
   cmp #$0
   bcs bellow0x
   lda #0
   sta objects+object_x
bellow0x:




   // --------------------
   // collision
   // --------------------
   //  box collision
   //  collision 0-15
   //   |_ collisionwidth 0-15 !!!
   // 

// jmp nocollision

       // ldy #0 // sprite counter 012345
       ldx #$0 // object in memory 0,11,22,33...  
       lda #0  
       sta counterx
collision:


        // check specific object
        /*
        clc
        lda counterx
        cmp #2
        beq notspec
        inc objects+object_y,x
notspec:
   */     


        // enter_collision: check now .. 


/*
        // focus only on one 
        clc
        lda counterx
        cmp #4
        bne focus_0
*/

            // collision enter
            // check identity
            lda #0
            ldy #0
            sta countery
enter_collision:

            // no collision with yourself
           clc
           lda #counterx
           cmp #countery
           beq notthesame

/*
           // now check
           clc
           lda counterx
           cmp #0
           bne focusfirstone
*/
           // debug
           // focus on one!
         
      /*
          lda countery
          clc
           cmp #2
           bne focusfirstone
       */   

          // inc objects+object_x,x
          
          txa
          pha

              tya
              tax
              // inc objects+object_y,x
          pla
          tax

          // collide now ... 

          // < x
          clc
          lda objects+object_x,x
          clc
          // engine_mode 0
          .if (engine_mode==0) {
            adc #20
          }
          .if (engine_mode==1) {
            adc #10
          }
          cmp objects+object_x,y
          bcc smallerx
    
          // x >
          clc
          lda objects+object_x,x
          clc
          .if (engine_mode==0) {
            sbc #20
          }
          .if (engine_mode==1) {
            sbc #10
          }
          cmp objects+object_x,y
          bcs biggerx
         
          // y ^ 
          clc
          lda objects+object_y,x
          clc
          adc #20
          cmp objects+object_y,y
          bcc smallerx

          // x v
          clc
          lda objects+object_y,x
          clc
          sbc #20
          cmp objects+object_y,y
          bcs biggerx


          // inc BACKGROUND_COLOR
          // inc objects+object_y,x
          

          // not avatar
          lda counterx
          clc
           cmp #0
           bne nothere

          lda countery
          clc
           cmp #0
           beq nothere
            // / not avatar
               
          // active?
          clc
          lda objects+object_state,x
          cmp #os_active
          bne notactive

          clc
          lda objects+object_state,y
          cmp #os_active
          bne notactive

           // ----------------------------
           // collision 
           // ----------------------------

           // eatble - eat it add score
           clc
           lda objects+object_statesub,y
           cmp os_sub_friend
           bne nobonus
           inc score
           lda #$03
           sta objects+object_behavior,y
           // died
           jmp avatar_died
nobonus:
            
            // enemy - die
           clc
           lda objects+object_statesub,y
           cmp os_sub_enemy
           bne noenemy
           
           // game over
           // inc BORDER_COLOR
           // lda objects+object_x,y
           // adc #30
           // sta objects+object_x,y

           lda #0
           sta score

           // died
           jmp avatar_died

            // jmp loadActualLevel

notactive:

noenemy:


nothere:

smallerx:          
biggerx: 
smallery:          
biggery: 



 focusfirstone:
 



notthesame:


focus_0:

            // / end collision

            pha 
                tya 
                clc
                // sec
                clc
                adc #object_length // #$0b 
                tay
            pla

            clc
            inc countery
     
            // iny
            lda countery
            clc
            cmp #objects_count
            beq noenter_collision

            jmp enter_collision
noenter_collision:

// lda #5
// sta countery

        // counter x
        // + 11
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla

        clc
        inc counterx
 
        // iny
        lda counterx
        clc
        cmp #objects_count
        beq end_count
        jmp collision
      
end_count:


/*

        // debug 
        lda #5       
        sta print_x
        lda counterx
        sta print_valnumber
        jsr print_number

        // debug 
        lda #14      
        sta print_x
        lda countery
        sta print_valnumber
        jsr print_number

       // debug 
        lda #17      
        sta print_x
        lda #objects_count
        sta print_valnumber
        jsr print_number
*/

nocollision:


   // --------------------
   // render sprites 
   // --------------------
       ldx #$0 // object counter 0,11,22    
       ldy #$0 // sprite counter 0 - 16       

/*
       lda $D010       // load X-MSB
        lda #%00000000  // set extra bit for sprite #5        // lda #%11111111  // set extra bit for sprite #5
        sta $D010  
*/

srender:


        // dirty disable mode (but no change in performance)
        lda objects+object_state,x  
        clc
        cmp #os_active
        beq rs_notactive
        lda #0
        sta objects+object_x,x
        sta objects+object_y,x
rs_notactive:

 
        // positions

        // engine_mode 0
        .if (engine_mode==0) {
            lda objects+object_x,x

            sta SPRITE_BASE,y
        }

        // engine_mode 1
        .if (engine_mode==1) {
            lda objects+object_x,x
            
            // <=128
            clc
            // less <128 or >128
            cmp #128
            bcc lowerthan128

            // >128
            clc
            sbc #127
            rol
            clc

            // add ...
            adc objects+object_x_higher,x

            sta SPRITE_BASE,y


            // set the bit > 256 
            lda $D010       // load X-MSB
            // lda #%11111111  // set extra bit for sprite #5
            cpy #0
            bne notfirstsprite0
            ora #%00000001
notfirstsprite0:
            cpy #2
            bne notfirstsprite1
            ora #%00000010
notfirstsprite1:
            cpy #4
            bne notfirstsprite2
            ora #%00000100
notfirstsprite2:
            cpy #6
            bne notfirstsprite3
            ora #%00001000
notfirstsprite3:
            cpy #8
            bne notfirstsprite4
            ora #%00010000
notfirstsprite4:
            cpy #10
            bne notfirstsprite5
            ora #%00100000
notfirstsprite5:
            cpy #12
            bne notfirstsprite6
            ora #%01000000
notfirstsprite6:
            cpy #14
            bne notfirstsprite7
            ora #%10000000
notfirstsprite7:      
            sta $D010 
           


            jmp than128done
lowerthan128:
            
            // <
            // * 2
            rol
            clc
            sta SPRITE_BASE,y

            lda $D010 
            cpy #0
            bne notfirstsprite0_
            and #%11111110
notfirstsprite0_:
            cpy #2
            bne notfirstsprite1_
            and #%11111101
notfirstsprite1_:
            cpy #4
            bne notfirstsprite2_
            and #%11111011
notfirstsprite2_:
            cpy #6
            bne notfirstsprite3_
            and #%11110111
notfirstsprite3_:
            cpy #8
            bne notfirstsprite4_
            and #%11101111
notfirstsprite4_:
            cpy #10
            bne notfirstsprite5_
            and #%11011111
notfirstsprite5_:
            cpy #12
            bne notfirstsprite6_
            and #%10111111
notfirstsprite6_:
            cpy #14
            bne notfirstsprite7_
            and #%01111111
notfirstsprite7_:      
            sta $D010 

than128done:



            /*
            lda $D010       // load X-MSB
            ora #%11111111  // set extra bit for sprite #5
            sta $D010   
            */
        }        



        lda objects+object_y,x
        .if (playfield_starts_at8px==1) {
            adc #8
        }
        sta SPRITE_BASE+1,y 

       // add 10
       pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
        // iny ... +2 
        iny
        iny

        cpy #(objects_sprite*2)
        beq srenderend
        jmp srender
srenderend:

//    jsr vsync // wait for 'vsync'


/*
   // move ... 
   ldx #$0 // sprite counter in 
   lda rcounter
   lda #$40
spritehandle:
    // X ----------------   
    lda SPRITE_BASE,x
        clc
        adc #$01
        sta rcounter
    sta SPRITE_BASE,x // X ----------
    
    // Y --------------   
    lda SPRITE_BASE,x
        inx // index + 1
        lda #$C0
    // sta SPRITE_BASE,x // Y ------------
    
    // NEXT --------------
    inx 
    cpx #16
    bne spritehandle
*/



  // -----------------------------
  // KEYS INPUT
  // -----------------------------
  // https://codebase64.org/doku.php?id=base:scanning_the_keyboard_the_correct_and_non_kernal_way
  // only 2 keys at once .-( 

           // get keys
           jsr SCNKEY
           jsr GETIN

           // escape doesnt exists > E
            clc
            cmp #65+4 // run/stop
            bne no_escape
            // jmp to escape
            jmp menu_awake

no_escape: 
           // check matrix !2
/*              
            // A
            clc
            cmp #65
            bne no_a
            dec objects+object_x
no_a:  
            // D
            clc
            cmp #68
            bne no_d
            inc objects+object_x
no_d:  
*/



/*

            // SPACE TO FINISH
            clc
            cmp #$20
            bne nokey
            // jmp exit
            lda #05     
            sta BORDER_COLOR      
            sta BACKGROUND_COLOR  

            rts  // exit ... 
*/
nokey:  




            // ------------------
            // avatar & joystick  
            // ------------------
            // joystick : https://retro-programming.com/how-to-program-joystick-input-handling-on-a-c64/

           


            // character-controller: all directions

.if (false) {
    

            clc
            lda #JOY_RIGHT                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notright   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                inc objects+object_x
                inc objects+object_x
                inc objects+object_x
joystick_notright:

            clc
            lda #JOY_LEFT             // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notleft   // if not active (==1), go to .input_up_check
                lda #$33
                // jsr $ffd2   // print screen ... 
                dec objects+object_x
                dec objects+object_x
                dec objects+object_x
           
joystick_notleft:

            clc
            lda #JOY_UP                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notup   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                dec objects+object_y
                dec objects+object_y
                dec objects+object_y
joystick_notup:

            clc
            lda #JOY_DOWN                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notdown   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                inc objects+object_y
                inc objects+object_y
                inc objects+object_y
joystick_notdown:


}
            // ----------------------------------
            // character controller: jump 
            // ----------------------------------


            
            // ----------------------------------
            // character controller ns-tower
            // ----------------------------------
            // character controller: ns-tower (automatic run left & right, jump)

            // character checks 
            // + [__] +
            //   +  + 
            //   0  1  
            //  floor

            // avatar_floor0
            // avatar_floor1
            lda #0
            sta avatar_floor0
            sta avatar_floor1

            // check falling ...
            lda objects+object_x
            clc
            sbc #10
            adc #0
            // adc #5
            sta playfield_x
            jsr get_px
            lda objects+object_y
            // - offset
            clc
            sbc #50
            adc #22
            sta playfield_y
            jsr get_py
            // get now the val
            jsr get_playfield

            lda playfield_val
            /*
            cmp #80
            bne something_there
            */
            cmp #80
            bcc something_there
            clc
            cmp #88
            bcs something_there
            lda #1
            sta avatar_floor0
            jmp something_there_forsure
something_there:

            // second part
            clc
            lda objects+object_x
            sbc #10
            adc #12-1
            sta playfield_x
            jsr get_px

            jsr get_playfield

            lda playfield_val
            /*
            cmp #80
            bne something_there2
            */
            cmp #80
            bcc something_there2
            clc
            cmp #88
            bcs something_there2

            lda #1
            sta avatar_floor1
something_there2:

something_there_forsure:


            /*
            0: walking (check falling down)
            1: falling down ... 
            2: in jumpmode
            */
            lda objects+object_arg
           
            // WALKING
            // state 0
            clc
            cmp #0
            bne state_0

            // demo mode
            lda ingame_mode
            cmp #igm_auto 
            bne demo_mode_not

            // autoplay
            rndGen(%11)
            clc
            cmp #0
            bne demo_mode_not

            

            jmp avatar_jumping_now

demo_mode_not:


                clc
                lda #JOY_FIRE                // mask left movement (8 == bit 4 == %0000 1000)
                bit $DC01               // bitwise "and" with joystick port 1
                bne joystick_avatar_nt_fire   // if not active (==1), go to .input_up_check
                lda #2
                sta objects+object_arg
                // sound jump
joystick_avatar_nt_fire:

                
                // end demo mode 
                lda ingame_mode
                cmp #igm_auto 
                bne end_demomode
                jmp menu_awake
end_demomode:

                // check falling down? 
                ldy #0

                lda avatar_floor0
                clc
                cmp #1
                bne noavatar_fall_change
                ldy #1
 noavatar_fall_change:
 
                lda avatar_floor1
                clc
                cmp #1
                bne noavatar_fall_changex
                ldy #1
 noavatar_fall_changex:

                clc
                cpy #0
                bne jobsnext

avatar_jumping_now:

                lda #1
                sta objects+object_arg
jobsnext:

            jmp statedone
state_0:

            // ------------------
            // FALLLING DOWN
            // ------------------

            // falling down 
            cmp #1
            bne state_1

            inc objects+object_y
            inc objects+object_y
            inc objects+object_y
            inc objects+object_y
            inc objects+object_y

            // hit the ground?
            lda avatar_floor0
            clc
            cmp #1
            bne noavatar_fallhit
            
            lda #0
            sta objects+object_arg
            lda #0
            sta avatar_jump
            
            lda #18
               sta playfield_val
               
               //testing
               /*
               sta block_no
               lda playfield_px
               sta block_px
               lda playfield_py
               sta block_py
               jsr render_block

                // jsr set_playfield
                */

            
            lda playfield_y16
            adc #16
            adc #11
            sta objects+object_y
            

noavatar_fallhit:

/*            
            // hit the ground?
            lda avatar_floor1
            clc
            cmp #1
            bne noavatar_fallhit2
            lda #0
            sta objects+object_arg
            lda #0
            sta avatar_jump
            lda objects+object_y
            jsr get_px
            lda playfield_y16
            sta objects+object_y
noavatar_fallhit2:
*/

            jmp statedone
    
state_1:

            // jumping - step by step 
            cmp #2
            bne state_2




            // up now ... 

            // jump_algo
            lda avatar_jump
            tax

            // jump_algo 5,4,3,2,2,1,1,0
            lda jump_algo,x
            cmp #42
            bne fallnow
            lda #1
            sta objects+object_arg  
            jmp statedone                     
fallnow:            

            lda objects+object_y
            sbc jump_algo,x
            sta objects+object_y

            inc avatar_jump
            lda avatar_jump

            jmp statedone
state_2: 

statedone:



            // object_behavior

            // -----------------------
            // left & right always 
            // -----------------------
            
            // -------------
            // left 
            // -------------
            lda objects+object_behavior
            clc
            cmp #0
            bne no_avatarleft
            
            dec objects+object_x
            // +3
            lda objects+object_x_higher
            cmp #1
            bne nothigher
            dec  objects+object_x
            lda #0
            sta objects+object_x_higher
nothigher:         

        
                clc
                lda objects+object_x
                // - offset
                sbc #10
                sbc #4
                sta playfield_x
                jsr get_px

                lda objects+object_y
                // - offset
                clc
                sbc #50
                adc #18
                sta playfield_y
                jsr get_py

                // get now the val
                jsr get_playfield
                lda playfield_val

                clc 
                // 88-95
                cmp #88
                bcc no_avatar_bouncing
                clc
                cmp #95
                bcs no_avatar_bouncing


                lda #1
                sta objects+object_behavior

                    // anim
                    lda #0
                    sta objects+object_minanim
                    lda #4
                    sta objects+object_maxanim
                    
                    // lda #7
                    // sta objects+object_animtodo
                    lda objects+object_animtodo
                    clc
                    sbc #7
                    sta objects+object_animtodo

no_avatar_bouncing:

            jmp no_avatar_nstower

no_avatarleft:

            // ----------------
            // right
            // ----------------
            clc
            cmp #1
            bne no_avatarright
            inc objects+object_x

            // +3
            lda objects+object_x_higher
            cmp #1
            bne nothigherx
            inc  objects+object_x
            lda #0
            sta objects+object_x_higher
nothigherx:   


            clc
                lda objects+object_x
                // - offset
                sbc #10
                adc #9 // * 2
                sta playfield_x
                jsr get_px

                lda objects+object_y
                // - offset
                clc
                sbc #50
                adc #18
                sta playfield_y
                jsr get_py

                // get now the val
                jsr get_playfield
                lda playfield_val

                clc 
                // 88-95
                cmp #88
                bcc no_avatar_bouncing_right
                clc
                cmp #95
                bcs no_avatar_bouncing_right


                lda #0
                sta objects+object_behavior

                    // anim
                    lda #7
                    sta objects+object_minanim
                    lda #11
                    sta objects+object_maxanim
                    // lda #7
                    // sta objects+object_animtodo
                    lda objects+object_animtodo
                    clc
                    adc #7
                    sta objects+object_animtodo



no_avatar_bouncing_right:

no_avatarright:

no_avatar_nstower:



            
            lda #0
            sta BORDER_COLOR 


            // wait for vsync
            // not used if it is at all too slow
            // and it is always at max speed

     //       jsr vsync // wait for 'vsync'

    jsr vsync // wait for 'vsync'

            // restart
            jmp main_loop      // loopy loop
exit: 
            jsr clear_screen
            rts

            // back to BASIC


// --------------------------------------------------
// SUBROUTINES 
// --------------------------------------------------
clear_screen: // basic
    jsr $E544       
    rts

clear_screen_overwrite:
    
    // 4 * 10 * (3*8) * 20 
    ldx #0
bl_it:
    lda #0
    sta $8000,x
    sta $8100,x
    sta $8200,x
    sta $8300,x

    inx
    clc
    cpx #200
    bne bl_it

    rts


clear_block: .byte 1
clear_px: .byte 0
clear_py: .byte 0

clear_screen_blocks: 

    lda #13
    sta clear_py
 
cl_y:

    lda #21
    sta clear_px

cl_x:
    lda clear_block
    sta block_no
    lda clear_px
    clc
    sbc #1
    sta block_px
    lda clear_py
    clc
    sbc #1
    sta block_py
    jsr render_block
    // px
    dec clear_px
    clc
    lda clear_px
    cmp #1
    bne cl_x
    // py
    dec  clear_py
    clc
    lda clear_py
    cmp #1
    bne cl_y

    rts


disable_inputbuffers:
    lda #1
    sta $0289  //  disable keyboard buffer
    lda #127
    sta $028a  // disable key repeat
    rts

vsync:
      lda #$FF    // load 255 into A
      cmp $D012    //look if current rasterline equals 255
      bne vsync     // if no, goto wait
      rts  

blink:
    inc BACKGROUND_COLOR
    inc BORDER_COLOR
    inc FOREGROUND_COLOR
    rts

.macro vicbank(pattern) {
    lda $dd00
    and #%11111100
    ora #pattern
    sta $dd00
}

// --------------------------------------------------
// JMP ROUTINEs 
// --------------------------------------------------

avatar_died:
    // show something and wait ...
    
    inc deaths
    jsr load_level

    jmp awake_level



// --------------------------------------------------
// INTERRUPTS 
// --------------------------------------------------
irq1:
    asl $d019
    

    // inc $d020 - act. volume 
    jsr music.play 
    // dec $d020
    pla
    tay
    pla
    tax
    pla
    rti

// --------------------------------------------------
// DATA LOADING 
// --------------------------------------------------

//.if (loadPicture) {

    // vicbank(%00000011); // bank0

    *=$0c00 "ScreenRam_1"; ;            .fill picture.getScreenRamSize(), picture.getScreenRam(i)
    // color
    *=$1c00; colorRam:  .fill picture.getColorRamSize(), picture.getColorRam(i)
    // bitmap
    *=$2000;            .fill picture.getBitmapSize(), picture.getBitmap(i)

    // vicbank(%00000010); // bank1

    * = $4c00 "ScreenRam_2"; screenRam_2: 
    
    // .fill picturemen.getScreenRamSize(), picturemen.getScreenRam(i)
    

    // bitmap
    /*
    * = $6000 "Bitmap_2"; bitMap_2: .fill picturemen.getBitmapSize(), picturemen.getBitmap(i)
    // color ram
    * = $7f40 "ColorRam_2:"; colorRam_2: .fill picturemen.getColorRamSize(), picturemen.getColorRam(i)
    */


// }

.if (loadMusic) { 
    * = music.location "Music"
    .fill music.size, music.getData(i)
}


// VARIABLES
// counter
counter:
  .byte $00

// title
title_counter: .byte 0
title_colors: .byte 0,2,3,4,6,8,9,11,12,15,17
title_comment_counter: .byte 0
title_comment_index: .byte 0
title_text: .text "PRESS START TO PLAY EPIC BATTLE"
            .byte 0
title_text_clear: 
            .text "                               "
            .byte 0


// text
menu_text: .text "FIGHT THE PIXLERS"
           .byte 0
menu_text_start: 
            .text "PRESS KEY TO START"
            .byte 0



// levels and 
level: .byte 0 // actual level
score: .byte 15
lowestscore: .byte 20
deaths: .byte 0



// counter
counter_tmp: .byte $00

offset_arg: .byte $00
offset_neg: .byte $00

offset_arg_x: .byte $00



// ---------------------------------------------------
// blocks, playfield, levels
// ---------------------------------------------------

/*
    block: 16*16 (4xblocksegment)

    320x200px 
    > blocksegments 40x15* 8*8
    >> usage: 20*13 engine-blocks!

    1-20 blocks
    * 1-13 blocks

*/




// def
// blockx, blocky 
// x: 160 > 160/16 = blocksegment 16
// 

// blockline: 320x8 > 40 x 8 (byte=8px) > 20 x 16px (2segments!)



// intern
blocksegment: .byte 0 // 8 y pixel?

blockcounter: .byte 0 // 8 y pixel?
blocksegmentcounter: .byte 0

store_bmp_lower: .byte 0
store_bmp_higher: .byte 0

store_draw_lower: .byte 0
store_draw_higher: .byte 0

store_color_lower: .byte 0
store_color_higher: .byte 0


counterpx: .byte 0



// ------------------------
// render playfield
// ------------------------
// px,py playfield 

// 0-320 
// 0-200
playfield_x: .byte 0
playfield_y: .byte 0
playfield_index: .byte 0
playfield_index_higher: .byte 0 // for 4/8 field ... 


// x: 0-19
// y: 0-13
playfield_px: .byte 0
playfield_py: .byte 0

// val
playfield_val: .byte 0

// x16: 0,8,16, ...
// x16: 0,16,32, ...
playfield_x8: .byte 0
playfield_y16: .byte 0


// x > px (%8) -> x16 (%*8)
// playfield_x > playfield_px > playfield_x8
get_px:
    // rol - rol - rol 
    // left 
    pha

    // lda x
    lda playfield_x
    .if (engine_mode==1) {
      clc
      ror // /2
    }
    clc
    ror // /4
    clc
    ror // /8
    // clc
    // ror // /16
    
    
    // store
    sta playfield_px

    .if (engine_mode==1) {
        rol // *2
    }
    rol // *4
    rol // *8
    rol // *16

    // store
    sta playfield_x8   

    //
    pla

    rts

get_py:
    // left 
    pha

    // lda x
    lda playfield_y
    clc
    ror // /2
    clc
    ror // /4
    clc
    ror // /8
    clc
    ror // /16
    
    // store
    sta playfield_py

    clc
    rol // *2
    clc
    rol // *4
    clc
    rol // *8
    clc
    rol // *16

    // store
    sta playfield_y16    

    //
    pla

    rts

// get playfield 0-19,0-13

// input: playfield_px, playfield_py
// output: playfield_val

get_playfield:

    // store it
    pha
    txa
    pha

    lda playfield_py
    clc
    cmp #0
    beq nolineingtatx
    
    // work on a 
    // a = y*20+x > index
    lda #0

    // y*20 ... 
    ldx playfield_py
 gpaxx:
    adc #19 // what the fuck - why this doesnt work with 20? #wtf problem? no i
    dex 
    clc
    cpx #0
    bne gpaxx

nolineingtatx:    

    // add x
    clc
    adc playfield_px

    // store in playfield_index
    sta playfield_index

    // transfer 
    tax

    // lda
    lda act_level,x
    sta playfield_val
    
    // retrieve
    pla
    tax
    pla

    rts

// get playfield 0-19,0-13

// input: playfield_px, playfield_py, playfield_val
// output: no

set_playfield:

    // store it
    pha
    txa
    pha

    lda playfield_py
    clc
    cmp #0
    beq nolineingtat
    
    // work on a 
    // a = y*20+x > index
    lda #0

    // y*20 ... 
    ldx playfield_py
 gpax:
    adc #19 // what the fuck - why this doesnt work with 20? #wtf 
    dex 
    clc
    cpx #0
    bne gpax

nolineingtat:    

    // add x
    clc
    adc playfield_px

    // transfer 
    tax

    // lda
    lda playfield_val
    sta act_level,x
    
    // retrieve
    pla
    tax
    pla

    rts



// ------------------------
// render playfield
// ------------------------
// 8*16 blocks (4 segments)

playfield_counter: .byte 0

render_playfield:
        
        // clear screen
        // not working
        // jsr clear_screen_overwrite

        // clear with blocks
        lda #85
        sta clear_block
        jsr clear_screen_blocks

        jsr vsync
        jsr vsync
        jsr vsync
jsr vsync
        jsr vsync
        jsr vsync
    jsr vsync
        jsr vsync
        jsr vsync
    jsr vsync
        jsr vsync
        jsr vsync
    jsr vsync
        jsr vsync
        jsr vsync
        

        // bitmap (copy to)

        lda #<$2000
        .if (playfield_starts_at8px==1) {
            adc #64
        }
        sta zp_bmp_lower
        lda #>$2000
        .if (playfield_starts_at8px==1) {
            adc #1
        }
        sta zp_bmp_higher
        


        lda #<$d800 // 1 color
        .if (playfield_starts_at8px==1) {
            adc #40
        }
        sta zp_draw_lower
        lda #>$d800
        sta zp_draw_higher

        lda #<$0c00 // 2 colors
        .if (playfield_starts_at8px==1) {
            adc #40
        }
        sta zp_colorram_lower
        lda #>$0c00
        sta zp_colorram_higher

       

        // "shift" now ...

           

        // ------------------------
        // copy playfield
        // ------------------------
        ldy #0

        lda zp_bmp_lower
        sta store_bmp_lower
        lda zp_bmp_higher
        sta store_bmp_higher

        lda zp_draw_lower
        sta store_draw_lower
        lda zp_draw_higher
        sta store_draw_higher

        lda zp_colorram_lower
        sta store_color_lower
        lda zp_colorram_higher
        sta store_color_higher
        

        lda #0
        sta playfield_counter

        lda #0
        sta store_level_block_index

playfield_loop:


        // save back
        lda store_bmp_lower
        sta zp_bmp_lower
        lda store_bmp_higher
        sta zp_bmp_higher

        lda store_draw_lower
        sta zp_draw_lower
        lda store_draw_higher
        sta zp_draw_higher

        lda store_color_lower
        sta zp_colorram_lower
        lda store_color_higher
        sta zp_colorram_higher



        // 0-3
        lda #0
        sta blockcounter

        lda #0
        sta counterx
        // ------------------------
        // copy now 
        // ------------------------

        // which block?
        // ldy 
        lda store_level_block_index
        tax
        lda act_level,x
 
// todo: put act_level at page/256 border or make it indirect addressed!
        // check now block 
        clc

        // transparent 8
        cmp #8
        bne transparent
        jmp transparent_block // 0
transparent:

        
        // automatic 

        pha

        // count up ... 
        // block

        lda #<block0
        sta zp_block_lower
        lda #>block0
        sta zp_block_higher 

        pla 

        tay

        clc
        cpy #0
        beq firstelement


        // pointer
next_block:
        lda zp_block_lower
        clc
        adc #44
        sta zp_block_lower      
        bcc less256block
        inc zp_block_higher
less256block:
        dey
        cpy #0
        bne next_block

firstelement: 

        // pointer go forwards to next block

        // get starting point now ...

copy_blocks:

        // copy one block and only one!!!
        // 8x8 = 4x8pixel in multicolor

        ldy #0 // pointer 

        // copy a block (8x8pixels = 8bytes)
copy_blocksegment:

        lda (zp_block_lower),y
        sta (zp_bmp_lower),y
        
        iny
       
        clc
        cpy #8
        bne copy_blocksegment 
// ^         
        // reset
        ldy #0

        // set colors ... 
        ldx #0

        // draw/paint color
        ldy #8
        lda (zp_block_lower),y
        // lda #%00000010 // 11 > 101 _l> green
        ldy #0
        sta (zp_draw_lower),y
        
        
        // sta $d800
        // multi 1 and multi 2 color
        ldy #9
        lda (zp_block_lower),y
        // get correct shifted value!
        // lda #%00111011 // 01 + 10  // set colors
        ldy #0
        sta (zp_colorram_lower),y
        // sta $0c00


        // go forward bmp
        // add 8
        lda zp_bmp_lower
        clc
        adc #8
        sta zp_bmp_lower
        bcc z256
        inc zp_bmp_higher
z256:

        // go forward in draw/paint color
        lda zp_draw_lower
        clc
        adc #1
        sta zp_draw_lower
        bcc b256o
        inc zp_draw_higher
b256o:
        // go forward in color ram
        lda zp_colorram_lower
        clc
        adc #1
        sta zp_colorram_lower
        bcc b256h
        inc zp_colorram_higher
b256h:



        // go forward block
        lda zp_block_lower
        clc
        adc #11
        sta zp_block_lower
        bcc xyzt
        inc zp_block_higher
xyzt:



        // next line (block 3 + blockline)
        // bmp: x+32 > + 1 line - (2blocks) = (20*2)*8 = 320 = 256 + 64 - 16
        // color: x+1 > + 1 line = 40*1 = 40 - 2
        lda blockcounter
        clc
        cmp #1
        bne nextline
        clc
        inc zp_bmp_higher // + 255
        clc
        lda zp_bmp_lower
        clc
        adc #48
        sta zp_bmp_lower
        bcc lowerthan256
        inc zp_bmp_higher
lowerthan256:
        // draw color ram
        // go forward
        lda zp_draw_lower
        clc
        adc #38
        sta zp_draw_lower  
        bcc lowerthan256x
        inc zp_draw_higher
lowerthan256x:
        // color ram 
        lda zp_colorram_lower
        clc
        adc #38
        sta zp_colorram_lower        
        bcc lowerthan256xx
        inc zp_colorram_higher
lowerthan256xx:

nextline:


        // block copy
        inc blockcounter
        lda blockcounter
        clc
        cmp #4
        beq copyend
        jmp copy_blocks
copyend:

// - ^


transparent_block:

        inc store_level_block_index 


     // playfield

// --^
   
       
        // get stored things back
        ldy #0
        lda store_bmp_lower,y
        sta zp_bmp_lower
        lda store_bmp_higher
        sta zp_bmp_higher

        lda store_draw_lower
        sta zp_draw_lower
        lda store_draw_higher
        sta zp_draw_higher

        lda store_color_lower
        sta zp_colorram_lower
        lda store_color_higher
        sta zp_colorram_higher
        
     


         // move
                lda zp_bmp_lower
                clc
                adc #16
                sta zp_bmp_lower
                bcc lowerthan256xyt
                inc zp_bmp_higher
        lowerthan256xyt:   

                // draw color
                lda zp_draw_lower
                clc
                adc #2
                sta zp_draw_lower
                bcc lowerthan256xyyx
                inc zp_draw_higher
        lowerthan256xyyx:   

                // multi1/mult2 color
                lda zp_colorram_lower
                clc
                adc #2
                sta zp_colorram_lower
                bcc lowerthan256xyyyx
                inc zp_colorram_higher
        lowerthan256xyyyx:       
    
        // next line
                inc counterpx
                clc
                lda counterpx
                cmp #20
                bne nextlinexy

                lda #0
                sta counterpx

                ldx #0
                
                // bmp_lower
                lda zp_bmp_lower
                clc
                inc zp_bmp_higher // ??  + 16*20 = 320 = 256+64
                clc
                adc #64
                sta zp_bmp_lower
                bcc lowerthan256xytp
                inc zp_bmp_higher        
        lowerthan256xytp:

                // go forward - + 2x1*20 - one half done with 44 ... 
                // color
                lda zp_draw_lower
                clc
                adc #40 // 40
                sta zp_draw_lower
                bcc lowerthan256xytxt
                inc zp_draw_higher        
        lowerthan256xytxt:

                lda zp_colorram_lower
                clc
                adc #40
                sta zp_colorram_lower
                bcc lowerthan256xytxtt
                inc zp_colorram_higher        
        lowerthan256xytxtt:


        nextlinexy:


        // save back bmp 
        ldy #0
        lda zp_bmp_lower
        sta store_bmp_lower
        lda zp_bmp_higher
        sta store_bmp_higher
        ldy #0

        // save back draw color
        lda zp_draw_lower
        sta store_draw_lower
        lda zp_draw_higher
        sta store_draw_higher
        
        // save back color color
        lda zp_colorram_lower
        sta store_color_lower
        lda zp_colorram_higher
        sta store_color_higher
    
        // max 240
        inc playfield_counter 
        lda playfield_counter

        // do something each block
        /*
        clc
        cmp #20
        bne nodoit
        jsr vsync
        jsr vsync
        jsr vsync
nodoit: */
        
       
        // take the first sprite and 
        /*
        lda #0
        sta sprite_no
        lda #5 
        sta sprite_index
        jsr set_sprite
        lda tile_px
        */

        lda playfield_counter
        clc
        cmp #240
        beq endplayfield
        jmp playfield_loop

endplayfield:


        rts



/*

*/

/*

        // painting 
        ldy #3
        lda #%00000001 // 11
        sta $d800,y
        lda #%00011010 // 01 + 10 
        sta $0c00,y
      
        // painting 
        ldy #4
        lda #%00000011 // 11
        sta $d800,y
        lda #%00100001 // 01 + 10 
        sta $0c00,y
*/


// -----------------
// get_blockpxpy
// -----------------
block_index: .byte $00
block_index_ct: .byte $00

block_index_x: .byte $00
block_index_y: .byte $00

/*
get_blockpxpy_index:

    lda #0
    sta block_px
    sta block_py

    tax
    pha

    lda block_index
r_sub:
    clc
    sbc #20
    bcs l_sub
    inc block_py
    jmp r_sub
l_sub:
    
    sta block_px

    pla
    txa

    rts
*/

// -----------------
// render block
// -----------------
/*
    // input
    block_x: .byte 0
    block_y: .byte 0
    block_no: .byte 0

*/
block_px: .byte 0
block_py: .byte 0
block_no: .byte 0

render_block:
    
    // shift x
    txa
    pha

    // y * 32 !!
    lda #<block0
    sta zp_block_lower
    lda #>block0
    sta zp_block_higher 

    // search the bmp ... 
    // zp_block_lower
    lda #<$2000
    .if (playfield_starts_at8px==1) {
        adc #64
    }
     sta zp_bmp_lower
    lda #>$2000
    .if (playfield_starts_at8px==1) {
        adc #1
    }
    sta zp_bmp_higher
   
    lda #<$d800 // 1 color
    .if (playfield_starts_at8px==1) {
            adc #40
        }
    sta zp_draw_lower
    
    lda #>$d800
    sta zp_draw_higher

    lda #<$0c00 // 2 colors
    .if (playfield_starts_at8px==1) {
            adc #40
        }
    sta zp_colorram_lower
    lda #>$0c00
    sta zp_colorram_higher

    // whichblock?
    ldx block_no
wbn:

    lda zp_block_lower
    clc
    adc #44
    sta zp_block_lower      
    bcc less256blockb
    inc zp_block_higher
less256blockb:

    // --x
    dex
    clc
    cpx #0
    bne wbn


    // ok lets go forward ...
    // * 32 

lda #5
// sta block_py
    lda block_py

    clc
    cmp #0
    beq noy
    
    lda #0
    ldx block_py

rxt:
    // 20*32 = 640
    clc
    lda zp_bmp_lower
    inc zp_bmp_higher
    inc zp_bmp_higher
    clc
    adc #128
    sta zp_bmp_lower      
    bcc less256blockb2
    inc zp_bmp_higher
less256blockb2:

    // 4*20 = 80
   lda zp_draw_lower
    clc
    adc #80
    sta zp_draw_lower      
    bcc less256blockbtt4
    inc zp_draw_higher
less256blockbtt4:

   lda zp_colorram_lower
    clc
    adc #80
    sta zp_colorram_lower      
    bcc less256blockbtt5
    inc zp_colorram_higher
less256blockbtt5:


    dex
    clc
    cpx #0
    bne rxt
noy:


lda #3
// sta block_px


    // x 16 
    clc
    lda block_px


    // ==0?
    clc
    cmp #0
    beq zerozero

    // all in a
    tax

    // move x position

    // lets go through all the bmp and so 
sper:
    lda zp_bmp_lower
    clc
    adc #16
    sta zp_bmp_lower      
    bcc less256blockbt
    inc zp_bmp_higher
less256blockbt:

    lda zp_draw_lower
    clc
    adc #2
    sta zp_draw_lower      
    bcc less256blockbtt
    inc zp_draw_higher
less256blockbtt:

    lda zp_colorram_lower
    clc
    adc #2
    sta zp_colorram_lower      
    bcc less256blockbte
    inc zp_colorram_higher
less256blockbte:

    clc
    dex
    cpx #0
    bne sper

zerozero:

    // segment 0

    // let's copy the things
    // dirt plain ... 
    ldy #0
scp:    
    lda (zp_block_lower),y
    sta (zp_bmp_lower),y
    iny
    clc
    cpy #8
    bne scp

    ldy #8
    lda (zp_block_lower),y
    ldy #0
    sta (zp_draw_lower),y

    ldy #9
    lda (zp_block_lower),y
    ldy #0
    sta (zp_colorram_lower),y

    // move to segment 1! (0>1)

    clc
    lda zp_block_lower
    adc #11
    sta zp_block_lower
    bcc less256blockbtet
    inc zp_block_higher
less256blockbtet:

    clc
    lda zp_bmp_lower
    adc #8
    sta zp_bmp_lower
    bcc less256blockbtett
    inc zp_bmp_higher
less256blockbtett:

    clc
    lda zp_draw_lower
    adc #1
    sta zp_draw_lower
    bcc less256blockbtett4
    inc zp_draw_higher
less256blockbtett4:

    clc
    lda zp_colorram_lower
    adc #1
    sta zp_colorram_lower
    bcc less256blockbtett5
    inc zp_colorram_higher
less256blockbtett5:

    // segment 2

    ldy #0
scp1:    
    lda (zp_block_lower),y
    sta (zp_bmp_lower),y
    iny
    clc
    cpy #8
    bne scp1

    ldy #8
    lda (zp_block_lower),y
    ldy #0
    sta (zp_draw_lower),y

    ldy #9
    lda (zp_block_lower),y
    ldy #0
    sta (zp_colorram_lower),y

// second line
    
    // move to segement 3/4

    lda zp_block_lower
    clc
    adc #11 // 20*2-2
    sta zp_block_lower      
    bcc less256blockbttst
    inc zp_block_higher
less256blockbttst:  


    // 16*20 = 320 - 1 segment
    lda zp_bmp_lower
    inc zp_bmp_higher
    clc
    adc #64-8
    sta zp_bmp_lower      
    bcc less256blockbtts
    inc zp_bmp_higher
less256blockbtts:    


    clc
    lda zp_draw_lower
    adc #39
    sta zp_draw_lower
    bcc less256blockbtett6
    inc zp_draw_higher
less256blockbtett6:

    clc
    lda zp_colorram_lower
    adc #39
    sta zp_colorram_lower
    bcc less256blockbtett7
    inc zp_colorram_higher
less256blockbtett7:
    
    // segment 3
    
    ldy #0
scps:    
    lda (zp_block_lower),y
    sta (zp_bmp_lower),y
    iny
    clc
    cpy #8
    bne scps

    ldy #8
    lda (zp_block_lower),y
    ldy #0
    sta (zp_draw_lower),y

    ldy #9
    lda (zp_block_lower),y
    ldy #0
    sta (zp_colorram_lower),y

    // move to segment 4

 clc
    lda zp_block_lower
    adc #11
    sta zp_block_lower
    bcc less256blockbtetti
    inc zp_block_higher
less256blockbtetti:

    clc
    lda zp_bmp_lower
    adc #8
    sta zp_bmp_lower
    bcc less256blockbtetttz
    inc zp_bmp_higher
less256blockbtetttz:

    clc
    lda zp_draw_lower
    adc #1
    sta zp_draw_lower
    bcc less256blockbtett4t
    inc zp_draw_higher
less256blockbtett4t:

    clc
    lda zp_colorram_lower
    adc #1
    sta zp_colorram_lower
    bcc less256blockbtett5t
    inc zp_colorram_higher
less256blockbtett5t:


    // segment 4

    ldy #0
scpss:    
    lda (zp_block_lower),y
    sta (zp_bmp_lower),y
    iny
    clc
    cpy #8
    bne scpss

    ldy #8
    lda (zp_block_lower),y
    ldy #0
    sta (zp_draw_lower),y

    ldy #9
    lda (zp_block_lower),y
    ldy #0
    sta (zp_colorram_lower),y

    // restore
    pla
    txa

    rts 

// --------------------------
// TILE (similair charsystem)
// 4x8
// --------------------------
// vs render_playfield/blocks

// -----------------
// render tile
// -----------------
// 4x8
/*
    // input
    tile_px: .byte 0
    tile_py: .byte 0
    tile_no: .byte 0

*/
tile_px: .byte 0
tile_py: .byte 0
tile_no_lower: .byte 0  // lower higher < under 256
tile_no_higher: .byte 0


tile_number: .byte 0

// render only one number 
render_tile_number09:
    
    lda tile_number
    clc
    adc #9
    sta tile_no_lower
    jsr render_tile

    rts

tile_adress: .byte
tile_adress_higher: .byte

// string parameters ...

// ------------------
// render_string
// ------------------


// #<a
// #>b
string_adress_lower: .byte $00
string_adress_higher: .byte $00


string_x: .byte $00
string_y: .byte $00
// string_id: .byte $00 // each string has an id 

    // internal
    string_adress_tmp_lower: .byte $00
    string_adress_tmp_higher: .byte $00

    string_char: .byte $00

    string_counter: .byte $00
    string_xstart: .byte $00
    string_ystart: .byte $00


string_color_draw: .byte 0 // not 0 render with this color 
// string_color_multi: .byte 0 // 1/2 merged

render_string: // address
    
    // load string_color
    lda string_color_draw
    sta render_tile_color

    // string0x
    lda #0
    sta string_counter

nextcharxy:

    ldx string_counter

    // load and render
    /*
    lda #<string0x
    sta zp_draw_lower
    lda #>string0x
    sta zp_draw_higher
    */

    lda string_adress_lower
    sta zp_draw_lower
    lda string_adress_higher
    sta zp_draw_higher

    ldy string_counter
    lda (zp_draw_lower),y
    sta string_char
    

    // works
    /*
    ldy string_counter
    // ldy #0
    lda string0x,y
    sta string_char
    */

    // works
    // lda #65
    // sta string_char

    // stop byte
    lda string_char
    cmp #0
    beq stop_null

    // space
    clc
    cmp #32
    bne nospace
    lda #24
    jmp tile_nodirect
nospace:

default_ascii:

    clc
    sbc #65
    // add now ...
    clc 
    adc #26 // A + 
    
tile_nodirect:

    sta tile_no_lower

    lda string_x
    sta tile_px
    lda string_y
    sta tile_py
    inc string_x
    jsr render_tile
    // counter string size 
    inc string_counter
    clc
    lda string_counter
    cmp #50 // nr chars till break
    bne nextcharxy

stop_null:
    
    rts

// ------------------
// render_char
// ------------------




// ------------------
// render_tile
// ------------------

render_tile_color: .byte 0

render_tile_reset:
    lda #0
    sta render_tile_color
    rts

render_tile:
    
    // shift x
    txa
    pha

    // y * 32 !!
    lda #<block0
    sta zp_block_lower
    lda #>block0
    sta zp_block_higher 

    // search the bmp ... 
    // zp_block_lower
    lda #<$2000
    .if (playfield_starts_at8px==1) {
        adc #64
    }
    sta zp_bmp_lower
    lda #>$2000
    .if (playfield_starts_at8px==1) {
        adc #1
    }
    sta zp_bmp_higher
    
    lda #<$d800 // 1 color
    .if (playfield_starts_at8px==1) {
            adc #40
        }        
    sta zp_draw_lower
    
    lda #>$d800
    sta zp_draw_higher

    lda #<$0c00 // 2 colors
    .if (playfield_starts_at8px==1) {
            adc #40
        }
    sta zp_colorram_lower
    lda #>$0c00
    sta zp_colorram_higher

    // whichblock?
    ldx tile_no_lower
// ldx #14    

wbn_k:

    lda zp_block_lower
    clc
    adc #11
    sta zp_block_lower      
    bcc less256blockb_k
    inc zp_block_higher
less256blockb_k:

    // --x
    dex
    clc
    cpx #0
    bne wbn_k


    // ok lets go forward ...
    // * 32 

 // lda #4
 // sta tile_py

    lda tile_py

    clc
    cmp #0
    beq noy_k
  
// ^  
//  lda #2
 ldx tile_py

rxt_k:
    // 16*20 = 320
    clc
    lda zp_bmp_lower
    inc zp_bmp_higher
    clc
    adc #64
    sta zp_bmp_lower      
    bcc less256blockb2_k
    inc zp_bmp_higher
less256blockb2_k:

    // 2*20 = 40
   lda zp_draw_lower
    clc
    adc #40
    sta zp_draw_lower      
    bcc less256blockbtt4_k
    inc zp_draw_higher
less256blockbtt4_k:

   lda zp_colorram_lower
    clc
    adc #40
    sta zp_colorram_lower      
    bcc less256blockbtt5_k
    inc zp_colorram_higher
less256blockbtt5_k:


    dex
    clc
    cpx #0
    bne rxt_k
noy_k:


// lda #6
// sta tile_px


    // x 16 
    clc
    lda tile_px


    // ==0?
    clc
    cmp #0
    beq zerozero_k

    // all in a
    tax

    // move x position

    // lets go through all the bmp and so 
sper_k:
    lda zp_bmp_lower
    clc
    adc #8
    sta zp_bmp_lower      
    bcc less256blockbt_k
    inc zp_bmp_higher
less256blockbt_k:

    lda zp_draw_lower
    clc
    adc #1
    sta zp_draw_lower      
    bcc less256blockbtt_k
    inc zp_draw_higher
less256blockbtt_k:

    lda zp_colorram_lower
    clc
    adc #1
    sta zp_colorram_lower      
    bcc less256blockbte_k
    inc zp_colorram_higher
less256blockbte_k:

    clc
    dex
    cpx #0
    bne sper_k

zerozero_k:

    // segment 0

    // let's copy the things
    // dirt plain ... 
    ldy #0
scp_k:    
    lda (zp_block_lower),y
    sta (zp_bmp_lower),y
    iny
    clc
    cpy #8
    bne scp_k

    ldy #8
    lda (zp_block_lower),y
    // overwrite?    
    pha
    lda render_tile_color
    clc
    cmp #0
    bne notoverwrite_color
    pla
    jmp overwrite_col
notoverwrite_color: 
    pla
    lda render_tile_color
overwrite_col:  

    ldy #0
    sta (zp_draw_lower),y

    ldy #9
    lda (zp_block_lower),y
    ldy #0
    sta (zp_colorram_lower),y
    

    // restore
    pla
    txa

    rts 

/*
        .byte %00111100
        .byte %00011100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100
 */
      


    // --------------------------------------------------
    // VARS ... 
    // --------------------------------------------------

    mcounter: .byte $00

    rcounter: .byte $00

    spritenr: .byte $00

    temp: .byte $00

    counterx: .byte $00
    countery: .byte $00

    // avatar 

    avatar_floor0: .byte $00
    avatar_floor1: .byte $00
    avatar_jump: .byte $00
    avatar_playfieldindex: .byte $00

    // async (all at once - name wrong)
    playfield_animation_counter: .byte $00
    playfield_animation: .byte $00
    playfield_animation_x: .byte $00
    playfield_animation_y: .byte $00 
    playfield_animation_async: .byte $00

    // stepbystep
    playfield_animstep_counter: .byte $00
    playfield_animstep_x: .byte $00
    playfield_animstep_y: .byte $00

    playfield_animstep_for: .byte $00



    // --------------------------------------------------
    // OBJECTS ... 
    // --------------------------------------------------

/*

    // look for constants
    object_x
    object_y

    
*/
    // object_x depends on engine_mode ! 
    //          default 0: _x : 1/1
    //          mode 1: _x *2 + _x+1 


    objects: 
    .align 256
  
      // object 0-7
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 0
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 1
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 2
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 3
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 4
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ,$00,$00,$00,$00,$00,$00// 5
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 6
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 7

      // 8+
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00


      // curves
      // .fill 256,round(127.5+127.5*sin(toRadians(i*360/256)))
      /*

        print(".byte ");

        for (int i=0;i<180;i+=10) {
           
          float t = cos(i/360.0f*PI);
          int v = (int)(t*5);
          print(v+",");
        }

      */

jump_algo:      
      .byte 6,5,5,3,3,2,2,2,1,1,0,0,0,0,0,0,0,42
//      .byte 5,5,3,3,2,2,2,1,1,0,0,0,0,42




// ---------------------------
// anim
// ---------------------------

anim_indexer: .byte 0
anim_sprite_counter: .byte 0
anim_counter: .byte 0


// ---------------------------
// levels
// ---------------------------

// argument: level

// copy a level here from levels to act_level

level_to_load: .byte 0

load_level:
            // push things 
            // and restore 



            // copy now ...
            lda #<levels
            sta zp_draw_lower
            lda #>levels
            sta zp_draw_higher  

// jmp cp_noforward

            // add levels ...
            clc
            lda  level_to_load

            clc
            cmp #0
            beq cp_noforward

            // ldy #4 // level * 2
            ldy level_to_load
            // dey
cp_level_add:
            clc 
            // 13*20+2
            // = 260+2
            // >> 256 + 6 =background/border color)
            // inc zp_draw_higher
            clc
            lda zp_draw_lower
            // adc #12
            adc #255 // why? 
            sta zp_draw_lower
            bcs levelhigher_than256x 
            inc zp_draw_higher
levelhigher_than256x:
            
            clc
            lda zp_draw_lower
            // adc #12
            adc #6+1 // why? 
            sta zp_draw_lower
            bcs levelhigher_than256xx
            inc zp_draw_higher
levelhigher_than256xx:
            



            clc
            dey 
           cpy #0
           bne cp_level_add 
            
cp_noforward:       

            /*
            lda #<act_level
            sta zp_bmp_lower
            lda #>act_level
            sta zp_bmp_higher
            */

            // copy now
            ldy #0
            ldx #0
cp_level:
            
            lda (zp_draw_lower),y

            sta act_level,x
            // sta (zp_bmp_lower),y
            

            inx
            iny
            clc
            cpy #12*20// 240 // visible part
            bcc cp_level

            rts

// -----------------------------
// sprite 
// -----------------------------
sprite_no: .byte 0
sprite_index: .byte 0

sprite_pointer_lower: .byte 0
sprite_pointer_higher: .byte 0
spritecolor_pointer_lower: .byte 0
spritecolor_pointer_higher: .byte 0


set_sprite:

    txa
    pha
    tya
    pha
   
// ---------------------

    // copy from sprite_index
    lda #<all_sprites
    sta zp_colorram_lower    
    lda #>all_sprites
    sta zp_colorram_higher
    // sprites
    // go further
    ldx sprite_index
    clc
    cpx #0
    beq znojump
zforw:
    clc
    lda zp_colorram_lower
    clc
    adc #63
    sta zp_colorram_lower
    bcc zmorethan256jk 
    inc zp_colorram_higher
zmorethan256jk:
    clc
    dex
    cpx #0
    bne zforw
znojump:   

    // copy to sprite_no
    lda #<sprites_09
    sta zp_draw_lower
    lda #>sprites_09
    sta zp_draw_higher     
    // go further
    ldx sprite_no
    clc
    cpx #0
    beq nojump
forw:
    clc
    lda zp_draw_lower
    adc #64
    sta zp_draw_lower
    bcc morethan256jk 
    inc zp_draw_higher
morethan256jk:
    clc
    dex
    cpx #0
    bne forw
nojump:


    // copy bmpdata it

    ldx #21*3
    ldy #21*3
cp_spritet:

    clc
    clc
    dey
    // lda (all_sprites+21*3*2),y
    lda (zp_colorram_lower),y
    clc
    iny
    // lda #128
   
    clc
    dey
    sta (zp_draw_lower),y    
    clc
    iny


   // inc BORDER_COLOR


    clc
    dex 
    clc
    dey
    clc
    cpy #0
    bne cp_spritet


    // ------------
    // colors
    // ------------


    // copy sprite color
    // draw/multi1/multi2
   
    
    ldx #0
    ldy #0

 

    // fixed
    // draw/multi1/multi2
    // draw color
    ldx #0

    // add on data
    txa
        clc
        adc sprite_index
        clc
        adc sprite_index
        clc
        adc sprite_index
    tax

    lda sprites_colors,x
    ldy sprite_no
    sta $d027,y
    // multi1
    inx
    lda sprites_colors,x
    sta $d025
    // multi2
    inx
    lda sprites_colors,x
    sta $d026

    pla
    tay

    pla
    tax

    rts



// -----------------------------
// dialog
// -----------------------------
dialog_type: .byte $00  

/*
    0: show
    1: ok
    2: yes - no
    3: ...
    
*/

dialog_id: .byte $00
dialog_x: .byte $00
dialog_y: .byte $00
dialog_time: .byte $00
dialog_answer: .byte $00


show_dialog:
    
    // show dialog ... 

    // wait for button up
    clc
jnofire:    
    lda #JOY_FIRE                // mask left movement (8 == bit 4 == %0000 1000)
    bit $DC01               // bitwise "and" with joystick port 1
    beq jnofire   // if not active (==1), go to .input_up_check

    // show text
    
       // set up
       lda #10
       sta string_x
       lda #7
       sta string_y
       // render ... 4 
       lda #<string0x
       sta string_adress_lower
       lda #>string0x
       sta string_adress_higher
       jsr render_string


    // wait for decision 
    // left - right - ok

    // --------------------
    // OK 
    // --------------------
    // ok ...
jnofireok:    
    // inc BORDER_COLOR
    lda #JOY_FIRE                // mask left movement (8 == bit 4 == %0000 1000)
    bit $DC01               // bitwise "and" with joystick port 1
    bne jnofireok   // if not active (==1), go to .input_up_check
dia_wait:


    // simplest
    jsr render_playfield

    
dia_wait_done:
    


    rts

// -----------------------------
// strings
// -----------------------------



// show direct whole text
comment_counter: .byte 0 // 0-100
comment_accum: .byte 0  // 1-20

comment_index: .byte 0
comment_max: .byte 3


// show char by char (realtime)
comment_char_mode: .byte 0 // 0: display text / 1: overwrite space 
comment_char_index: .byte 0

comment_char_pointer_lower: .byte 0
comment_char_pointer_higher: .byte 0

comment_char_print: .byte 0, 0

// strings ....

string0:

string0x:
.text "DEMOTEXT LIKE DEMO"
.byte 0

comment_strings:

    //     0123456789012345678901234567890123456789


    .text "THIS IS A DEMO WITH A GAME              "
    .byte 0

    .text "YOU DONT HAVE TO PLAY                   "
    .byte 0

    .text "THE GAME IS OPTIONAL                    "
    .byte 0

    .text "TO MAKE RETRO IN A TIME OF RETRO  HORROR"
    .byte 0

    .text "ENJOY THE TEXT ABOUT CODING GAMES       "
    .byte 0

    .text "JUST TIME TO GET BACK IN TIME           "
     .byte 0

    .text "HOHO                                    "
    .byte 0

    .text "KING KONG                               "
    .byte 0

    .text "JO MAN JO                               "
    .byte 0

    .text "TERENCE HILL LIVES                      "
    .byte 0

    .text "THEY WORKED WITH ONLY 8BIT IN CALCS     "
    .byte 0
    
    .text "SCREENS: MULTICOLOR 40X25 X 4X8 PIXS    "
    .byte 0
    
    .text " CREATING A GAME WITH C64 IS HORROR     "
    .byte 0

// --------------------------------------------------
// MACROS 
// --------------------------------------------------
.macro rndGen(mask) {
    // see http://sta.c64.org/cbm64mem.html
    // first we read the current raster line (0-255)
    lda $d012
    // then we xor it with timer A (low byte)
    // see https://www.c64-wiki.com/wiki/CIA
    eor $dc04
    // then we subtract it with timer A (high byte)
    clc
    sbc $dc05
    // finally we mask it so we can have a number between 0 and bits^2
    and #mask
}

.function toSpritePtr(addr) {
   .return (addr&$3FFF)/64
}


.align 64

// single color
spritePtrs:
.byte toSpritePtr(sprite_0), toSpritePtr(sprite_1)
.byte toSpritePtr(sprite_2), toSpritePtr(sprite_3)
.byte toSpritePtr(sprite_4), toSpritePtr(sprite_5)
.byte toSpritePtr(sprite_6), toSpritePtr(sprite_7)

// you can use http://spritemate.com/ to edit these
// just press file->save file->kick ass(hex) once you designed your sprite


// be carefull with the address you chose for your sprites. two notes:
// 1. it needs to be divisible by 64 - see above - you can use the .align 64 if it helps
// 2. it needs to be in the same video block where you want to display them
//    the c64 has four video blocks $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff

// ! SINGLE COLORS SPRITES
// $b60
* = $b60-32 "Sprites"; // address $b60 means that this sprites can only be used with the screen on block $0000-$3fff


// memory for sprite patterns needs to be divisible by 64 - see above why


// sprite 0 / singlecolor / color: $01

// all sprites

*=$900

sprites_09:

.align 64



/*
sprite0:
        .byte 0,0,0,0,0,0,0,0,0,0,0,0,63,0,0,63,0,0,63,0,0,63,0,0,63,85,0,63,85,0,0,85,0,0,85,0,0,85,0,0,85,170,0,85,170,0,0,170,0,0,170,0,0,170,0,0,170,0,0,170,0,0,0

// +1


*/

sprite_0:
sprite_avatar:

.byte $255,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01

sprite_1:

.byte $255,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01

sprite_2:

.byte $255,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01

sprite_3:

.byte $255,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01

sprite_4:

.byte $255,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01

sprite_5:

.byte $255,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01

sprite_6:

.byte $255,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01

sprite_7:

.byte $255,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01


*=$1400 


.align 64
all_sprites:

#import "sprites.asm"


all_sprites_x:

// -----------------------------
// levels & blocks
// -----------------------------
*=$1200


store_level_block_index: .byte 0

store_level_lower: .byte 0
store_level_higher: .byte 0

// todo ... > set to a 256/page 

act_level: 

    
        .byte 1,1,2,3,4,5,1,2,3,4, 0,0,0,0,0,0,0,0,0,0
        .byte 0,1,1,1,1,1,1,1,1,1, 0,0,0,0,0,0,0,0,0,1
        .byte 0,1,2,3,4,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 0,0,0,2,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,2,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,2,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,2,2,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,2,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,2,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,2,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,1,1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,1,1
       
        .byte 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0

    

// levels
*=$6000
levels:

// block: 16x16 pixels - 2x2 screenblocks
// levels here 20x13 

level0:
        #import "level0.asm"
level1:
        #import "level1.asm"

level2:
        #import "level2.asm"

level3: 
        #import "level3.asm"

level4: 
        #import "level4.asm"

level5:
        #import "level5.asm"

level6:
        #import "level6.asm"

level7:
        #import "level7.asm"

level8:
        #import "level8.asm"

level9:
        #import "level9.asm"

level10:
        #import "level10.asm"

level11:
        #import "level11.asm"

level12:
        #import "level12.asm"

level13:
        #import "level13.asm"

level14:
        #import "level14.asm"

level15:
        #import "level15.asm"

level16:
        #import "level16.asm"

level17:
        #import "level17.asm"

level18:
        #import "level18.asm"

level19:
        #import "level19.asm"


/*
        .byte 0,1,2,3,4,0,1,2,3,4, 0,0,0,0,0,0,0,0,0,0
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,1,1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,1,1
       
        .byte 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0
*/

// block (playfield)
// block: 4 blocksegments
//        blocksegment: data for multicolor 8x4 + 3 colors 
// 1 2
// 3 4 
//
// blocksegment-size: 8+3 = 11 
// blocksize: 4*11
/*
        // 1. block segment        
        .byte 85,191,165,165,165,165,165,165
        // () text/char color, multi 1, multi 2
        .byte 5,13,7
*/


// > use https://petscii.krissz.hu
// chars - select one > bytes are down in the info > copy them to your project
// or export  [>]
// colors export code 


// blocks: 

/*
 // 1. block segment        
        .byte 85,191,165,165,165,165,165,165
        // background, char color, multi 1, multi 2
        .byte 1,12,11

        // 2. block segment
        .byte 85,253,93,93,93,93,93,93
        .byte 1,12,11
        
        // 3. block segment
        .byte 165,165,165,165,165,165,170,170
        .byte 1,12,11
        
        // 4. block segment
        .byte 93,93,93,93,93,93,169,169
        .byte 1,12,11
*/

// block0:

*=$4000
#import "blocksall.asm"

// ---------------------------
// comments
// ---------------------------

comment_step_y: .byte 24

comment_step_color: .byte 0

comment_stepper_reset:
    lda #0
    sta string_color_draw
    rts

comment_stepper:

  // ----------------------------
  // COMMENT SYSTEM STEPBYSTEP
  // ----------------------------
// jmp nocommentstepper 

  lda comment_step_color
  sta string_color_draw

  inc comment_counter
  lda comment_counter
  clc
  cmp #1
  beq bexx
  jmp no_comment_step
bexx:  
  lda #0
  sta comment_counter
  
  inc comment_accum
  lda comment_accum
  clc
  cmp #2
  beq bex
  jmp no_comment_step
bex:

  lda #0
  sta comment_accum

  // pos x
  lda comment_char_index  
  sta string_x


  // 0-40 print
  lda comment_char_index
  clc
  cmp #40
  bcs print_end
   // ... 
   // lda #67
   // sta comment_char_print

   // dynamic
   lda comment_char_pointer_lower
   sta zp_draw_lower
   lda comment_char_pointer_higher
   sta zp_draw_higher

   lda comment_char_index
   tay
   lda (zp_draw_lower),y
    sta comment_char_print
   jmp print_endecho
print_end:
   // overwrite old 
   lda comment_char_index  
   clc
   sbc #40
   sta string_x
   lda #32
   sta comment_char_print
print_endecho:



    // set up print 
    lda #<comment_char_print
    sta string_adress_lower
    lda #>comment_char_print
    sta string_adress_higher

    lda comment_step_y
    sta string_y

    jsr render_string

    // cursor
    /*
    lda string_x
    inc string_x
    sta tile_px
    lda #24
    sta tile_py
    lda #200
    sta tile_no_lower
    jsr render_tile
    */
    


  // go through the chars
  inc comment_char_index
  clc
  lda comment_char_index
  cmp #80
  bne nottheendmyfriend
  
  lda #0
  sta comment_char_index

  // add 40 here ... 
  // next line
  lda comment_char_pointer_lower
  clc
  adc #41
  sta comment_char_pointer_lower
  bcc nomoregoogle
  inc comment_char_pointer_higher
nomoregoogle:

  inc comment_index
  // cmp
  lda comment_index
  clc
  cmp #12 // string amounts
  bne noadd_term
      lda #0
      sta comment_index
      lda #<comment_strings
      sta comment_char_pointer_lower
      lda #>comment_strings
      sta comment_char_pointer_higher

noadd_term:

nottheendmyfriend:

no_comment_step:

nocommentstepper: 

rts

// modes
ingame_mode: .byte 0 
     

// ----------------------------
// playfield animation
// ----------------------------

// animate the playfield

// 1. sync
// 2. async

playfield_animate:

  // -----------------------------
  // PLAYFIELD ANIAmTON
  //  STEPS BY STEPS
  // GOING THROUGH THE PLAYFIELD
  // -----------------------------
  // CANT BE PART OF GAMEPLAY
  // ONLY BACKGROUND
// jmp ani_fornextn  
  
  lda #20*1 // 1 line 
  sta playfield_animstep_for

ani_fornext: 

  inc playfield_animstep_counter
//  cmp #3
//  bne astep_no

  lda #0
  sta playfield_animstep_counter
  // go forward 1 
  inc playfield_animstep_x
  clc
  lda playfield_animstep_x
  cmp #20
  bne astep_nexty
  lda #0
  sta playfield_animstep_x
  inc playfield_animstep_y
  lda playfield_animstep_y
  cmp #12
  bne astep_nexty
  lda #0
  sta playfield_animstep_y
astep_nexty:

  // lets do the checks > changes ...
  lda playfield_animstep_x
  sta playfield_px
  lda playfield_animstep_y
  sta playfield_py
  jsr get_playfield

  // check ... 
  clc
  lda playfield_val    

  cmp #128
  bcc noanim_step
  clc
  cmp #128+8
  bcs noanim_step

      // random 
      rndGen(%1)
      clc 
      cmp #0
      bne astep_no

      lda playfield_val
      // 0-8
      sbc #128

      // 2bit animation
      // %2 == 0 > add 1
      // %2 == 1 > sbc 1

      // /2
      clc
      ror
      bcc mod2 // %2 ==0
      dec playfield_val
      jmp end_mod
mod2:
      inc playfield_val
end_mod:
        jsr set_playfield

        lda playfield_val
        sta block_no
        lda playfield_px
        sta block_px
        lda playfield_py
        sta block_py
        jsr render_block

          jmp anim_done
    no_128: 

anim_done:

noanim_step:

astep_no:

   // for next
   dec playfield_animstep_for
   lda playfield_animstep_for
   clc
   cmp #0
   beq ani_fornextn
   jmp ani_fornext
ani_fornextn:
    
  // -----------------------------
  // PLAYFIELD ANIM ALL TOGETHER
  // -----------------------------
  // animate all togehter
  // whole playfield 
// jmp noplayfieldanimation

  // take one each frame
  inc playfield_animation_async


  // animations sync
  inc playfield_animation
  lda playfield_animation
  cmp #10
  bne no_playfieldanimations
  lda #0
  sta playfield_animation

  lda #0
  sta playfield_animation_x
  sta playfield_animation_y

  lda #0 
  sta playfield_animation_counter

pymg:
 
  lda playfield_animation_counter
  tax
  lda act_level,x

  // check animations --------

  // check animations


  // 20
  clc
  cmp #112
  bne pa_x20
  lda #113
  sta act_level,x
  sta block_no
  // update block
  lda playfield_animation_x
  sta block_px
  lda playfield_animation_y
  sta block_py
  jsr render_block
  jmp pa_anim_done
pa_x20:

  // 17
  clc
  cmp #113
  bne pa_x21
  lda #112
  sta act_level,x
  sta block_no
  // update block
  lda playfield_animation_x
  sta block_px
  lda playfield_animation_y
  sta block_py
  jsr render_block
  jmp pa_anim_done
pa_x21:

pa_anim_done:

  inc playfield_animation_x
  lda playfield_animation_x
  cmp #20
  bne not20
  lda #0
  sta playfield_animation_x
  inc playfield_animation_y  
not20:


  inc playfield_animation_counter
  lda playfield_animation_counter
  clc
  cmp #240
  bne pymg

no_playfieldanimations:

noplayfieldanimation:

    rts