// ****************************************
// GAME TEMPLATE
// IN KICK ASSEMBLER
// EXPERIMENTAL ARCHEOLOGY
// CONFOEDERATIO LUDENS
// 
// ****************************************
// Fullfeatured 2 loaded screen > look at ... _featured!


// GAMEDESIGN NEEEDS
// SIMPLE FUNCTIONS:
// - IF THEN, LOOP, INC, DEC
// - INPUT
// - OUTPUT
// (- SPRITES/SCROLLING/COLLISION) OR DO IT YOURSELF


// CODE SNIPETS
// https://codebase64.org/doku.php?id=start


/*
    TOO BIG CONSOLE ((24+320) x (200+50)pixel) WITH A TOO SMALL HEART  (8bit 6502)  
    DATAMANAGEMENT HORROR!
*/

/*

    ENGINE MODE 

    engine_mode:           // 0 normal mode: spritex only 0-256
                            // 1 extended mode: spritex 0-320: 
                            //
                            //   spritex: 100 + 1 >> 200 + 1 = 201
                            //            byte 1 (0-160): x (*2)  > 129*2
                            //            byte 2 (0/1): + 0/1   > +1    >> 258+1 > 259
                            //            spritecollision: /2 
                            //

    SPRITES:
    x = 24   [24-320+24]
    y = 50   [50-50+200]


    INGAME SCREEN MODE

    engine_ingamescreen         // 0: char-mode *
                                // 1: chars - Extended Colour Mode / ECM / Extended color mode * - not many tiles!
                                // 2: color bitmap 
                                // * not yet working with ingame menu screen switch etc



*/

.var  engine_mode   = 1 // 1

.var engine_ingamescreen = 2 // only 2 available .. 

// TODO: DRAW BITMAP
// https://www.youtube.com/watch?v=AGR2-tAYXFw


// COMPILING (FOR FASTER DEV)
.var loadPicture = true // > by hand ! search for loadPicture
.var loadMusic = true

// CONTROL 1-10 as joystick input1Ω

// PROCESSOR: 6502 :-( (Why not the original 680x? yes to expensive!)
// VIC-II: Graphic chip
// SID: Programmable sound chip

// EMULATION: VICE-USAGE
// - drag&drop
// - F10
// - cursors (0-10)

// KICK ASSEMLBER
// ASSEMBLER WITH SCRIPTING FUNCTIONS
// http://www.theweb.dk/KickAssembler/webhelp/content/ch12s03.html

// EXAMPLES
// https://codebase64.org/doku.php?do=search&id=base%3Areading_the_keyboard&q=print


/*

    # ASSEMBLER-HINTS

    160x200 in multicolor 

    only 8bit ... > problems with sprite x etc .-(

    page: 256bytes 

    command             : local
    command xyz         : command memory
    command xyz,index   : command memory+index

    inc
    dec 

    clc - clear add on state bits ! (for ror,rol,etc)

    clc
    lda #100
    adc #200 - add (reset flag before)
    bcs morethan256 
    // do the staff 
    // add 1 to possible 8-16bit byte
    // use a for the rest .. 
    morethan256:  

        // example 
            lda #100
            lda #10
            clc
            adc #200
            // depends on carryflag

            bcs morethan256 
            inc BACKGROUND_COLOR
        morethan256:

            bcc lessthan256 
            // is more - more is in a
            inc BORDER_COLOR
        lessthan256:

    // adding over 256
    // use carry flag
    //  
    // a: 200+60 > a: 4 and carryflag = true 
    // 
    clc 
    lda #100
    adc #200
    // result 44 or 45 + carry flag !!!
    // check carry flag !

    // add > 255
    // add 1 directly and than the rest!



    // calculating with pointers (no other way!)

        // zero page - calculating with pointers (only possibility!)
        // fe - 00
        // ff - 04
        // (fe) access ($0400)

        // Most programmers use $02 to $06 and/or $FB to $FE.

        // lowbyte  lda #<$0400
        //          sta $fe
        // highbyte sta #>$0400
        // etc.

        // https://technology-blog.net/c64-assembler-programmierung-zeropage-und-addressing-modes/

        indirect registers .-(

        a lot of defined things https://www.c64-wiki.de/wiki/Zeropage
        $fb+ 
        indirect adressing mit zero page

        LDA ($FE),Y // load fe und ff > absolute adress ... 
        STA ($fe),Y
        // indirect adressing with y!
        vs LDA($FE,Y) - (FE+Y)

        // 00 + 04 > 0400
          lda #$00
          sta $fe
          lda #$04
          sta $ff
          // c
          lda #3
          sta ($fe),y

        // clean the screen (not splitted)
            lda #$00
            sta $10
            lda #$02
            sta $11
        fill:
            ldy #0
            lda #$ff
        loop:
            sta ($10), y
            iny
            bne loop
            lda $11
            clc
            adc #$01
            cmp #$06
            beq done
            sta $11
            bne fill
        done:   


    txa - transfer x to a
    tya - transfer a to x

    
    // value ohne # !!!!
    // > %10001
    // > 10
    // > 00

    // sub 10
    clc
    sbc #10


    // stack
    pha (PusH Accumulator)        
    // do something 
    pla (PuLl Accumulator)          

    / indexing
    sta xyz,4 // store in acummlator-adresse xyz[4]
    lda xyz,5 // load into accumulator xyz[4]

    clc
    cmp #20,x
    bne bxt // not ...

    think invers:

    == bne
    != beq


    bne : not equal
    beq : equal
    blt : lower than (flags!)
    bcc : less
    bcs : higher or same

    bit (compare)

    
bxt:

    ror - '*2'
    rol - '/2'

    http://www.6502.org/tutorials/6502opcodes.html#ROR

*/

/*

    THE ARCHITECTURE OF C64

    VIDEORAM:

        vicbank(%00000011)  defines where the VIDEORAM IS!
        [VIDEORAM (IS SOMEHOW ORGANISED IN 8x8 BLOCKS .-( ))]
        [VIDEORAM]+1016 > POINTERS TO ! THE SPRITES! [SPRITE0][SPRITE1]...

        [POSITIONS ABSOLUTE!]

    // DESIGNDECISIONS?

*/

//VIDEO RAMS ADDRESSES
// POSSIBLE: $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff
// https://www.c64-wiki.com/wiki/Screen_RAM
// $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff etc
// ... 
// vicbank(%00000011);
// vicbank(%00000010); // bank1
/*
    lda $dd00
    and #%11111100
    ora #pattern
    sta $dd00 // store there

 */ 

// MODES:
// - CURSOR MODE - ASCII 
//   - start AT $4000 (SCREENRAM)

// - GRAPHIC MODE - ALSO BLOCKS (COLORRAM)
//   - STARTS AT $D800

/*
    8x4 > next 8x4 > next 8x4
    [ ] > [ ] > [ ]


*/

// - HIGHRES: 320x200 
// - LOWRES: 160x200 - MULTICOLOR 

// GRAPHICS PAINT
// https://mcdraw.xyz

// CONVERT PICS TO C64 COLOR PALETTE
// https://www.micheldebree.nl/retropixels/

// SPRITE PAINT (Multicolor)
// multicolor: https://beta.spritemate.com
// you can use http://spritemate.com/ to edit these
// just press file->save file->kick ass(hex) once you designed your sprite


// HELPERS
// DEC TO HEX
// https://www.rapidtables.com/convert/number/decimal-to-hex.html?x=214


// DEMO EXAMPLE
// https://github.com/celso/c64/blob/master/card.asm (including sprite management etc)
// GOOD FOR STARTING (this is a mix from this and other tutorials)

// RANDOM
// rndGen(%1111);
// sta $d027,x  // into x 



// MUSIC

// playing SID music has 3 parts:
// 0. load music
// 1. you use use Kick Assembler's LoadSid to import the .sid file
// 2. you call music.init
// 3. you call music.play in every raster interrupt
// see http://www.theweb.dk/KickAssembler/webhelp/content/ch12s03.html and the README.md

// ----------------------
// MINIMAL VARS/CONST
// ----------------------

.var  BORDER_COLOR   = $D020
.var  BACKGROUND_COLOR    = $D021
.var  FOREGROUND_COLOR = $E536

.var  SPRITE_0_X_POSITION = $D000 // only for ascii screen !!!! 
.var  SPRITE_0_Y_POSITION = $D001
.var  SPRITE_0_POINTER    = $0400 + $03F8 // Last 8 Bytes of Screen RAM
.var  SPRITE_0_DATA       = $0340         // Block 13, 13*64=>832 => $0340
.var  SPRITE_UPPER_X      = $D010   // X-MSB
.var  SPRITE_0_COLOR      = $D027 

// VRAM (different places - definable)
// SPRITES: VRAM START AND $3F8

 .var SCNKEY     = $ff9f   // scan keyboard - kernal routine
 .var GETIN      = $ffe4   // read keyboard buffer - kernal routine

            // ----------------------
            // MAX VARIABLES
            // ----------------------


            // *******************************************************************************
            // *** Farben                                                                  ***
            // *******************************************************************************
            .var COLOR_BLACK         = $00           // schwarz
            .var COLOR_WHITE         = $01           // weiß
            .var COLOR_RED           = $02           // rot
            .var COLOR_CYAN          = $03           // türkis
            .var COLOR_PURPLE        = $04           // lila
            .var COLOR_GREEN         = $05           // grün
            .var COLOR_BLUE          = $06           // blau
            .var COLOR_YELLOW        = $07           // gelb
            .var COLOR_ORANGE        = $08           // orange
            .var COLOR_BROWN         = $09            // braun
            .var COLOR_PINK          = $0a           // rosa
            .var COLOR_DARKGREY      = $0b           // dunkelgrau
            .var COLOR_GREY          = $0c           // grau
            .var COLOR_LIGHTGREEN    = $0d           // hellgrün
            .var COLOR_LIGHTBLUE     = $0e           // hellblau
            .var COLOR_LIGHTGREY     = $0f           // hellgrau

            // zone Sprites
            // *******************************************************************************
            // *** Die VIC II Sprite Register  -  ANFANG                                   ***
            // *******************************************************************************
            // THESE ARE ABSOLUT REGISTERS > NOT THE DATA! 
            .var SPRITE_BASE         = $d000
            .var SPRITE0X            = $d000         // (00) X-Position von Sprite 0
            .var SPRITE0Y            = $d001         // (01) Y-Position von Sprite 0
            .var SPRITE1X            = $d002         // (02) X-Position von Sprite 1
            .var SPRITE1Y            = $d003         // (03) Y-Position von Sprite 1
            .var SPRITE2X            = $d004         // (04) X-Position von Sprite 2
            .var SPRITE2Y            = $d005         // (05) Y-Position von Sprite 2
            .var SPRITE3X            = $d006         // (06) X-Position von Sprite 3
            .var SPRITE3Y            = $d007         // (07) Y-Position von Sprite 3
            .var SPRITE4X            = $d008         // (08) X-Position von Sprite 4
            .var SPRITE4Y            = $d009         // (09) Y-Position von Sprite 4
            .var SPRITE5X            = $d00a         // (10) X-Position von Sprite 5
            .var SPRITE5Y            = $d00b         // (11) Y-Position von Sprite 5
            .var SPRITE6X            = $d00c         // (12) X-Position von Sprite 6
            .var SPRITE6Y            = $d00d         // (13) Y-Position von Sprite 6
            .var SPRITE7X            = $d00e         // (14) X-Position von Sprite 7
            .var SPRITE7Y            = $d00f         // (15) Y-Position von Sprite 7
            .var SPRITESMAXX         = $d010         // (16) Höhstes BIT der jeweiligen X-Position
                                                //         da der BS 320 Punkte breit ist reicht
                                                //         ein BYTE für die X-Position nicht aus// 
                                                //         Daher wird hier das 9. Bit der X-Pos
                                                //         gespeichert. BIT-Nr. (0-7) = Sprite-Nr.
            .var SPRITEACTIVE        = $d015         // (21) Bestimmt welche Sprites sichtbar sind
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDOUBLEHEIGHT  = $d017         // (23) Doppelte Höhe der Sprites
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDEEP          = $d01B         // (27) Legt fest ob ein Sprite vor oder hinter
                                                //         dem Hintergrund erscheinen soll.
                                                //         Bit = 1: Hintergrund vor dem Sprite
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEMULTICOLOR    = $d01c         // (28) Bit = 1: MultiColor Sprite 
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEDOUBLEWIDTH   = $d01d         // (29) Bit = 1: Doppelte Breite des Sprites
                                                //         Bit-Nr. = Sprite-Nr.
            .var SPRITEMULTICOLOR0   = $d025         // (37) Spritefarbe 0 im Multicolormodus
            .var SPRITEMULTICOLOR1   = $d026         // (38) Spritefarbe 1 im Multicolormodus
            .var SPRITE0COLOR        = $d027         // (39) Farbe von Sprite 0
            .var SPRITE1COLOR        = $d028         // (40) Farbe von Sprite 1
            .var SPRITE2COLOR        = $d029         // (41) Farbe von Sprite 2
            .var SPRITE3COLOR        = $d02a         // (42) Farbe von Sprite 3
            .var SPRITE4COLOR        = $d02b         // (43) Farbe von Sprite 4
            .var SPRITE5COLOR        = $d02c         // (44) Farbe von Sprite 5
            .var SPRITE6COLOR        = $d02d         // (45) Farbe von Sprite 6
            .var SPRITE7COLOR        = $d02e         // (46) Farbe von Sprite 7

            .var SPRITE0DATA         = $07f8         // Sprite-Pointer für die Sprite-0-Daten
            // *******************************************************************************
            // *** Die VIC II Sprite Register  -  ENDE                                     ***
            // *******************************************************************************

            // zone VIC
            .var VICBASE             = $d000         // (RG) = Register-Nr. dezimal
            .var VICRASTERROWPOS     = $d012         // (18) Aktuelle Rasterzeile lesen oder setzen
            .var VICBORDERCOLOR      = $d020         // (32) Bildschirmrandfarbe
            .var VICBACKGROUNDCOLOR  = $d021         // (33) Hintergrundfarbe

            // zone CIA
            .var CIA1_A              = $dc00         // Adresse des CIA1-A
            .var CIA1_B              = $dc01         // Adresse des CIA1-B
            .var CIA1_CLOCK_TENTH    = $dc08         // Adresse zehntel Sekunden (Uhrzeit) im CIA1
            .var CIA1_CLOCK_SECONDS  = $dc09         // Adresse Sekunden (Uhrzeit) im CIA1

            // zone SID
            // *******************************************************************************
            // *** Die SID Register  -  ANFANG                                             ***
            // *******************************************************************************
            .var SID_BASE            = $d400         // (Nr) Basisadresse des SID_BASE
            .var SID_VOICE1_FREQ_MSB = $d401         // (01) 1. Stimme: High-Byte der Frequenz
            .var SID_VOICE1_WAVEFORM = $d404         // (04) 1. Stimme: Wellenform
            .var SID_SUSTAIN_RELEASE = $d406         // (06) BIT 7-4: Anschlag (sustain)
                                                //          3-0: Abschwellen (release)
            .var SID_VOLUME          = $d418         // (24) BIT   7: 3. Stimme Filtermodus AUS
                                                //            6:   -''-    Hochpass
                                                //            5:   -''-    Bandpass
                                                //            4:   -''-    Tiefpass
                                                //          3-0: Lautstärke

            .var SID_WAVE_TRIANGLE   = $11           // Wellenform: Dreieck
            .var SID_WAVE_SAWTOOTH   = $21           // Wellenform: Sägezahn
            .var SID_WAVE_PULSE      = $41           // Wellenform: Rechteck
            .var SID_WAVE_WHITENOISE = $81           // Wellenform: Rauschen
            // *******************************************************************************
            // *** Die SID Register  -  ENDE                                               ***
            // *******************************************************************************

            // zone Zeropage
            .var ZP_SCREENRAMADR     = $02           // Zeichen-Quelle fürs BS-Kopieren (drawscreen:)
            .var ZP_COLORRAMADR      = $04           // Farb-Quelle fürs BS-Kopieren    (drawscreen:)
            .var ZP_SCREENTODRAW     = $06           // Zeichen-Ziel fürs BS-Kopieren   (drawscreen:)
            .var ZP_COLORTODRAW      = $08           // Farb-Ziel fürs BS-Kopieren      (drawscreen:)
            .var ZP_LOOPHELPER       = $f8           // Die letzten 8 BYTES für Schleifen reservieren

            // zone Kernal
            .var JT_GETIN            = $ffe4         // Kernalfunktion: Zeichen lesen

            // zone Generic
            .var SCREENRAMADR        = $0400         // Beginn des Bildschirmspeichers
            .var COLORRAMADR         = $d800         // Beginn des Farbspeichers
            .var INPUT_NONE          = $00           // Es wurde noch kein Port gewählt
            .var INPUT_JOY1          = $01           // Joystick in Port-1
            .var INPUT_JOY2          = $02           // oder 2
            .var JOY_UP              = %00000001     // Joystick rauf
            .var JOY_DOWN            = %00000010     // Joystick runter
            .var JOY_LEFT            = %00000100     // Joystick links
            .var JOY_RIGHT           = %00001000     // Joystick rechts
            .var JOY_FIRE            = %00010000     // Joystick FEUER// 



// --------------------------------------------
// LOAD DATA
// --------------------------------------------

// Music (<3k!)
// Attention: Reload Emulators to test other music!!

.var music = LoadSid("music7.sid") 

// Graphics
// https://mcdraw.xyz
//.if (loadPicture) {
  
  
    // .var picture = LoadBinary("image.koa", BF_KOALA)
    // .var picture = LoadBinary("minimalpicture.kla", BF_KOALA) // less loading

  // .var picture = LoadBinary("image.kla", BF_KOALA)
  .var picture = LoadBinary("white.kla", BF_KOALA)

    .var picturemen = LoadBinary("squarez_menu.kla", BF_KOALA)
//}

// --------------------------------------------------
// INIT
// --------------------------------------------------

// *=$0801 "Basic Program"
BasicUpstart2(start)


 // the address $0001 holds and sets the 6510 CPU's on-chip port register
    // %x10: RAM visible at $A000-$BFFF; KERNAL ROM visible at $E000-$FFFF
    // what we're saying here is we don't need the BASIC ROM after we start
    // see https://www.c64-wiki.com/wiki/Zeropage
    lda #%00110110
    sta $0001


// --------------------------------------------------
// INIT 
// --------------------------------------------------
*= $c000 "Program" // no idea why ..

start:

    // MULTIMEDIA

    // music: init 1
    .if (loadMusic) { 
        lda #music.startSong-1 // set up the music
        jsr music.init
    }

    // setup: raster music
    sei

        .if (loadMusic) { 
          lda #<irq1
          sta $0314
          lda #>irq1
          sta $0315
          lda #$1b
          sta $d011
          lda #$80
          sta $d012
          lda #$7f
          sta $dc0d
          sta $dd0d
          lda #$81
          sta $d01a
          lda $dc0d
          lda $dd0d
          asl $d019
        }

      cli


    // CLEAR SCREEN
    // jsr clear_screen

     // disable input buffers     
     jsr disable_inputbuffers


// ------------------------------------
// Testsuite for codes
// ------------------------------------

// comment: code (concept, idea) and working code (tested)
// bne etc are like i++ 

jmp  nottestsuite

testsuite:
    
    lda #100
    lda #10
    clc
    adc #200
    // depends on carryflag

    bcs morethan256 
    inc BACKGROUND_COLOR
morethan256:

    bcc lessthan256 
    // is more - more is in a
    inc BORDER_COLOR
lessthan256:

    jmp testsuite

nottestsuite:

// ------------------------------------
// asciiloop (SHOWS 'ASCII' MODE)
// ------------------------------------
// of course: it is no ascii!!!!
// different format like zx81 etc
 





jmp noascii // disable 'ASCII'    
   
    // background, frame color
      lda #$04     
      sta BORDER_COLOR      
      lda #$07
      sta BACKGROUND_COLOR  
      // set FOREGROUND_COLOR (COLOR CAN BE DIFFERENT IN EACH LINE!)
      lda #$09
      sta FOREGROUND_COLOR


      // ----------------
      // ASCII 
      // ----------------
      // indirect addressing
      // calculation with and

     // lda #$2   // #$20 is the spacebar Screen Code
     // sta $0400,x  // fill four areas with 256 spacebar characters

     lda #$00
     sta $fe
     lda #$04
     sta $ff
     // c
     lda #3
     ldy #0
     sta ($fe),y

     lda #$0400 // indexing 
     sta $fe  // store here ... 
     lda #4
     ldy #0
     // inc $ff  // add 256   > $0500 (another page)
     // adc ($fe)  - only adds ... value from zero page ($fe)

     sta ($fe),y


/*
     // indirect

      // fe & ff > FFfe
      // 00 & 04 > 0400
      lda #$00
      sta $fe
      lda #$04
      sta $ff


      ldx #0 // for x=0,x<4
dorest:

     ldy #0 // for y=0,y<40
oxp:
     lda #3
     tya
     sta ($fe),y
     iny
     clc
     cpy #40
     bne oxp

     inc $ff

     clc 
     cpx #4
     bne dorest
*/

     // indirect 
     // 


     // wait
iascci:
      // jmp iascci


      // ----------------
      // ASCII / PRINT
      // ----------------
     
      // charset: https://www.c64-wiki.de/wiki/Zeichen

      // print - show a character
      lda #$d6                //  load character '_' into register A
      jsr $ffd2               //  print character to screen
      // print at // ... 
      // https://medium.com/@RetroAsmDev/c-64-part-4-ascii-art-a4319784d26
      
  

        
        // WRITE INTO SCREEN MEMORY

        // ASCII: 40x25 > 1000bytes > $0400-$07F7
        // - example: https://dustlayer.com/c64-coding-tutorials/2013/4/8/episode-2-2-writing-to-the-c64-screen

        // SINGLE COLOR CHARS !!!
            
        // FILL ALL WITH CHARS


        // all the same
        ldx #$00
        ldy #$00
clear:    
         lda #$41    // #$20 is the spacebar Screen Code
         sta $0400,x  // fill four areas with 256 spacebar characters
         sta $0500,x 
         sta $0600,x 
         sta $06e8,x 
         lda #$04     // set foreground to black in Color Ram 
         sta $d800,x  
         sta $d900,x
         sta $da00,x
         sta $dae8,x
         inx           // increment X
         bne clear    


        // write direct in the screen
        ldx #$ff
    directscreen:  
        lda #$04 
        sta $0400,x
        dex
        bne directscreen
        
        // just print one char somewhere
        lda #$d8
        ldx #$20
        sta $0400,x

waitx:
//         jmp waitx


        // ASCII MULTICOLOR
        // Extended Colour Mode

        //  set to 25 line text mode and turn on the screen
        lda #$1B
        sta $D011

        //  disable SHIFT-Commodore
        lda #$80
        sta $0291

        //  set screen memory ($0400) and charset bitmap offset ($2000)
       // lda #$18
       // sta $D018

        //  set border color
        lda #$00
        sta $D020
        
        //  set background color
        lda #$00
        sta $D021

        //  turn on multicolor mode
        lda #$D8
        sta $D016

        //  set multicolor 1
        lda #$0C
        sta $D022

        //  set multicolor 2
        lda #$0B
        sta $D023

        lda #68
        sta $0400

asciiloop: 
        jsr vsync // wait for 'vsync'

        jsr SCNKEY
        jsr GETIN


/*
        ldx #$00
        ldy #$00

        ldy counter
        inc counter

        lda #$00        
clearcolhere:    
         lda #$67     // #$20 is the spacebar Screen Code
         sta $0400,x  // fill four areas with 256 spacebar characters
//         sta $0500,x 
//         sta $0600,x 
//         sta $06e8,x 
         // lda #$08     // set foreground to black in Color Ram 
         // iny
         // tya

         lda #$12    
         sta $d800,x  
         // iny
         // tya
         sta $d900,x
         // iny
         // tya
         sta $da00,x
         // iny
         // tya
         sta $dae8,x
         inx           // increment X
         bne clearcolhere   

*/



        // SPACE TO FINISH
        cmp #$20
        bne noinfokey
            // lda #05     
            // sta BORDER_COLOR      
            // sta BACKGROUND_COLOR  
            
            lda #$d6                //  load character '_' into register A
            jsr $ffd2               //  print character to screen
              
            jmp noascii
noinfokey:

        // PRINTING 
        // https://dustlayer.com/c64-coding-tutorials/2013/4/8/episode-2-4-reading-from-a-data-table



        // ------------------
        // blink  
        // ------------------
    
        // inc BACKGROUND_COLOR
        //  inc BORDER_COLOR
        //  inc FOREGROUND_COLOR
        
        jmp asciiloop



noascii:
        

        jsr blink


      // ----------------
      // GRAPHIC MODE
      // ----------------

        jsr blink

// vicbank(%00000011);


        vicbank(%00000010); // bank1



        // -----------------------------
          // IMAGE COPY
          // -----------------------------

    //   .if (engine_ingamescreen==0) {
             // copy picture 
                
                lda #$38
                sta $d018
                
                lda #$d8
                sta $d016
                
                lda #$3b
                sta $d011
                
                lda #0
                sta $d020
                
                lda #picture.getBackgroundColor()
                sta $d021
                
                ldx #0
        copycat:
                .for (var i=0; i<4; i++) {
                   lda colorRam+i*$100,x
                   sta $d800+i*$100,x // colorram 
                }
                inx
                bne copycat
 
  //  }


 // -----------------------------
  // OBJECTS
  // -----------------------------

    .const objects_count = 14 // 14

    .const objects_sprite = 8 // 0-x are sprites rest something else triggers

    // object struct 

    .const object_length = $0c // length 

    .const object_x = 0 // + 1 byte!

    /* 

        X-MSB

        sprite: 256+x

        256 + 40 

        LDA $D010       ; load X-MSB
        ORA #%00100000  ; set extra bit for sprite #5
        STA $D010       ; write X-MSB register
    */

    .const object_y = 2
    .const object_w = 4
    .const object_h = 5

    .const object_type = 6  // 0 nothing 1 sprite 2 block 3 trigger

        .const ot_nothing = 0
        .const ot_sprite = 1
        .const ot_block = 2
        .const ot_trigger = 3


    .const object_state = 7

        .const os_active = 0 // inactive
        .const os_inactive = 1 // active

    .const object_statesub = 8 // 0 neutral - 1 friend - 2 enemy 

        .const os_sub_neutral = 0
        .const os_sub_friend = 1
        .const os_sub_enemy = 2


    .const object_arg = 9
    .const object_behavior = 10 // 0 - no behaviour 1: player1 2: player 2 3: reset 4+: up left etc .. 
    .const object_spr = 11
    .const object_anim = 12

 // -----------------------------
  // SPRITE SETUP
  // -----------------------------
 
    // ALL SINGLE COLOR
    lda #%00000000
    // lda #%11111111
    sta $d01c // all sprites are of type 'single color'
    // card: $D015/53269  acts like a "switch" that turns one of the eight sprites "on" or "off"
    // swith all on 
    lda #%11111111
    sta $d015 // all eight sprites on (all bits set)

    // cards: the location of the sprite pointers (see sprites.asm) follows that of the text screen plus 1016/$3F8
     // this will iterate the 8 sprite pointers, load their values (see sprites.asm) and set screen addresses with them
    // see https://www.c64-wiki.com/wiki/Sprite#Sprite_pointers


      jsr blink




// --------------------------------------------------
// MENU-LOOP
// --------------------------------------------------

jmp nomenu

    // vicbank(%00000011); // bank0
    vicbank(%00000010); // bank1 - MENU

    lda #00   
    sta BORDER_COLOR      
    sta BACKGROUND_COLOR  

    lda 0
    sta mcounter

menu_loop:

    jsr vsync   

    // mcounter
    inc mcounter
    lda mcounter
    clc
    cmp #50
    bne mnext
    lda #0
    sta mcounter
    inc BACKGROUND_COLOR
    inc BORDER_COLOR
mnext:

    // space
    jsr SCNKEY
    jsr GETIN
          
    // SPACE TO FINISH
    cmp #$20
    bne menu_nokey
    jmp nomenu
menu_nokey:     


    jmp menu_loop

nomenu:


// --------------------------------------------------
// GAME-LOOP 
// --------------------------------------------------


    // set background
    lda #00   
    sta BORDER_COLOR      
    sta BACKGROUND_COLOR  


// ---------------------------
// GAMELOOP: SPRITE RESET 
// ---------------------------
// spritespixel def: pointer VRAM+1016!
// reset all/them all 



    // $D01C/53276 sprites can be high resolution or multicolor mode - bits at 0 sets them to high res
    // see https://www.c64-wiki.com/wiki/Sprite
    lda #%00000000 // single color
    lda #%11111111 // multi color
     sta $d01c // all sprites are of type 'single color'

    // $D015/53269  acts like a "switch" that turns one of the eight sprites "on" or "off"
    // see https://www.c64-wiki.com/wiki/Sprite
    lda #%11111111
    sta $d015 // all eight sprites on (all bits set)

    // FIND WHERE THEY POINT
        ldx #$8
    !loop:
        lda spritePtrs,x
        sta $0c00 + 1016,x
        dex
        bpl !loop-

    // --------------------------
    // STRANGE COLOR SYSTEM
    // --------------------------
    // sprite colors ...

    lda #$0a // sprite multicolor 1
    sta $D025
    lda #$08 // sprite multicolor 2
    sta $D026


    lda #$01 // sprite multicolor 2
    sta SPRITE0COLOR

    lda #$07 // sprite multicolor 2
    sta SPRITE1COLOR
    sta SPRITE2COLOR
    sta SPRITE3COLOR
 
    lda #$02 // sprite multicolor 2
    sta SPRITE4COLOR
    sta SPRITE5COLOR
    sta SPRITE6COLOR
    sta SPRITE7COLOR




   // --------------------------
    // SPRITES
    // --------------------------
 
    // --------------------
    // setup
    // --------------------

setup_menu:
 
       ldy #$0 // sprite nr ... 
       ldx #$0 // sprite counter 0,11,22,33,44 etc ...   
       lda 0  
       sta temp // x pos ... 
ssetting:
        
    
        // positions
        // char position
        
        lda temp
        // rndGen(%1111111)
        sta objects+object_x,x
        // lda #$80
        // rndGen(%1111111)
        sta objects+object_y,x
        
    

        // line
        lda temp
        clc
        adc #$18
        sta temp
        
        // object_behavior

        // all inactive
        lda os_inactive
        sta objects+object_state,x

        // active all hardwaresprites
        cpy #$08
        bcs notanymoreactive
        lda os_active
        sta objects+object_state,x  

notanymoreactive:

        // >0
        cpy #$01
        bcc end_check

        /*
        // random behavior
        rndGen(%111)
        sta objects+object_behavior,x
        ora 1
        */
        lda #3 // reset everything here ... 
        sta objects+object_behavior,x
        

        // default enemies
        lda os_sub_enemy
        sta objects+object_statesub,x    

 
        // <3
        cpy #$04
        bcs enemies
        // eatable
        lda os_sub_friend
        sta objects+object_statesub,x
enemies:       
        

        


end_check:
    



        // add indices 
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
        iny
        cpy #objects_count
        bne ssetting

        // --------------------
        // direct settings
        // --------------------
        // avatar
        .var sprnr=0
        lda #$a0
        sta objects+(sprnr*object_length)+object_x
        sta objects+(sprnr*object_length)+object_y

/*        
        .eval sprnr=1
        lda #$01
        sta objects+(sprnr*object_length)+object_behavior
        
        .eval sprnr=2
        lda #$02
        sta objects+(sprnr*object_length)+object_behavior
        
        .eval sprnr=3
        lda #$03
        sta objects+(sprnr*object_length)+object_behavior

        .eval sprnr=4
        lda #$04
        sta objects+(sprnr*object_length)+object_behavior

        .eval sprnr=5
        rndGen(%11)
        sta objects+(sprnr*object_length)+object_behavior
        ora 1
    
*/
        


// ------------------------
// MAIN_LOOP
// ------------------------

// SET 
vicbank(%00000011); // bank0
// vicbank(%00000010); // bank1 - MENU

    // ascii mode ...
    .if (engine_ingamescreen==0) {

        lda #7
        sta BORDER_COLOR
        lda #1
        sta BACKGROUND_COLOR
        lda #4
        sta FOREGROUND_COLOR

        // disable .. graphic mode
        // disable bitmap mode
        lda #$1b
        lda #%00011011
        // lda #%00011111
        // lda #%11111111
        sta $D011

       lda #$D8
        sta $D016

        //  set multicolor 1
        lda #$0C
        sta $D022

        //  set multicolor 2
        lda #$0B
        sta $D023



        // The pointers to the character set and the screen character memory both reside in address 53272/$D018

//  set screen memory ($0400) and charset bitmap offset ($2000)
       // lda #$18
       // sta $D018
  
//    *=$0c00 "ScreenRam_1"; ;            .fill picture.getScreenRamSize(), picture.getScreenRam(i)
    // color
//    *=$1c00; colorRam:  .fill picture.getColorRamSize(), picture.getColorRam(i)
    // bitmap
  //  *=$2000;            .fill picture.getBitmapSize(), picture.getBitmap(i)


        //   
        //   ldy #$18     // screen at $0400, bitmap at $2000
        //   sta $d011
      
          // set VIC to bank 3
          lda $DD00
          and #$fc
          // sta $dd00
  
          ldx #0
again:
          lda #244
          txa
          sta $2000,x

         lda #127

         sta $2000+300,x
    
         txa
         // lda #%00111011 
         sta $0400,x // screen ram
         
          inx
          clc
          cpx #160 // 2 lines ... 
          bne again

         


    }


        // Extended Color Mode 
    .if (engine_ingamescreen==1) {



    }

   // --------------------------
   // PLAYFIELD ALIAS LEVELS
   // --------------------------
   
   lda #0
   sta block_x
   lda #0   
   sta block_y
   lda #1
   sta block_no
   jsr render_block
   
   // render playground
   // jsr render_playfield


// --------------------
// mainloop
// --------------------

main_loop:
  

   
    // inc BORDER_COLOR

   // --------------------
   // gui
   // --------------------

/*
        lda #4
        sta print_x
        lda #11
        sta print_valnumber
        jsr print_number
 
        // painting 
        ldy #3
        lda #%00000001 // 11
        sta $d800,y
        lda #%00011010 // 01 + 10 
        sta $0c00,y
      
        // painting 
        ldy #4
        lda #%00000011 // 11
        sta $d800,y
        lda #%00100001 // 01 + 10 
        sta $0c00,y
                
*/
        // flicker
     jmp noflackerforex

 inc FOREGROUND_COLOR
inc BACKGROUND_COLOR
inc BORDER_COLOR

noflackerforex:


        lda #20        
        sta print_x
        lda score
        sta print_valnumber
        jsr print_number

        lda #30        
        sta print_x
        lda level
        clc
        adc #$01
        sta print_valnumber
        jsr print_number
        
  // -----------------------------
  // SPRITE HANDLES
  // -----------------------------

  // --------------------
  // handle sprite
  // --------------------

// jmp nobehaviour

       ldy #0 // sprite counter 012345
       ldx #$0 // object in memory 0,11,22,33...  
       lda 0  
       sta temp
supdate:
        // inc objects+object_x,x

        // ---------------------
        // reset ?
        // ---------------------
        lda objects+object_behavior,x
        clc
        cmp #$03
        beq resetnow
        jmp noreset
resetnow:

        // -----------------------
        // reset behaviours 
        // -----------------------

        // default - right
        lda #$04
        sta objects+object_behavior,x

        // speed
        lda #$0
        rndGen(%1)
        sta objects+object_arg,x

        // ---------------
        // default right
        // ---------------
        // default x / y 

        lda #20// 10*2 = 20
        sta  objects+object_x,x
        lda #0 // #50
        rndGen(%01111111)
        clc
        // lda #0 // #50
        cmp #50 // 50
        bcs toosmally
        clc
        adc #50
toosmally:
        sta  objects+object_y,x

// jmp resetdone


        // rnd behaviour
        rndGen(%11)
        clc

        // ---------------
        // right
        // ---------------
        cmp #$00
        bne right
        jmp resetdone

right:
        // ---------------
        // left
        // ---------------
        cmp #$01
        bne rightleft
        lda #5 
        sta objects+object_behavior,x
        lda #30 // (50+320)/2 = 185
        sta  objects+object_x,x
        
        // y comes from y-pos
        jmp resetdone

rightleft:


        // ---------------
        // down
        // ---------------

        // downup
        cmp #$02
        bne updown
        lda #6
        sta objects+object_behavior,x
 
        lda #0
        rndGen(%01111111)
        clc
        adc #0
        sta  objects+object_x,x 

        lda #60
        sta  objects+object_y,x
        jmp resetdone

updown:

// jmp nextobjectreset

// jmp nextobjectreset

        // ---------------
        // up
        // ---------------

        // downup
        cmp #$03
        bne downup
        lda #7
        sta objects+object_behavior,x

        lda #0
        rndGen(%01111111)
        clc
        adc #0
        sta  objects+object_x,x
  
        lda #230
        sta  objects+object_y,x
        jmp resetdone
downup:

        
nextobjectreset:

        // problem nothing found 

        lda #3
        sta objects+object_behavior,x  

        inc BORDER_COLOR

        // default .. 
        // lda #4
        // sta objects+object_behavior,x  


resetdone:        
noreset:        
     

        // ------------------
        // behaviors
        // ------------------


        // BEHAVIOR RIGHT 4

        lda objects+object_behavior,x
        clc
        cmp #$04
        bne up_right
        inc objects+object_x,x
        // lda objects+object_x,x
        // adc level
        lda objects+object_arg,x
        clc 
        cmp #1
        bcc uprightfast
        inc objects+object_x,x
uprightfast:
        // biggerthan
        lda objects+object_x,x
        clc
        cmp #20+140 // 20+160 // 160 
        bcc up_right

         lda #0
        sta objects+object_x,x
        sta objects+object_y,x


        lda #$03
        sta objects+object_behavior,x
        jmp nextobject
up_right:        

        // BEHAVIOR LEFT 5
        clc
        cmp #$05
        bne up_left
        dec objects+object_x,x
        lda objects+object_arg,x
        clc 
        cmp #1
        bcc upleftfast
        dec objects+object_x,x
upleftfast:        
        // biggerthan
        lda objects+object_x,x
        clc
        cmp #30
        bcs up_left

         lda #0
        sta objects+object_x,x
        sta objects+object_y,x

        lda #$03
        sta objects+object_behavior,x
        jmp nextobject

up_left:        

        // BEHAVIOR DOWN 6
        clc
        cmp #$06
        bne up_down
        inc objects+object_y,x
        lda objects+object_arg,x
        clc 
        cmp #1
        bcc updownfast
        inc objects+object_y,x
updownfast:
        // biggerthan
        lda objects+object_y,x
        clc
        cmp #230
        bcc up_down


         lda #0
        sta objects+object_x,x
        sta objects+object_y,x

        lda #$03
        sta objects+object_behavior,x  
 

        jmp nextobject   

up_down:        


// jmp nextobject

        // BEHAVIOR UP

        clc
        cmp #$07
        bne up_up
        dec objects+object_y,x
        dec objects+object_y,x
        lda objects+object_arg,x
        clc         
        cmp #1
        bcc updownx
        dec objects+object_y,x
        dec objects+object_y,x
updownx:         
        // biggerthan
        lda objects+object_y,x
        clc
        cmp #60
        bcs up_up
        lda #$03
        sta objects+object_behavior,x

        lda #0
        sta objects+object_x,x
        sta objects+object_y,x

        jmp nextobject
up_up:        

nextobject:

       
        // + 11
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
 
        iny
        clc
        cpy #objects_count
        beq nosupdate
        jmp supdate
nosupdate:

nobehaviour: 


     // -----------------------
        // avatar boundaries
        // -----------------------

        // x: *2
        clc
        lda objects+object_x
        cmp #12
        bcs avat_lower
        lda #12
        sta objects+object_x
        jmp avat_end
avat_lower:
        cmp #159
        bcc avat_higher
        lda #159
        sta objects+object_x
        jmp avat_end
avat_higher:

avat_end:

        // y: *1
        clc
        lda objects+object_y
        cmp #50
        bcs avat_lowery
        lda #50
        sta objects+object_y
        jmp avat_endy
avat_lowery:
        cmp #228
        bcc avat_highery
        lda #228
        sta objects+object_y
        jmp avat_endy
avat_highery:

avat_endy:

   // --------------------
   // frame
   // --------------------

   // check frame
   lda objects+object_x
   cmp #$0
   bcs bellow0x
   lda #0
   sta objects+object_x
bellow0x:




   // --------------------
   // collision
   // --------------------
   //  box collision
   //  collision 0-15
   //   |_ collisionwidth 0-15 !!!
   // 

// jmp nocollision

       // ldy #0 // sprite counter 012345
       ldx #$0 // object in memory 0,11,22,33...  
       lda #0  
       sta counterx
collision:


        // check specific object
        /*
        clc
        lda counterx
        cmp #2
        beq notspec
        inc objects+object_y,x
notspec:
   */     


        // enter_collision: check now .. 


/*
        // focus only on one 
        clc
        lda counterx
        cmp #4
        bne focus_0
*/

            // collision enter
            // check identity
            lda #0
            ldy #0
            sta countery
enter_collision:

            // no collision with yourself
           clc
           lda #counterx
           cmp #countery
           beq notthesame

/*
           // now check
           clc
           lda counterx
           cmp #0
           bne focusfirstone
*/
           // debug
           // focus on one!
         
      /*
          lda countery
          clc
           cmp #2
           bne focusfirstone
       */   

          // inc objects+object_x,x
          
          txa
          pha

              tya
              tax
              // inc objects+object_y,x
          pla
          tax

          // collide now ... 

          // < x
          clc
          lda objects+object_x,x
          clc
          // engine_mode 0
          .if (engine_mode==0) {
            adc #20
          }
          .if (engine_mode==1) {
            adc #10
          }
          cmp objects+object_x,y
          bcc smallerx
    
          // x >
          clc
          lda objects+object_x,x
          clc
          .if (engine_mode==0) {
            sbc #20
          }
          .if (engine_mode==1) {
            sbc #10
          }
          cmp objects+object_x,y
          bcs biggerx
         
          // y ^ 
          clc
          lda objects+object_y,x
          clc
          adc #20
          cmp objects+object_y,y
          bcc smallerx

          // x v
          clc
          lda objects+object_y,x
          clc
          sbc #20
          cmp objects+object_y,y
          bcs biggerx


          // inc BACKGROUND_COLOR
          // inc objects+object_y,x
          

          // not avatar
          lda counterx
          clc
           cmp #0
           bne nothere

          lda countery
          clc
           cmp #0
           beq nothere
            // / not avatar
               
          // active?
          clc
          lda objects+object_state,x
          cmp os_active
          bne notactive

          clc
          lda objects+object_state,y
          cmp os_active
          bne notactive

           // ----------------------------
           // collision 
           // ----------------------------

           // eatble - eat it add score
           clc
           lda objects+object_statesub,y
           cmp os_sub_friend
           bne nobonus
           inc score
           lda #$03
           sta objects+object_behavior,y
nobonus:
            
            // enemy - die
           clc
           lda objects+object_statesub,y
           cmp os_sub_enemy
           bne noenemy
           
           // game over
           inc BORDER_COLOR
           // lda objects+object_x,y
           // adc #30
           // sta objects+object_x,y

           lda #0
           sta score

notactive:

noenemy:


nothere:

smallerx:          
biggerx: 
smallery:          
biggery: 



 focusfirstone:
 



notthesame:


focus_0:

            // / end collision

            pha 
                tya 
                clc
                // sec
                clc
                adc #object_length // #$0b 
                tay
            pla

            clc
            inc countery
     
            // iny
            lda countery
            clc
            cmp #objects_count
            beq noenter_collision

            jmp enter_collision
noenter_collision:

// lda #5
// sta countery

        // counter x
        // + 11
        pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla

        clc
        inc counterx
 
        // iny
        lda counterx
        clc
        cmp #objects_count
        beq end_count
        jmp collision
      
end_count:


/*

        // debug 
        lda #5       
        sta print_x
        lda counterx
        sta print_valnumber
        jsr print_number

        // debug 
        lda #14      
        sta print_x
        lda countery
        sta print_valnumber
        jsr print_number

       // debug 
        lda #17      
        sta print_x
        lda #objects_count
        sta print_valnumber
        jsr print_number
*/

nocollision:


   // --------------------
   // render sprites 
   // --------------------
       ldx #$0 // object counter 0,11,22    
       ldy #$0 // sprite counter 0 - 16       

/*
       lda $D010       // load X-MSB
        lda #%00000000  // set extra bit for sprite #5        // lda #%11111111  // set extra bit for sprite #5
        sta $D010  
*/

srender:


 
        // positions

        // engine_mode 0
        .if (engine_mode==0) {
            lda objects+object_x,x
            sta SPRITE_BASE,y
        }

        // engine_mode 1
        .if (engine_mode==1) {
            lda objects+object_x,x
            
            // <=128
            clc
            // less <128 or >128
            cmp #127
            bcc lowerthan128

            // >128
            clc
            sbc #127
            rol
            clc
            sta SPRITE_BASE,y


            // set the bit > 256 
            lda $D010       // load X-MSB
            // lda #%11111111  // set extra bit for sprite #5
            cpy #0
            bne notfirstsprite0
            ora #%00000001
notfirstsprite0:
            cpy #2
            bne notfirstsprite1
            ora #%00000010
notfirstsprite1:
            cpy #4
            bne notfirstsprite2
            ora #%00000100
notfirstsprite2:
            cpy #6
            bne notfirstsprite3
            ora #%00001000
notfirstsprite3:
            cpy #8
            bne notfirstsprite4
            ora #%00010000
notfirstsprite4:
            cpy #10
            bne notfirstsprite5
            ora #%00100000
notfirstsprite5:
            cpy #12
            bne notfirstsprite6
            ora #%01000000
notfirstsprite6:
            cpy #14
            bne notfirstsprite7
            ora #%10000000
notfirstsprite7:      
            sta $D010 
           


            jmp than128done
lowerthan128:
            
            // <
            // * 2
            rol
            clc
            sta SPRITE_BASE,y

            lda $D010 
            cpy #0
            bne notfirstsprite0_
            and #%11111110
notfirstsprite0_:
            cpy #2
            bne notfirstsprite1_
            and #%11111101
notfirstsprite1_:
            cpy #4
            bne notfirstsprite2_
            and #%11111011
notfirstsprite2_:
            cpy #6
            bne notfirstsprite3_
            and #%11110111
notfirstsprite3_:
            cpy #8
            bne notfirstsprite4_
            and #%11101111
notfirstsprite4_:
            cpy #10
            bne notfirstsprite5_
            and #%11011111
notfirstsprite5_:
            cpy #12
            bne notfirstsprite6_
            and #%10111111
notfirstsprite6_:
            cpy #14
            bne notfirstsprite7_
            and #%01111111
notfirstsprite7_:      
            sta $D010 

than128done:



            /*
            lda $D010       // load X-MSB
            ora #%11111111  // set extra bit for sprite #5
            sta $D010   
            */
        }        


        lda objects+object_y,x
        sta SPRITE_BASE+1,y 

       // add 10
       pha 
            txa 
            clc
            adc #object_length // #$0b 
            tax
        pla
        // iny ... +2 
        iny
        iny

        cpy #(objects_sprite*2)
        beq srenderend
        jmp srender
srenderend:

//    jsr vsync // wait for 'vsync'


/*
   // move ... 
   ldx #$0 // sprite counter in 
   lda rcounter
   lda #$40
spritehandle:
    // X ----------------   
    lda SPRITE_BASE,x
        clc
        adc #$01
        sta rcounter
    sta SPRITE_BASE,x // X ----------
    
    // Y --------------   
    lda SPRITE_BASE,x
        inx // index + 1
        lda #$C0
    // sta SPRITE_BASE,x // Y ------------
    
    // NEXT --------------
    inx 
    cpx #16
    bne spritehandle
*/



  // -----------------------------
  // KEYS INPUT
  // -----------------------------
  // https://codebase64.org/doku.php?id=base:scanning_the_keyboard_the_correct_and_non_kernal_way
  // only 2 keys at once .-( 

           // get keys
           jsr SCNKEY
           jsr GETIN

           // check matrix !2
/*              
            // A
            clc
            cmp #65
            bne no_a
            dec objects+object_x
no_a:  
            // D
            clc
            cmp #68
            bne no_d
            inc objects+object_x
no_d:  
*/


/*

            // SPACE TO FINISH
            clc
            cmp #$20
            bne nokey
            // jmp exit
            lda #05     
            sta BORDER_COLOR      
            sta BACKGROUND_COLOR  

            rts  // exit ... 
*/
nokey:  




            // ------------------
            // joystick  
            // ------------------
            // joystick : https://retro-programming.com/how-to-program-joystick-input-handling-on-a-c64/

            clc
            lda #JOY_RIGHT                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notright   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                inc objects+object_x
                inc objects+object_x
                inc objects+object_x
joystick_notright:

            clc
            lda #JOY_LEFT             // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notleft   // if not active (==1), go to .input_up_check
                lda #$33
                // jsr $ffd2   // print screen ... 
                dec objects+object_x
                dec objects+object_x
                dec objects+object_x
           
joystick_notleft:

            clc
            lda #JOY_UP                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notup   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                dec objects+object_y
                dec objects+object_y
                dec objects+object_y
joystick_notup:

            clc
            lda #JOY_DOWN                // mask left movement (8 == bit 4 == %0000 1000)
            bit $DC01               // bitwise "and" with joystick port 1
            bne joystick_notdown   // if not active (==1), go to .input_up_check
                // lda #$32
                // jsr $ffd2   // print screen ... 
                inc objects+object_y
                inc objects+object_y
                inc objects+object_y
joystick_notdown:



            lda #0
            sta BORDER_COLOR 


            // wait for vsync
            // not used if it is at all too slow
            // and it is always at max speed

     //       jsr vsync // wait for 'vsync'

    jsr vsync // wait for 'vsync'

            // restart
            jmp main_loop      // loopy loop
exit: 
            jsr clear_screen
            rts

            // back to BASIC


// --------------------------------------------------
// SUBROUTINES 
// --------------------------------------------------
clear_screen:
    jsr $E544       
    rts

disable_inputbuffers:
    lda #1
    sta $0289  //  disable keyboard buffer
    lda #127
    sta $028a  // disable key repeat
    rts

vsync:
      lda #$FF    // load 255 into A
      cmp $D012    //look if current rasterline equals 255
      bne vsync     // if no, goto wait
      rts  

blink:
    inc BACKGROUND_COLOR
    inc BORDER_COLOR
    inc FOREGROUND_COLOR
    rts

.macro vicbank(pattern) {
    lda $dd00
    and #%11111100
    ora #pattern
    sta $dd00
}



// --------------------------------------------------
// INTERRUPTS 
// --------------------------------------------------
irq1:
    asl $d019
    

    // inc $d020 - act. volume 
    jsr music.play 
    // dec $d020
    pla
    tay
    pla
    tax
    pla
    rti

// --------------------------------------------------
// DATA LOADING 
// --------------------------------------------------

//.if (loadPicture) {

    // vicbank(%00000011); // bank0

    *=$0c00 "ScreenRam_1"; ;            .fill picture.getScreenRamSize(), picture.getScreenRam(i)
    // color
    *=$1c00; colorRam:  .fill picture.getColorRamSize(), picture.getColorRam(i)
    // bitmap
    *=$2000;            .fill picture.getBitmapSize(), picture.getBitmap(i)

    // vicbank(%00000010); // bank1

    * = $4c00 "ScreenRam_2"; screenRam_2: .fill picturemen.getScreenRamSize(), picturemen.getScreenRam(i)
    
    // bitmap
    * = $6000 "Bitmap_2"; bitMap_2: .fill picturemen.getBitmapSize(), picturemen.getBitmap(i)
    // color ram
    * = $7f40 "ColorRam_2:"; colorRam_2: .fill picturemen.getColorRamSize(), picturemen.getColorRam(i)


// }

.if (loadMusic) { 
    * = music.location "Music"
    .fill music.size, music.getData(i)
}


// VARIABLES
// counter
counter:
  .byte $00

// levels and 
level: .byte $00
score: .byte 00


// ---------------------------------------------------
// blocks, playfield, levels
// ---------------------------------------------------

/*
    block: 16*16 (4xblocksegment)

    320x200px 
    > blocksegments 40x15* 8*8
    >> usage: 20*13 engine-blocks!

    1-20 blocks
    * 1-13 blocks

*/

// pointers

        // bitmap & block
        .var zp_block_lower   = $02 // zeropage
        .var zp_block_higher  = $03 


        .var zp_bmp_lower   = $04 // zeropage
        .var zp_bmp_higher  = $05 

        // color ram .. copy to 1+2
        .var zp_colorram_lower   = $fc // zeropage
        .var zp_colorram_higher  = $fd  

        // draw
        .var zp_draw_lower   = $fe // zeropage
        .var zp_draw_higher  = $ff 

 


// def
// blockx, blocky 
// x: 160 > 160/16 = blocksegment 16
// 

// blockline: 320x8 > 40 x 8 (byte=8px) > 20 x 16px (2segments!)

// ---------------------
// render_playfield
// ---------------------



render_playfield:


        // 0-3
        lda #0
        sta blockcounter

        // pointers

       
        // bitmap (copy to)

        lda #<$2000
        sta zp_bmp_lower
        lda #>$2000
        sta zp_bmp_higher

        lda #<$d800 // 1 color
        sta zp_draw_lower
        lda #>$d800
        sta zp_draw_higher

        lda #<$0c00 // 2 colors
        sta zp_colorram_lower
        lda #>$0c00
        sta zp_colorram_higher

        // block
        lda #<block1
        sta zp_block_lower
        lda #>block1
        sta zp_block_higher

        // "shift" now ...
        
        // not working! 

        // jmp shift_noo 
        
                    ldy #3*20+1

                    ldx #0 // count the blocks
            shiftito:
                    // add 8
                    // add 1
                    // add 1
                    lda zp_bmp_lower
                    clc
                    adc #16
                    sta zp_bmp_lower
                    bcc lowerthan256xyoa
                    inc zp_bmp_higher
            lowerthan256xyoa:        
                    lda zp_draw_lower
                    clc
                    adc #2
                    sta zp_draw_lower
                    bcc lowerthan256xyyoa
                    inc zp_draw_higher
            lowerthan256xyyoa:        
                    lda zp_colorram_lower
                    clc
                    adc #2
                    sta zp_colorram_lower
                    bcc lowerthan256xyyyoa
                    inc zp_colorram_higher
            lowerthan256xyyyoa:  
                    


                    // new line
                    // 20 > new line
                    inx
                    clc
                    cpx #19
                    bne nextlinexo
                    ldx #0

                    lda zp_bmp_lower
                    clc
                    inc zp_bmp_higher // 320 = 256+64
                    clc
                    adc #64
                    sta zp_bmp_lower
                    bcc lowerthan256xyto
                    inc zp_bmp_higher        
            lowerthan256xyto:
                    lda zp_draw_lower
                    clc
                    adc #40
                    sta zp_draw_lower
                    bcc lowerthan256xytxo
                    inc zp_draw_higher        
            lowerthan256xytxo:
                    lda zp_colorram_lower
                    clc
                    adc #40
                    sta zp_colorram_lower
                    bcc lowerthan256xytxto
                    inc zp_colorram_higher        
            lowerthan256xytxto:


            nextlinexo:        

                    // shift again?
                    clc 
                    dey
                    cpy #0
                    bne shiftito        

            shift_noo:
            


        lda #0
        sta playfield_counter

        // ------------------------
        // copy playfield 
        // ------------------------


playfield_loop:

        
        // save positions
        lda zp_bmp_lower
        sta bmp_pointer_low    
        lda zp_bmp_higher
        sta bmp_pointer_high   
    

        // ------------------------
        // copy block 
        // ------------------------


        // get starting point now ...

copy_blockso:

        // copy one block and only one!!!
        // 8x8 = 4x8pixel in multicolor

        ldy #0 // pointer 

        // copy a block (8x8pixels = 8bytes)
copy_blocksegmento:

        lda (zp_block_lower),y
        sta (zp_bmp_lower),y
        
        iny
       
        clc
        cpy #8
        bne copy_blocksegmento 
// ^         
        // reset
        ldy #0

        // set colors ... 
        ldx #0
        lda #%00000001 // 11
        sta (zp_draw_lower),y
        sta $d800
        lda #%00111011 // 01 + 10 
        sta (zp_colorram_lower),y
        sta $0c00

        // go forward bmp
        // add 8
        lda zp_bmp_lower
        clc
        adc #8
        sta zp_bmp_lower
        lda zp_draw_lower
        clc
        adc #1
        sta zp_draw_lower
        lda zp_colorram_lower
        clc
        adc #1
        sta zp_colorram_lower

        // go forward block
        lda zp_block_lower
        clc
        adc #11
        sta zp_block_lower
        
        // next line
        lda blockcounter
        clc
        cmp #1
        bne nextlineo
        clc
        inc zp_bmp_higher // + 255
        clc
        lda zp_bmp_lower
        clc
        adc #48
        sta zp_bmp_lower
        bcc lowerthan256o
        inc zp_bmp_higher
lowerthan256o:
        // go forward
        // go forward
        lda zp_draw_lower
        clc
        adc #38
        sta zp_draw_lower  
        bcc lowerthan256xo
        inc zp_draw_higher
lowerthan256xo:
        lda zp_colorram_lower
        clc
        adc #38
        sta zp_colorram_lower        
bcc lowerthan256xxo
        inc zp_colorram_higher
lowerthan256xxo:

nextlineo:


        // block copy
        inc blockcounter
        lda blockcounter
        clc
        cmp #4
        beq copyendo
        jmp copy_blockso
copyendo:

// - ^
        
        // load positions
        lda bmp_pointer_low
        sta zp_bmp_lower    
        lda bmp_pointer_high
        sta zp_bmp_higher

        // go forward in memory
                // add 8
                // add 1
                // add 1
                lda zp_bmp_lower
                clc
                adc #16
                sta zp_bmp_lower
                bcc lowerthan256xyo
                inc zp_bmp_higher
        lowerthan256xyo:       
        /* 
                lda zp_draw_lower
                clc
                adc #2
                sta zp_draw_lower
                bcc lowerthan256xyyo
                inc zp_draw_higher
        lowerthan256xyyo:        
                lda zp_colorram_lower
                clc
                adc #2
                sta zp_colorram_lower
                bcc lowerthan256xyyyo
                inc zp_colorram_higher
        lowerthan256xyyyo:  
        */

        // save positions
        lda zp_bmp_lower
        sta bmp_pointer_low    
        lda zp_bmp_higher
        sta bmp_pointer_high   

// jmp playfield_loop

        // show all
        inc playfield_counter
        lda playfield_counter
        clc
        cmp #40
        bne stopplayfield
        jmp playfield_loop
stopplayfield: 

// --- ^ playfield loop


        rts 

// ---------------------------------------------------------
// render_block
// ---------------------

       

render_block:
        
        
        // 0-3
        lda #0
        sta blockcounter

        // pointers

       
        // bitmap (copy to)

        lda #<$2000
        sta zp_bmp_lower
        lda #>$2000
        sta zp_bmp_higher

        lda #<$d800 // 1 color
        sta zp_draw_lower
        lda #>$d800
        sta zp_draw_higher

        lda #<$0c00 // 2 colors
        sta zp_colorram_lower
        lda #>$0c00
        sta zp_colorram_higher

        // block
        lda #<block1
        sta zp_block_lower
        lda #>block1
        sta zp_block_higher

        // "shift" now ...

        // jmp shift_no 

        ldy #10*20+13

        ldx #0 // count the blocks
shiftit:
        // add 8
        // add 1
        // add 1
        lda zp_bmp_lower
        clc
        adc #16
        sta zp_bmp_lower
        bcc lowerthan256xy
        inc zp_bmp_higher
lowerthan256xy:        
        lda zp_draw_lower
        clc
        adc #2
        sta zp_draw_lower
        bcc lowerthan256xyy
        inc zp_draw_higher
lowerthan256xyy:        
        lda zp_colorram_lower
        clc
        adc #2
        sta zp_colorram_lower
        bcc lowerthan256xyyy
        inc zp_colorram_higher
lowerthan256xyyy:  
        


        // new line
        // 20 > new line
        inx
        clc
        cpx #19
        bne nextlinex
        ldx #0

        lda zp_bmp_lower
        clc
        inc zp_bmp_higher // 320 = 256+64
        clc
        adc #64
        sta zp_bmp_lower
        bcc lowerthan256xyt
        inc zp_bmp_higher        
lowerthan256xyt:
        lda zp_draw_lower
        clc
        adc #40
        sta zp_draw_lower
        bcc lowerthan256xytx
        inc zp_draw_higher        
lowerthan256xytx:
        lda zp_colorram_lower
        clc
        adc #40
        sta zp_colorram_lower
        bcc lowerthan256xytxt
        inc zp_colorram_higher        
lowerthan256xytxt:


nextlinex:        

        // shift again?
        clc 
        dey
        cpy #0
        bne shiftit        

shift_no:


        // ------------------------
        // copy now 
        // ------------------------


        // get starting point now ...

copy_blocks:

        // copy one block and only one!!!
        // 8x8 = 4x8pixel in multicolor

        ldy #0 // pointer 

        // copy a block (8x8pixels = 8bytes)
copy_blocksegment:

        lda (zp_block_lower),y
        sta (zp_bmp_lower),y
        
        iny
       
        clc
        cpy #8
        bne copy_blocksegment 
// ^         
        // reset
        ldy #0

        // set colors ... 
        ldx #0
        lda #%00000001 // 11
        sta (zp_draw_lower),y
        sta $d800
        lda #%00111011 // 01 + 10 
        sta (zp_colorram_lower),y
        sta $0c00

        // go forward bmp
        // add 8
        lda zp_bmp_lower
        clc
        adc #8
        sta zp_bmp_lower
        lda zp_draw_lower
        clc
        adc #1
        sta zp_draw_lower
        lda zp_colorram_lower
        clc
        adc #1
        sta zp_colorram_lower

        // go forward block
        lda zp_block_lower
        clc
        adc #11
        sta zp_block_lower
        
        // next line
        lda blockcounter
        clc
        cmp #1
        bne nextline
        clc
        inc zp_bmp_higher // + 255
        clc
        lda zp_bmp_lower
        clc
        adc #48
        sta zp_bmp_lower
        bcc lowerthan256
        inc zp_bmp_higher
lowerthan256:
        // go forward
        // go forward
        lda zp_draw_lower
        clc
        adc #38
        sta zp_draw_lower  
        bcc lowerthan256x
        inc zp_draw_higher
lowerthan256x:
        lda zp_colorram_lower
        clc
        adc #38
        sta zp_colorram_lower        
bcc lowerthan256xx
        inc zp_colorram_higher
lowerthan256xx:

nextline:


        // block copy
        inc blockcounter
        lda blockcounter
        clc
        cmp #4
        beq copyend
        jmp copy_blocks
copyend:

// - ^

        rts

/*

        // painting 
        ldy #3
        lda #%00000001 // 11
        sta $d800,y
        lda #%00011010 // 01 + 10 
        sta $0c00,y
      
        // painting 
        ldy #4
        lda #%00000011 // 11
        sta $d800,y
        lda #%00100001 // 01 + 10 
        sta $0c00,y
*/


// ---------------------------------------------------
// print_number
// ---------------------------------------------------

print_valnumber: .byte $00 // single

print_x: .byte $00
print_y: .byte $00 // * not yet num ... 

// temp
print_valtemp: .byte $00 // single
print_val: .byte $00 // single
print_val10: .byte $00
print_val100: .byte $00

// print number (1203)
print_number:
        // load valnumber
        lda print_valnumber
        sta print_valtemp

        lda #0
        sta print_val100

        // go down 
        lda print_valtemp
step10:  
        clc
        cmp #10
        bcs less10
        sta print_val10
        // dec print_x
        jmp step10end
less10:
        clc
        sbc #10
        inc print_val100
        sta print_valtemp       
        jmp step10

step10end:

        // display now
        // 10s

        lda print_val10
        sta print_val
        jsr print_num

        dec print_x
        lda print_val100
        sta print_val
        jsr print_num


        rts

// print only number
print_num: 

        
        lda print_x

        tay    // y: for y=0 ...

        //colors 1+2
        // lda #%00111010 // 00 + 2 colors .. 
        lda #%00000001
        sta $0400,y

        // draw color  - default white 001
        // lda #%00110001 // 2 colors
        lda #%00000001 // 2 colors ( xyz also changine!  - 001)
        sta $d800,y 


        ldx #0 // x: position x*8

goright:    
        dey

        inx
        inx
        inx
        inx
        inx
        inx
        inx
        inx

        clc
        cpy #0
        bne goright
        


        // lda
        lda print_val

        // display here .. 
        ldy #0  // chars + ypos

        clc
        cmp #1
        bne n1
        ldy #8
n1:
        clc
        cmp #2
        bne n2
        ldy #16
n2:
        clc
        cmp #3
        bne n3
        ldy #24
n3:
        clc
        cmp #4
        bne n4
        ldy #32
n4:
        clc
        cmp #5
        bne n5
        ldy #40
n5:
        clc
        cmp #6
        bne n6
        ldy #48
n6:
        clc
        cmp #7
        bne n7
        ldy #56
n7:
        clc
        cmp #8
        bne n8
        ldy #64
n8:
        clc
        cmp #9
        bne n9
        ldy #72
n9:


        // load it
        lda chars,y
        sta $2000,x
        inx
        iny

        lda chars,y
        sta $2000,x
        inx
        iny

        lda chars,y
        sta $2000,x
        inx
        iny

        lda chars,y
        sta $2000,x
        inx
        iny

        lda chars,y
        sta $2000,x
        inx
        iny

        lda chars,y
        sta $2000,x
        inx
        iny

        lda chars,y
        sta $2000,x
        inx
        iny

        lda chars,y
        sta $2000,x
        inx
        iny
        


        rts 

chars:


char_0: 
        .byte %00111100
        .byte %11001100 
        .byte %11001100 
        .byte %11001100 
        .byte %11001100 
        .byte %11001100 
        .byte %11001100 
        .byte %11111100

char_1: 


        .byte %10111110
        .byte %10011110 
        .byte %10010010 
        .byte %11111111 
        .byte %10011110 
        .byte %00011110 
        .byte %00011110 
        .byte %01011110



        // .byte 171,91,27,27,27,27,27,27
        // .byte 12,60,240,60,255,60,60,60
//        .byte 127,1,151,151,254,151,151,169
        // BYTE 127,151,151,151,151,151,151,169
/*
        .byte %00111100
        .byte %00011100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100
 */
      
char_2: .byte %11111100
        .byte %11111100
        .byte %00001100 
        .byte %11111100 
        .byte %11000000 
        .byte %11000000 
        .byte %11000000 
        .byte %11111100

char_3: .byte %11111100
        .byte %11111100
        .byte %00001100 
        .byte %00001100 
        .byte %00111100 
        .byte %00001100 
        .byte %00001100 
        .byte %11111100 

char_4: .byte %11000000
        .byte %11000000
        .byte %11001100 
        .byte %11111100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 

char_5: .byte %11111100
        .byte %11111100
        .byte %11000000
        .byte %11001100 
        .byte %11111100 
        .byte %00001100 
        .byte %00001100 
        .byte %11111100 

char_6: .byte %11000000
        .byte %11000000 
        .byte %11000000 
        .byte %11000000 
        .byte %11111100 
        .byte %11001100 
        .byte %11001100 
        .byte %11111100

char_7: .byte %11111100
        .byte %11111100
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100         

char_8: .byte %00111100
        .byte %11001100 
        .byte %11001100 
        .byte %11001100 
        .byte %11111100 
        .byte %11001100 
        .byte %11001100 
        .byte %11111100

char_9: .byte %11111100
        .byte %11001100 
        .byte %11001100 
        .byte %11001100 
        .byte %11111100 
        .byte %00001100 
        .byte %00001100 
        .byte %00001100

    // --------------------------------------------------
    // VARS ... 
    // --------------------------------------------------

mcounter: .byte $00

rcounter: .byte $00

spritenr: .byte $00

temp: .byte $00

counterx: .byte $00
countery: .byte $00

playfield_counter: .byte 00

bmp_pointer_low: .byte 00
bmp_pointer_high: .byte 00

// input
block_x: .byte 0
block_y: .byte 0
block_no: .byte 0

// intern
blocksegment: .byte 0 // 8 y pixel?

blockcounter: .byte 0 // 8 y pixel?
blocksegmentcounter: .byte 0



    // --------------------------------------------------
    // OBJECTS ... 
    // --------------------------------------------------

/*

    // look for constants
    object_x
    object_y

    
*/
    // object_x depends on engine_mode ! 
    //          default 0: _x : 1/1
    //          mode 1: _x *2 + _x+1 

    objects: 
  
      // object 0-7
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 0
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 1
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 2
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 3
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 4
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 5
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 6
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 // 7

      // 8+
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00



// --------------------------------------------------
// MACROS 
// --------------------------------------------------
.macro rndGen(mask) {
    // see http://sta.c64.org/cbm64mem.html
    // first we read the current raster line (0-255)
    lda $d012
    // then we xor it with timer A (low byte)
    // see https://www.c64-wiki.com/wiki/CIA
    eor $dc04
    // then we subtract it with timer A (high byte)
    clc
    sbc $dc05
    // finally we mask it so we can have a number between 0 and bits^2
    and #mask
}

.function toSpritePtr(addr) {
   .return (addr&$3FFF)/64
}

// single color
spritePtrs:
.byte toSpritePtr(sprite_avatar), toSpritePtr(sprite_eat)
.byte toSpritePtr(sprite_eat), toSpritePtr(sprite_eat)
.byte toSpritePtr(sprite_enemy), toSpritePtr(sprite_enemy)
.byte toSpritePtr(sprite_enemy), toSpritePtr(sprite_enemy)

// you can use http://spritemate.com/ to edit these
// just press file->save file->kick ass(hex) once you designed your sprite


// be carefull with the address you chose for your sprites. two notes:
// 1. it needs to be divisible by 64 - see above - you can use the .align 64 if it helps
// 2. it needs to be in the same video block where you want to display them
//    the c64 has four video blocks $0000-$3fff, $4000-$7fff, $8000-$bfff, $c000-$ffff

// ! SINGLE COLORS SPRITES
// $b60
* = $b60-32 "Sprites"; // address $b60 means that this sprites can only be used with the screen on block $0000-$3fff

all_sprites:

.align 64
// memory for sprite patterns needs to be divisible by 64 - see above why




// sprite 0 / singlecolor / color: $01

sprite_avatar:
/*
.byte $00,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$7f,$0f,$fc,$7f,$0f,$fc,$7f
.byte $0f,$fc,$7f,$0f,$04,$7f,$ff,$04
.byte $7f,$ff,$04,$7f,$ff,$04,$47,$ff
.byte $04,$47,$ff,$04,$47,$ff,$fc,$47
.byte $07,$fc,$47,$07,$fc,$7f,$07,$fc
.byte $7f,$07,$fc,$7f,$07,$fc,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01
*/

.byte $00,$00,$00,$2a,$aa,$a8,$3f,$ff
.byte $f8,$3a,$aa,$b8,$ba,$aa,$b8,$ba
.byte $aa,$b8,$ba,$aa,$b8,$ba,$aa,$b8
.byte $ba,$aa,$b8,$ba,$aa,$b8,$ba,$aa
.byte $b8,$ba,$aa,$b8,$ba,$aa,$b8,$ba
.byte $aa,$b8,$ba,$aa,$b8,$ba,$aa,$b8
.byte $ba,$aa,$b8,$ba,$aa,$b8,$ba,$aa
.byte $b8,$bf,$ff,$e8,$aa,$aa,$a0,$81

sprite_eat:

/*
.byte $00,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01
*/

/*
.byte $00,$00,$00,$00,$00,$00,$00,$00
.byte $00,$01,$6a,$80,$03,$ea,$80,$03
.byte $ea,$80,$01,$7e,$c0,$03,$ea,$80
.byte $01,$7e,$c0,$03,$ea,$80,$01,$7e
.byte $c0,$03,$ea,$80,$01,$7e,$c0,$03
.byte $ea,$80,$01,$7e,$c0,$03,$ea,$80
.byte $03,$ea,$80,$01,$69,$40,$00,$00
.byte $00,$00,$00,$00,$00,$00,$00,$81
*/

.byte $00,$00,$00,$2a,$aa,$a8,$2a,$aa
.byte $a8,$2a,$aa,$a8,$2a,$aa,$a8,$2a
.byte $aa,$a8,$2a,$aa,$a8,$2a,$00,$a8
.byte $2a,$00,$a8,$2a,$00,$a8,$2a,$00
.byte $a8,$2a,$00,$a8,$2a,$00,$a8,$2a
.byte $00,$a8,$2a,$aa,$a8,$2a,$aa,$a8
.byte $2a,$aa,$a8,$2a,$aa,$a8,$2a,$aa
.byte $a8,$2a,$aa,$a8,$00,$00,$00,$8f

sprite_enemy:

/*
.byte $00,$00,$00,$7f,$ff,$fc,$7f,$0f
.byte $fc,$61,$08,$1c,$61,$08,$1c,$61
.byte $09,$fc,$61,$09,$04,$61,$f9,$04
.byte $60,$01,$04,$7c,$01,$04,$44,$01
.byte $04,$44,$01,$04,$45,$fd,$fc,$45
.byte $04,$0c,$45,$04,$0c,$7d,$04,$0c
.byte $61,$04,$0c,$61,$04,$04,$7f,$07
.byte $fc,$7f,$ff,$fc,$00,$00,$00,$01
*/


.byte $09,$24,$24,$a9,$96,$94,$a9,$96
.byte $94,$2b,$be,$bd,$2b,$be,$be,$2b
.byte $be,$bc,$2b,$be,$bc,$2b,$be,$bc
.byte $ab,$be,$bd,$2b,$be,$be,$2b,$be
.byte $bc,$2b,$be,$bc,$ab,$be,$bd,$ab
.byte $be,$be,$2b,$be,$bc,$2b,$be,$bc
.byte $2b,$be,$bd,$ab,$be,$be,$aa,$aa
.byte $a8,$2a,$aa,$a8,$0a,$02,$08,$81



// -----------------------------
// levels & blocks
// -----------------------------
*=$1000

// levels
levels:

// block: 16x16 pixels - 2x2 screenblocks
// levels here 20x13 

level0:
        .byte 0,1,2,3,4,0,1,2,3,4, 0,0,0,0,0,0,0,0,0,0
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,1
        .byte 1,1,1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,1,1
       
        .byte 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0


// block (playfield)
// block: 4 blocksegments
//        blocksegment: data for multicolor 8x4 + 3 colors 
// 1 2
// 3 4 
//
// blocksegment-size: 8+3 = 11 
// blocksize: 4*11
/*
        // 1. block segment        
        .byte 85,191,165,165,165,165,165,165
        // () text/char color, multi 1, multi 2
        .byte 5,13,7
*/


// > use https://petscii.krissz.hu
// chars - select one > bytes are down in the info > copy them to your project
// or export  [>]
// colors export code 


blocks: 

block0: // grass
        .byte 0,3,32,28,60,12,0,192
        .byte 5,13,7

        .byte 3,3,192,4,4,0,12,204
        .byte 5,13,7

        .byte 67,67,0,32,16,12,48,48
        .byte 5,13,7

        .byte 204,204,64,0,8,12,3,3
        .byte 5,13,7

// *=$4000
block1: // stone

        // 1. block segment        
        .byte 85,191,165,165,165,165,165,165
        // background, char color, multi 1, multi 2
        .byte 1,12,11

        // 2. block segment
        .byte 85,253,93,93,93,93,93,93
        .byte 1,12,11
        
        // 3. block segment
        .byte 165,165,165,165,165,165,170,170
        .byte 1,12,11
        
        // 4. block segment
        .byte 93,93,93,93,93,93,169,169
        .byte 1,12,11




