
*=$c000
               lda #$00           // Rahmen und Hintergrund schwarz.
               sta $d020
               sta $d021

               jsr init_sprites   // Sprites initialisieren.

               sei                // Interrupt unterdrücken, da der
                                  // beim Timing stört und ein
                                  // gelegentliches Flackern
                                  // verursachen würde.

busy_wait:      lda $D012          // Auf Rasterzeile warten, bei der
               cmp next          // alle acht Sprites angezeigt
               bne busy_wait      // wurden.

               ldy #00            // Y-Koordinaten aller Sprites um
adfx:              lda $D001,y        // 32 erhöhen, damit diese erneut
               clc                // angezeigt werden.
               adc #32
               sta $D001,y
               iny
               iny
               cpy #16
               bne adfx

               lda next          // Rasterzeile, auf die gewartet
               clc                // wird, ebenfalls um 32 erhöhen.
               adc #32
               sta <next

               jmp busy_wait

next:          .byte 78           // Nächste Rasterzeile, s.o.


init_sprites:  lda #$C3           // Aussehen des Sprites definieren.
               ldy #63            // Der Einfachheit halber, sind es
ba:              sta 832,y          // hier nur senkrechte Streifen.
               dey
               bpl ba

               lda #13            // Alle Spritedatenzeiger auf
               ldy #7             // Block 832 zeigen lassen.
bb:              sta 2040,y
               dey
               bpl bb

               lda #24            // X-Koordinaten der acht Sprites
               ldy #00            // festlegen. Das erste ist am linken
bc:              sta $D000,y        // Rand, jedes weitere um 32 Pixel
               clc                // nach rechts versetzt.
               adc #32
               iny
               iny
               cpy #16
               bne bc

               lda #50            // Y-Koordinaten der acht obersten
               ldy #00            // Sprites festlegen. Diese sind
bd:             sta $D001,y        // jeweils um ein Pixel nach unten
               clc                // verschoben.
               adc #01
               iny
               iny
               cpy #16
               bne bd

               lda #$ff           // Alle acht Sprites anschalten.
               sta $D015

               rts